#ifndef _SHARED_H_
#define _SHARED_H_

#include "zlib.h"

#ifdef __ZODIAC__
#include "TapWave.h"
#define LSB_FIRST

#define GENZ_TURBOFSKIP 15
#define GENZ_ROMSDIR "0:/PALM/Programs/LJZ/GENZ/Roms/"
#define GENZ_SAVESDIR "0:/PALM/Programs/LJZ/GENZ/Saves/"
#define AUTO_FSKIP 10
#define SKEEZIX_FSKIP 11

#define MAX_FRAME_SKIPPED 10


#endif


#include <stdio.h>
#include <math.h>


#include "types.h"
#include "macros.h"


#include "cyclone.h"
#include "m68k.h"
#include "z80.h"
#include "genesis.h"
#include "vdp.h"
#include "render.h"
#include "mem68k.h"
#include "memz80.h"
#include "membnk.h"
#include "memvdp.h"
#include "system.h"
#include "unzip.h"
#include "fileio.h"
#include "loadrom.h"
#include "io.h"
#include "sound.h"
#include "fm.h"
#include "sn76496.h"
#include "osd.h"

#include "ljz_std.h"

extern struct Cyclone CycloneCPU;
extern int32 total_cycles;
extern uint32 rom_size;
extern uint8 emul_z80;

extern unsigned char *saveram; // The actual saveram buffer
extern unsigned save_start, save_len; // Start address and length
extern int save_prot, save_active; // Flags set from $A130F1
extern int genZ_cpu_cyclone;
extern int32 genZ_frameTime,genZ_framecount,genZ_specialfskip;

#endif /* _SHARED_H_ */

