#include <TapWave.h>

#include "LJZmenu.h"

int menu_confirm(char *message)
{
	RectangleType ryes,rno;
	int x,y;
	menu_message(message);
	menu_button (240-43-60,200,"Yes",2,&ryes,1);
	menu_button (240-43+60,200,"No",2,&rno,1);
	
	for (;;)
	{
		menu_waitPen(&x,&y,1);
		if (TEST_PEN_MENU(x,y,ryes)) return 1;
		if (TEST_PEN_MENU(x,y,rno)) return 0;
	}
}

void menu_messageRaw(int X,int Y,char *message)
{
	RGBColorType fg;	
	RectangleType rect;	
	int width;	
	
	WinPushDrawState();
	WinSetCoordinateSystem(kCoordinatesNative);
    FntSetFont(boldFont);
    
    width=FntCharsWidth(message,StrLen(message));        
	WinSetDrawMode(winOverlay);
    fg.r=220;fg.g=180;fg.b=40;
    WinSetTextColorRGB(&fg,NULL);    
	WinPaintChars(message,StrLen(message),X,Y);
	
	WinPopDrawState();
}


int menu_getTick(void)
{
	long long l;
	l=TimGetTicks();		
	return l*1000/SysTicksPerSecond();
}
void menu_wait(int ms)
{
	int start=menu_getTick();
	while (menu_getTick()-start<ms) ;
}

void menu_message(char *message)
{
	RGBColorType fg;	
	RectangleType rect;	
	Int16 width,j;	
	Boolean notruncated;
	char *p;
	
	notruncated=1;
	p=message;
	j=StrLen(p);
	
	
	WinPushDrawState();
	WinSetCoordinateSystem(kCoordinatesNative);
    WinSetDrawMode(winPaint);
    FntSetFont(boldFont);
    
    width=FntCharsWidth(message,StrLen(message));
    
    if (width>400)
    {
	    width=400;
		FntCharsInWidth(message,&width,&j,&notruncated);
		if (!notruncated)
		{
			p=(char*)ljz_malloc(j);
			memmove(p,message,j);
			p[j]=0;
			p[j-1]='.';p[j-2]='.';p[j-3]='.';
		}
	}
    
   	fg.r=250>>1;fg.g=250>>1;fg.b=250>>1;
    WinSetForeColorRGB(&fg,NULL);                
    rect.topLeft.x=240-width/2-5;
    rect.topLeft.y=160-FntBaseLine()/2-7;
    rect.extent.x=width+10;
    rect.extent.y=FntBaseLine()+15;
    WinPaintRectangle(&rect,8);
    fg.r=250;fg.g=250;fg.b=250;  
    WinSetForeColorRGB(&fg,NULL);
    rect.topLeft.x=240-width/2-5+1;
    rect.topLeft.y=160-FntBaseLine()/2-7+1;
    rect.extent.x=width+10-2;
    rect.extent.y=FntBaseLine()+15-2;
    WinPaintRectangle(&rect,8);		
    
	WinSetDrawMode(winOverlay);
    fg.r=220;fg.g=180;fg.b=40;
    WinSetTextColorRGB(&fg,NULL);    
	WinPaintChars(p,j,240-width/2,160-1-FntBaseLine()/2);
	
	
	if (!notruncated) ljz_free(p);
	
	WinPopDrawState();
}
void menu_button (int X,int Y,char *message,int state,RectangleType *area,int size)
{	
	RGBColorType fg;
	RectangleType rect;
	int width;	
	
	WinPushDrawState();
	WinSetCoordinateSystem(kCoordinatesNative);
    WinSetDrawMode(winPaint);
    
    switch (size)
	{	
		case 2:width=130;break;			
		case 1:width=80;break;
		case 0:width=40;break;				
		case 3:width=30;break;				
		case 4:width=FntCharsWidth(message,StrLen(message))+12;break;				
	}	
    
    switch (state)
    {
    	case 0:fg.r=200>>1;fg.g=130>>1;fg.b=150>>1;break;
    	case 1:fg.r=128>>1;fg.g=80>>1;fg.b=0;break;
    	case 2:fg.r=255>>1;fg.g=140>>1;fg.b=0;break;
    	case 3:fg.r=80>>1;fg.g=80>>1;fg.b=80>>1;break;
    	case 4:fg.r=160>>1;fg.g=120>>1;fg.b=205>>1;break;
    	case 5:fg.r=240>>1;fg.g=50>>1;fg.b=45>>1;break;
    	case 6:fg.r=35>>1;fg.g=210>>1;fg.b=15>>1;break;
    	case 7:fg.r=220>>1;fg.g=80>>1;fg.b=80>>1;break;
    	case 8:fg.r=30>>1;fg.g=20>>1;fg.b=220>>1;break;
    	case 9:fg.r=255>>1;fg.g=240>>1;fg.b=220>>1;break;
    }
    WinSetForeColorRGB(&fg,NULL);
                
    rect.topLeft.x=X;
    rect.topLeft.y=Y;
    rect.extent.x=/*FntCharsWidth(message,strlen(message))*/width+6;
    rect.extent.y=FntBaseLine()+12;
    if (area) *area=rect;
    WinPaintRectangle(&rect,8);
     switch (state)
    {
    	case 0:fg.r=170;fg.g=100;fg.b=140;break;
    	case 1:fg.r=128;fg.g=80;fg.b=0;break;
    	case 2:fg.r=255;fg.g=140;fg.b=0;break;
    	case 3:fg.r=80;fg.g=80;fg.b=80;break;
    	case 4:fg.r=160;fg.g=120;fg.b=205;break;
    	case 5:fg.r=240;fg.g=50;fg.b=45;break;
    	case 6:fg.r=35;fg.g=210;fg.b=15;break;
    	case 7:fg.r=220;fg.g=80;fg.b=80;break;
    	case 8:fg.r=30;fg.g=20;fg.b=220;break;
    	case 9:fg.r=255;fg.g=240;fg.b=220;break;
    }
    WinSetForeColorRGB(&fg,NULL);
    rect.topLeft.x=X+1;
    rect.topLeft.y=Y+1;
    rect.extent.x=/*FntCharsWidth(message,strlen(message))*/width+6-2;
    rect.extent.y=FntBaseLine()+12-2;
    WinPaintRectangle(&rect,8);
		  
    WinSetDrawMode(winOverlay);
    switch (state)
    {    	
    	case 1:
    	case 2:
    	case 3:
    	case 5:
    	case 9:
	    fg.r=32;fg.g=32;fg.b=64;
	    break;
	    case 0:
	    case 4:
	    case 6:
	    case 7:
	    case 8:
	    
	    fg.r=255;fg.g=255;fg.b=255;
	    break;
	}
    WinSetTextColorRGB(&fg,NULL);
	WinPaintChars(message,strlen(message),X+(width+6-FntCharsWidth(message,strlen(message)))/2,Y+4);
	
	WinPopDrawState();
	
//	if (pause) fgbZ_pause();
}

void menu_bar(int X,int Y,int val,int max,RectangleType *area)
{
	RGBColorType fg;
	RectangleType rect;
	int width;	
	
	WinPushDrawState();
	WinSetCoordinateSystem(kCoordinatesNative);
    WinSetDrawMode(winPaint);
    
   	fg.r=255>>1;fg.g=250>>1;fg.b=245>>1;   
    WinSetForeColorRGB(&fg,NULL);
    rect.topLeft.x=X;
    rect.topLeft.y=Y+10-3;
    rect.extent.x=100+5;
    rect.extent.y=5;
    WinPaintRectangle(&rect,0);
    
    fg.r=255;fg.g=250;fg.b=245;   
    WinSetForeColorRGB(&fg,NULL);
    rect.topLeft.x=X+1;
    rect.topLeft.y=Y+10-3+1;
    rect.extent.x=100+5-2;
    rect.extent.y=5-2;
    WinPaintRectangle(&rect,0);
    
    fg.r=250>>1;fg.g=200>>1;fg.b=255>>1;
    WinSetForeColorRGB(&fg,NULL);
    rect.topLeft.x=X+val*100/max;
    rect.topLeft.y=Y-1;
    rect.extent.x=8;
    rect.extent.y=21;
    WinPaintRectangle(&rect,8);
    
    fg.r=250;fg.g=200;fg.b=255;   
    WinSetForeColorRGB(&fg,NULL);
    rect.topLeft.x=X+val*100/max+1;
    rect.topLeft.y=Y;
    rect.extent.x=8-2;
    rect.extent.y=21-2;
    WinPaintRectangle(&rect,8);
    
    rect.topLeft.x=X;    
    rect.topLeft.y=Y;
    rect.extent.x=100+5;
    rect.extent.y=21;
    if (area) 
    {

    	if (rect.topLeft.x>=10) rect.topLeft.x-=10;
    	else rect.topLeft.x=0;
		rect.extent.x+=20;
    	*area=rect;
	}    
	WinPopDrawState();

}

void menu_waitPen(int *X,int *Y,int wait_release)
{
	TwInputHandle mInputQueue;
	Int32 inputFormats[] = { twInputPenX,twInputPenY,twInputPenZ };
	typedef struct {Int32 mPenX;Int32 mPenY;Int32 mPenZ;} ZUserEvent;
	ZUserEvent mUserEvent;
	Int32* mInputFormat;    
    
   	TwInputOpen(&mInputQueue, "twinput", "r");
   	mInputFormat = (Int32*)ljz_malloc(sizeof(Int32)*sizeof(inputFormats)/sizeof(inputFormats[0]));
       memmove(mInputFormat, inputFormats, sizeof(inputFormats));
   	TwInputSetFormat(mInputQueue, mInputFormat, sizeof(inputFormats));
   	TwInputActivate(mInputQueue);
   	
   	if (wait_release==3)
   	{
		TwInputPoll(mInputQueue, (Int32 *) &mUserEvent, sizeof(mUserEvent));
		if (X) *X=mUserEvent.mPenX;
		if (Y) *Y=mUserEvent.mPenY;	
		
		ljz_free(mInputFormat);	    
	    TwInputClose(mInputQueue);
		return;
   	}

    if (wait_release)
	do{
   		TwInputPoll(mInputQueue, (Int32 *) &mUserEvent, sizeof(mUserEvent));
    } while (mUserEvent.mPenZ);
    
    if (wait_release==2) 
    {
	    ljz_free(mInputFormat);	    
    	TwInputClose(mInputQueue);
    	return;
    }
    
	do{
    	TwInputPoll(mInputQueue, (Int32 *) &mUserEvent, sizeof(mUserEvent));
	} while (!(mUserEvent.mPenZ));
	if (X) *X=mUserEvent.mPenX;
	if (Y) *Y=mUserEvent.mPenY;	
	if (wait_release)
    do{
   		TwInputPoll(mInputQueue, (Int32 *) &mUserEvent, sizeof(mUserEvent));
    } while (mUserEvent.mPenZ);
    ljz_free(mInputFormat);	    
    TwInputClose(mInputQueue);
}
