//---------------------------------------------------------------------------
// NEOPOP : Emulator as in Dreamland
//
// Copyright (c) 2001-2002 by neopop_uk
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version. See also the license.txt file for
//	additional informations.
//---------------------------------------------------------------------------

/*
//---------------------------------------------------------------------------
//=========================================================================

	system_input.c

//=========================================================================
//---------------------------------------------------------------------------

  History of changes:
  ===================

*/

#include "neopop.h"

#include "system_main.h"


//=============================================================================

//I/O state
static _u8 up,down,left,right,button_a,button_b,option;


//=============================================================================


extern _u32 neopopZ_padState;
extern _u32 neopopZ_fastforward;
extern _s32 neopopZ_frameBeginTime,neopopZ_frameTime,neopopZ_speedpct;
extern _s32 neopopZ_autofireA,neopopZ_autofireB;
extern _s32 neopopZ_framecount;

//-----------------------------------------------------------------------------
// system_input_update()
//-----------------------------------------------------------------------------
void system_input_update(void)
{
	//Clear the controller status
	up = down = left = right = button_a = button_b = option = 0;

    if (neopopZ_padState&KEY_A)
	 switch (neopopZ_autofireA)
	 {
  		case 0:button_a=1; break;
  		case 1:
  	  		if ((neopopZ_framecount&31)>15) button_a=1;
  	  		break;
  		case 2:
  	  		if ((neopopZ_framecount&15)>7) button_a=1;
  	  		break;
  		case 3:
  	  		if ((neopopZ_framecount&7)>3) button_a=1;
  	  		break;  		   
  	 }
  	 
  	if (neopopZ_padState&KEY_B)
	 switch (neopopZ_autofireB)
	 {
  		case 0:button_b=1; break;
  		case 1:
  	  		if ((neopopZ_framecount&31)>15) button_b=1;
  	  		break;
  		case 2:
  	  		if ((neopopZ_framecount&15)>7) button_b=1;
  	  		break;
  		case 3:
  	  		if ((neopopZ_framecount&7)>3) button_b=1;
  	  		break;  		   
  	 }
    
    
    if (neopopZ_padState&KEY_UP) up=1;
    if (neopopZ_padState&KEY_DOWN) down=1;
    if (neopopZ_padState&KEY_LEFT) left=1;
    if (neopopZ_padState&KEY_RIGHT) right=1;
	if (neopopZ_padState&KEY_START) option=1;

	//Write the controller status to memory
	ram[0x6F82] = up | (down << 1) | (left << 2) | (right << 3) | 
		(button_a << 4) | (button_b << 5) | (option << 6);
		
	if (neopopZ_padState&KEY_TURBO)
	{		
		neopopZ_fastforward=1;		
	}
	else 
	if (neopopZ_fastforward)
	{
		neopopZ_fastforward=0;
		neopopZ_frameBeginTime=neopopZ_getTickCount()+neopopZ_frameTime*100/neopopZ_speedpct;
	}
	
	if (neopopZ_padState&KEY_QUICKLOAD)
	{
		if (!state_load(0,1))
		{
			if (menu_confirm("Load state ?")) state_load(0,0);
			neopopZ_frameBeginTime=neopopZ_getTickCount()+neopopZ_frameTime*100/neopopZ_speedpct;
		}
	}
	if (neopopZ_padState&KEY_QUICKSAVE)
	{
		if (menu_confirm("Save state ?")) state_save(0);
			neopopZ_frameBeginTime=neopopZ_getTickCount()+neopopZ_frameTime*100/neopopZ_speedpct;
	}
}

//=============================================================================
