  AREA tlcs900h, CODE, READONLY

  CODE32
  IMPORT loadW
  IMPORT _ipc


FLAGM_S EQU 0x80
FLAGM_Z EQU 0x40
FLAGM_H EQU 0x10
FLAGM_V EQU 0x04
FLAGM_N EQU 0x02
FLAGM_C EQU 0x01

FLAGM_SZHVN  EQU 0xD6
FLAGM_SZHVNC EQU 0xD7
FLAGM_SZVNC EQU 0xC7

  ; +++-----------------------------------------------------------------+++
  ; +     fetch16                                                         +
  ; +                                                                     +
  ; +   IN  : none                                                        +
  ; +   OUT : r0 = Word data                                              +
  ; +++-----------------------------------------------------------------+++
  EXPORT fetch16B

fetch16B
  ;stmfd sp!, {lr}
  
  ; Transfer pc global variable in register r1, and her content in r0 and r2
  ldr r1, =_ipc
  ldr r0, [r1]
  
  ; r2 = _ipc +2
  add r2, r0, #2
    
  ; global variable _pc = global variable _pc + 2
  str r2, [r1]
  
  ; call to loadW.
  ;bl loadW
  b loadW

  ;ldmfd sp!, {pc}
  


  EXPORT asm_generic_ADD_B
  EXPORT asm_generic_ADD_W
  EXPORT asm_generic_ADD_L
  EXPORT asm_generic_SUB_B
  EXPORT asm_generic_SUB_W
  EXPORT asm_generic_SUB_L
  EXPORT asm_generic_ADC_B
  EXPORT asm_generic_ADC_W
  EXPORT asm_generic_ADC_L
  EXPORT asm_generic_SBC_B
  EXPORT asm_generic_SBC_W
  EXPORT asm_generic_SBC_L
  

asm_generic_ADD_B
  
  	mov		r3, r0, lsl#24		;//Sauvegarde tmp
  	adds	r0, r3, r1, lsl#24	;//Resultat dans haut r0
  	orr		r0, r0, r3, lsr#24	;//Dans le bas, l'ancien r0
  	
  	ldrh 	r3,[r2,#0]
	bic 	r3, r3, #FLAGM_SZHVNC

			;//New Flags settings
  	orreq 	r3, r3, #FLAGM_Z
  	orrcs 	r3, r3, #FLAGM_C
  	orrmi 	r3, r3, #FLAGM_S
  	orrvs 	r3, r3, #FLAGM_V

			;//New Flag (Half)
	mov		r1,r1,lsl#28
	adds	r1,r1,r0,lsl#28
	orrcs	r3,r3, #FLAGM_H
	
			;//save flags
	strh	r3,[r2,#0];
	
			;//direct return
	mov		r0,r0,lsr#24
	mov 	pc,lr	
	
asm_generic_ADD_W
  
  	mov		r3, r0, lsl#16		;//Sauvegarde tmp
  	adds	r0, r3, r1, lsl#16	;//Resultat dans haut r0
  	orr		r0, r0, r3, lsr#16	;//Dans le bas, l'ancien r0
  	
  	ldrh 	r3,[r2,#0]
	bic 	r3, r3, #FLAGM_SZHVNC

			;//New Flags settings
  	orreq 	r3, r3, #FLAGM_Z
  	orrcs 	r3, r3, #FLAGM_C
  	orrmi 	r3, r3, #FLAGM_S
  	orrvs 	r3, r3, #FLAGM_V

			;//New Flag (Half)
	mov		r1,r1,lsl#28
	adds	r1,r1,r0,lsl#28
	orrcs	r3,r3, #FLAGM_H
	
			;//save flags
	strh	r3,[r2,#0];
	
			;//direct return
	mov		r0,r0,lsr#16
	mov 	pc,lr	


asm_generic_ADD_L
  
  	ldrh 	r3,[r2,#0]
	bic 	r3, r3, #FLAGM_SZVNC

   			;//Perform OP
   	adds 	r0, r1, r0

			;//New Flags settings
  	orreq 	r3, r3, #FLAGM_Z
  	orrcs 	r3, r3, #FLAGM_C
  	orrmi 	r3, r3, #FLAGM_S
  	orrvs 	r3, r3, #FLAGM_V

			;//save flags
	strh	r3,[r2,#0];
	
			;//direct return
	mov 	pc,lr	



;//////////////////////////////////////////////////



asm_generic_SUB_B
  
  	mov		r3, r0, lsl#24		;//Sauvegarde tmp
  	subs	r0, r3, r1, lsl#24	;//Resultat dans haut r0
  	orr		r0, r0, r3, lsr#24	;//Dans le bas, l'ancien r0
  	
  	ldrh 	r3,[r2,#0]
	bic 	r3, r3, #FLAGM_SZHVNC
	orr		r3, r3, #FLAGM_N
	
			;//New Flags settings
  	orreq 	r3, r3, #FLAGM_Z
  	orrlo 	r3, r3, #FLAGM_C
  	orrmi 	r3, r3, #FLAGM_S
  	orrvs 	r3, r3, #FLAGM_V

			;//New Flag (Half)
	mov		r1, r1, lsl#28
	cmps	r1, r0, lsl#28
	orrhi	r3,r3,#FLAGM_H

			;//save flags
	strh	r3,[r2,#0];
	
			;//direct return
	mov		r0,r0,lsr#24
	mov 	pc,lr	
	
asm_generic_SUB_W
  
  	mov		r3, r0, lsl#16		;//Sauvegarde tmp
  	subs	r0, r3, r1, lsl#16	;//Resultat dans haut r0
  	orr		r0, r0, r3, lsr#16	;//Dans le bas, l'ancien r0
  	
  	ldrh 	r3,[r2,#0]
	bic 	r3, r3, #FLAGM_SZHVNC
	orr		r3, r3, #FLAGM_N

			;//New Flags settings
  	orreq 	r3, r3, #FLAGM_Z
  	orrlo 	r3, r3, #FLAGM_C
  	orrmi 	r3, r3, #FLAGM_S
  	orrvs 	r3, r3, #FLAGM_V

			;//New Flag (Half)
	mov		r1, r1, lsl#28
	cmps	r1, r0, lsl#28
	orrhi	r3,r3,#FLAGM_H
	
			;//save flags
	strh	r3,[r2,#0];
	
			;//direct return
	mov		r0,r0,lsr#16
	mov 	pc,lr	


asm_generic_SUB_L
  
  	ldrh 	r3,[r2,#0]
	bic 	r3, r3, #FLAGM_SZVNC
	orr		r3, r3, #FLAGM_N

   			;//Perform OP
   	subs 	r0, r0, r1

			;//New Flags settings
  	orreq 	r3, r3, #FLAGM_Z
  	orrlo 	r3, r3, #FLAGM_C
  	orrmi 	r3, r3, #FLAGM_S
  	orrvs 	r3, r3, #FLAGM_V

			;//save flags
	strh	r3,[r2,#0];
	
			;//direct return
	mov 	pc,lr	


asm_generic_ADC_B
  
  	ldrh 	r3,[r2,#0]
  	movs	r3,r3,lsr#1

    sub		r0, r0, #0x100		;//On se place en fin de mot
  	adcs	r1, r0, r1      	;//Resultat dans r1
  	
	adc		r3,r3, #0		    ;//On rinsre le carryflag
	bic 	r3, r3, #FLAGM_SZHVN

			;//New Flags settings
  	orreq 	r3, r3, #FLAGM_Z
  	orrmi 	r3, r3, #FLAGM_S
  	orrvs 	r3, r3, #FLAGM_V

			;//New Flag (Half)
	eor		r0,r0,r1
	movs	r0,r0,lsr#5
	orrcs	r3,r3, #FLAGM_H
	
			;//save flags
	strh	r3,[r2,#0];
	
			;//direct return
	and		r0,r1,#0xFF
	mov 	pc,lr	
	
asm_generic_ADC_W
  
  	ldrh 	r3,[r2,#0]
  	movs	r3,r3,lsr#1

    sub		r0, r0, #0x10000	;//On se place en fin de mot
  	adcs	r1, r0, r1      	;//Resultat dans r1
  	
	adc		r3,r3, #0		    ;//On rinsre le carryflag
	bic 	r3, r3, #FLAGM_SZHVN

			;//New Flags settings
  	orreq 	r3, r3, #FLAGM_Z
  	orrmi 	r3, r3, #FLAGM_S
  	orrvs 	r3, r3, #FLAGM_V

			;//New Flag (Half)
	eor		r0,r0,r1
	movs	r0,r0,lsr#5
	orrcs	r3,r3, #FLAGM_H
	
			;//save flags
	strh	r3,[r2,#0];
	
			;//direct return
	and		r0,r1,#0xFF
	and		r0,r1,#0xFF00
	mov 	pc,lr	


asm_generic_ADC_L
  
  	ldrh 	r3,[r2,#0]
  	movs	r3,r3,lsr#1

  	adcs	r0, r0, r1      	;//Resultat dans r1
  	
	adc		r3,r3, #0		    ;//On rinsre le carryflag
	bic 	r3, r3, #FLAGM_SZHVN

			;//New Flags settings
  	orreq 	r3, r3, #FLAGM_Z
  	orrmi 	r3, r3, #FLAGM_S
  	orrvs 	r3, r3, #FLAGM_V

			;//save flags
	strh	r3,[r2,#0];
	
			;//direct return
	mov 	pc,lr	



;//////////////////////////////////////////////////



asm_generic_SBC_B
  
  	ldrh 	r3,[r2,#0]
  	movs	r3,r3,lsr#1

  	mov		r3, r0, lsl#24		;//Sauvegarde tmp
  	sbcs	r0, r3, r1, lsl#24	;//Resultat dans haut r0
  	orr		r0, r0, r3, lsr#24	;//Dans le bas, l'ancien r0
  	
  	ldrh 	r3,[r2,#0]
	bic 	r3, r3, #FLAGM_SZHVNC
	orr		r3, r3, #FLAGM_N
	
			;//New Flags settings
  	orreq 	r3, r3, #FLAGM_Z
  	orrlo 	r3, r3, #FLAGM_C
  	orrmi 	r3, r3, #FLAGM_S
  	orrvs 	r3, r3, #FLAGM_V

			;//New Flag (Half)
	mov		r1, r1, lsl#28
	cmps	r1, r0, lsl#28
	orrhi	r3,r3,#FLAGM_H

			;//save flags
	strh	r3,[r2,#0];
	
			;//direct return
	mov		r0,r0,lsr#24
	mov 	pc,lr	
	
asm_generic_SBC_W
  
  	ldrh 	r3,[r2,#0]
  	movs	r3,r3,lsr#1

  	mov		r3, r0, lsl#16		;//Sauvegarde tmp
  	sbcs	r0, r3, r1, lsl#16	;//Resultat dans haut r0
  	orr		r0, r0, r3, lsr#16	;//Dans le bas, l'ancien r0
  	
  	ldrh 	r3,[r2,#0]
	bic 	r3, r3, #FLAGM_SZHVNC
	orr		r3, r3, #FLAGM_N

			;//New Flags settings
  	orreq 	r3, r3, #FLAGM_Z
  	orrlo 	r3, r3, #FLAGM_C
  	orrmi 	r3, r3, #FLAGM_S
  	orrvs 	r3, r3, #FLAGM_V

			;//New Flag (Half)
	mov		r1, r1, lsl#28
	cmps	r1, r0, lsl#28
	orrhi	r3,r3,#FLAGM_H
	
			;//save flags
	strh	r3,[r2,#0];
	
			;//direct return
	mov		r0,r0,lsr#16
	mov 	pc,lr	


asm_generic_SBC_L
  
  	ldrh 	r3,[r2,#0]
  	movs	r3,r3,lsr#1

  	ldrh 	r3,[r2,#0]
	bic 	r3, r3, #FLAGM_SZVNC
	orr		r3, r3, #FLAGM_N

   			;//Perform OP
   	sbcs 	r0, r0, r1

			;//New Flags settings
  	orreq 	r3, r3, #FLAGM_Z
  	orrlo 	r3, r3, #FLAGM_C
  	orrmi 	r3, r3, #FLAGM_S
  	orrvs 	r3, r3, #FLAGM_V

			;//save flags
	strh	r3,[r2,#0];
	
			;//direct return
	mov 	pc,lr	

	
  END