#include "neopop.h"

#ifdef __GFXRENDER_1__

//---------------------------------------------------------------------------
// NEOPOP : Emulator as in Dreamland
//

#ifndef __GFX__
#define __GFX__

//=============================================================================

// Def generals
#include "neopop.h"

//=============================================================================

#define ZDEPTH_BACK_SPRITE			2
#define ZDEPTH_BACKGROUND_SCROLL	3
#define ZDEPTH_MIDDLE_SPRITE		4
#define ZDEPTH_FOREGROUND_SCROLL	5
#define ZDEPTH_FRONT_SPRITE			6

//=============================================================================


// Variable perso 
typedef struct
{
  //  uint8 *data;        /* Bitmap data */
    unsigned short int *data; // pour coller avec def 
    
    
 //   int width;          /* Bitmap width (32+512+32) */
 //   int height;         /* Bitmap height (256) */
    
    int width;          /* Bitmap width (160) */
    int height;         /* Bitmap height (152) */
    
//    int depth;          /* Color depth (8 bits) */
      int depth;          /* Color depth (16 bits) */
    int pitch;          /* Width of bitmap in bytes */
    int granularity;    /* Size of each pixel in bytes */
    struct {
        int x;          /* X offset of viewport within bitmap */
        int y;          /* Y offset of viewport within bitmap */
        int w;          /* Width of viewport */
        int h;          /* Height of viewport */
        int ow;         /* Previous width of viewport */
        int oh;         /* Previous height of viewport */
        int changed;    /* 1= Viewport width or height have changed */
    }viewport;
}t_bitmap;  

extern t_bitmap bitmap; // se retrouve en premier dans gpmain.cpp



//---------------------------
// Common Graphics Variables
//---------------------------

extern _u8 zbuffer[256];	//Line z-buffer
extern _u16* cfb_scanline;	//set = cfb + (scanline * SCREEN_WIDTH)

extern _u8 scanline;		//Current scanline

extern _u8 winx, winw;
extern _u8 winy, winh;
extern _u8 scroll1x, scroll1y;
extern _u8 scroll2x, scroll2y;
extern _u8 scrollsprx, scrollspry;
extern _u8 planeSwap;
extern _u8 bgc, oowc, negative;

extern _u16 r,g,b;

void gfx_delayed_settings(void);

//=============================================================================

void gfx_draw_scanline_colour(void);
void gfx_draw_scanline_mono(void);

//=============================================================================
#endif

#endif