/*
 * Snes9x - Portable Super Nintendo Entertainment System (TM) emulator.
 *
 * (c) Copyright 1996 - 2000 Gary Henderson (gary@daniver.demon.co.uk) and
 *                           Jerremy Koot (jkoot@snes9x.com)
 *
 * Super FX C emulator code 
 * (c) Copyright 1997 - 1999 Ivar (Ivar@snes9x.com) and
 *                           Gary Henderson.
 * Super FX assembler emulator code (c) Copyright 1998 zsKnight and _Demo_.
 *
 * DSP1 emulator code (c) Copyright 1998 Ivar, _Demo_ and Gary Henderson.
 * DOS port code contains the works of other authors. See headers in
 * individual files.
 *
 * Snes9x homepage: www.snes9x.com
 *
 * Permission to use, copy, modify and distribute Snes9x in both binary and
 * source form, for non-commercial purposes, is hereby granted without fee,
 * providing that this license information and copyright notice appear with
 * all copies and any derived work.
 *
 * This software is provided 'as-is', without any express or implied
 * warranty. In no event shall the authors be held liable for any damages
 * arising from the use of this software.
 *
 * Snes9x is freeware for PERSONAL USE only. Commercial users should
 * seek permission of the copyright holders first. Commercial use includes
 * charging money for Snes9x or software derived from Snes9x.
 *
 * The copyright holders request that bug fixes and improvements to the code
 * should be forwarded to them so everyone can benefit from the modifications
 * in future versions.
 *
 * Super NES and Super Nintendo Entertainment System are trademarks of
 * Nintendo Co., Limited and its subsidiary companies.
 */
 
#define OS9X_TURBOFSKIP 15

#include <TapWave.h>
 
#include "lj.h"


//#define TESTING
//#define TESTING_LOADQUICKATSTART


#ifdef __DEBUG__
#include "AdnDebugMgr.h" 
#define DBG_BREAK AdnDebugBreak();
#endif
 
#ifndef __MWERKS__
#else
#define OS9X_ROMSDIR "0:/PALM/Programs/LJZ/SNES/Roms/" //"gp:\\snes\\ffmq11.zip"
#define OS9X_SAVESDIR "0:/PALM/Programs/LJZ/SNES/Saves/"
#endif

#define _MAX_SKIP_FRAME_ 10
#define AUTO_FSKIP 10
#define SKEEZIX_FSKIP 11

/***********************************************/
/* SNES9X headers */
#include "snes9x.h"
#include "memmap.h"
//#include "debug.h"
#include "cpuexec.h"
#include "ppu.h"
#include "snapshot.h"
#include "apu.h"
#include "display.h"
#include "gfx.h"
#include "soundux.h"
#include "cheats.h"

#include "gammatab.h"


#include "sys/stat.h"
using namespace std;

extern "C" int __getdate_file(const char * name);

// Assertion Support
static void
assert_check(int error, const char* message)
{
    if (error) {
        ErrDisplayFileLineMsg("PalmOS", (UInt16) error, message);
    }
}

char str_month[12][4]=
{"Jan","Feb","Mar","Apr","May","Jun",
"Jul","Aug","Sep","Oct","Nov","Dec"};

extern int os9x_statecompress(char *source,char *dest,char *img);
extern int os9x_stateuncompress(char *source,char *dest);

int os9x_load(char *ext);
int os9x_loadzsnes(char *ext);
int os9x_save(char *ext);
/*****************/
extern "C" {
#include "LJZmenu.h"
}
/**************************/

#include "os9xZ_openspc.h"

void os9x_BigTextOut(uint8 *buffer,int X,int Y,char *A,int col,int bold);
void os9x_pause(int pause);

#define xassert(error) assert_check(error, #error);

#ifdef TITLE
#undef TITLE
#define TITLE "OpenSNES9XZ"
#endif

/****************/

/* timing stuff*/
uint32 os9x_frame;
volatile int os9x_timertps_running;
volatile int os9x_timersnd_running;
uint32 os9x_framerendered;
uint32 os9x_framecomputed;
int32 os9x_frameBeginTime;
/************************/
/* emu options */
uint32 os9x_asmcpu;

uint32 os9x_gammavalue;

extern unsigned char gammatab[10][32];

int32 os9x_fastmode;
int32 os9x_fskipvalue;

int32 os9x_specialskipframe;

int os9x_showfps;
int32 os9x_ShowSub;
int32 os9x_PalBrightness;
int os9x_apuenabled;
int os9x_sampledecoder;
int os9x_syncmode;
int os9x_fastsprite;

int os9x_fastforward;

int os9x_softrendering;
uint8 *vrambuffer;

int os9x_BG_Forced;
int os9x_DisableIRQ;
int os9x_DisableHDMA;
int os9x_CyclesPercentage;
/************************/
int framecpto;

int os9x_emupaused;

/* not used yet*/


/************************/
/*sound stuff*/
int os9x_soundenabled;


/*volatile uint32 os9x_sndThSample_Int,os9x_sndThSample_Dec;
volatile uint32 os9x_sndThSample_Int_Incr,os9x_sndThSample_Dec_Incr;
volatile uint32 os9x_sndRealSample;*/

uint8 *os9x_sndBuffer;
uint8 *os9x_sndBufferpos,*os9x_sndBufferend;
uint32 os9x_sndSz;
int os9x_sndFrequency;
char os9x_sndStereo;
char os9x_snd16bits;
int os9x_sndBuffsize;

/************************/
/* video */


TwGfxType *os9x_mGfxLib;
TwGfxSurfaceType *os9x_curRenderingScreen;
TwGfxSurfaceType *os9x_curTileCache,*os9x_tmpRenderingScreen;
TwGfxSurfaceType *os9x_tileCaches[3];
TwGfxSurfaceType *os9x_RenderingScreen[2];

int os9x_screen_h,os9x_screen_w;

TwGfxBitmapType tmp_sprBitmap;

TwInputHandle os9x_mInputQueue;
Int32 os9x_inputFormats[] = { twInputTimeStamp };
typedef struct {Int32 mTime;} os9x_ZUserEvent;
os9x_ZUserEvent os9x_mUserEvent;
Int32* os9x_mInputFormat;        

uint8 *os9x_tileCachesPtr[3];
uint8 *os9x_curRenderingScreenPtr;
uint8 *os9x_RenderingScreenPtr[2];
int os9x_curRenderingScreenIndex;


uint32 os9x_ColorsChanged;
uint32 os9x_renderingmode;


/* inputs */
volatile char os9x_exitemu;

uint32 os9x_autofireA,os9x_autofireB,os9x_autofireX,os9x_autofireY;
uint32 os9x_autofireL,os9x_autofireR;
uint32 os9x_speedpct;

uint32 os9x_vpad;

#define KEY_UP    		0x00000001
#define KEY_DOWN  		0x00000002
#define KEY_LEFT  		0x00000004
#define KEY_RIGHT 		0x00000008
#define KEY_SEL   		0x00000010
#define KEY_A     		0x00000020
#define KEY_B	  		0x00000040
#define KEY_X     		0x00000080
#define KEY_Y	  		0x00000100
#define KEY_L	  		0x00000200
#define KEY_R	  		0x00000400
#define KEY_START 		0x00000800
#define KEY_SELECT		0x00001000
#define KEY_QUICKLOAD   0x00002000
#define KEY_QUICKSAVE   0x00004000
#define KEY_FRAMESKIP	0x00008000
#define KEY_SCREENMODE	0x00010000
#define KEY_RENDER 		0x00020000
#define KEY_TURBO  		0x00040000




/****************/
char rom_filename[256];
char shortrom_filename[64];
char strload[128];
char os9x_romsdir[256];
char os9x_savesdir[256];
char sram_filename[256];
char tmp_filename[256];
char os9x_curVolume;
/****************/



#include "SoundMgr.h"
static SndStreamRef snd_stream;
typedef struct {uint32 __r9;uint32 __r10;} reg_sys_t;
static reg_sys_t reg_sys;
int in_mix=0;

static Err os9x_sndCallBack (void *userData,SndStreamRef stream, void *bufferZ,UInt32 frameCountZ)
{
	__asm 
	{
		stmfd  r13!,{r9,r10}
		ldr	   r9,[r0]
		ldr	   r10,[r0,#4]
	}	
	if (!in_mix)
	{
		in_mix=1;
		S9xMixSamples((uint8*)bufferZ,(int)(frameCountZ<<(os9x_sndStereo)));
		in_mix=0;
	}
	__asm 
	{
		ldmfd  r13!,{r9,r10}
	}
	return errNone;
}


int32 os9x_time()
{
	//TODO return time
	//return 0;
	/*int64 l;
	l=TimGetTicks();		
	return l*1000/SysTicksPerSecond();*/
	TwInputPoll(os9x_mInputQueue, (Int32 *) &os9x_mUserEvent, sizeof(os9x_mUserEvent));  	  	      	
	return os9x_mUserEvent.mTime;
}

int32 os9x_getTickCount()
{
	//TODO return tick 
	/*long long l;
	l=TimGetTicks();	
	return l*1000/SysTicksPerSecond();*/
	
  	TwInputPoll(os9x_mInputQueue, (Int32 *) &os9x_mUserEvent, sizeof(os9x_mUserEvent));  	  	      	
	return os9x_mUserEvent.mTime;
}





void os9x_TextOut(uint8 *buffer,int X,int Y,char *A,int col,int bold);

#define MsgAll(X,Y,A,col) {\
  os9x_TextOut(os9x_RenderingScreenPtr[os9x_curRenderingScreenIndex],X,Y,A,col,0);}

#define Cls(Col) {\
  memset(os9x_RenderingScreenPtr[os9x_curRenderingScreenIndex],Col,320*320*2);}
  
  
extern void init_logop(void);
extern void close_logop(void);  
  
void ClsPalm(int r,int g,int b)
{
	RectangleType 				bounds;
	WinPushDrawState();
	WinSetDrawMode( winPaint );
	RGBColorType 	fill;
	fill.r=r; fill.g=g; fill.b=b;
	WinSetForeColorRGB( &fill, NULL );
	WinGetBounds( WinGetDisplayWindow(), &bounds );
	WinPaintRectangle( &bounds, 0 );									
	WinPopDrawState();
}  
  
void ClsFade(int Col)
{
   int r,v,b,cc;   
   TwGfxSurfaceType* displaySurface;
   TwGfxRectType region;
   uint16 *src,*dest;
   
   src=(uint16*)ljz_malloc(320*2);
   
   // Get palmos display surface:
   xassert(TwGfxGetDisplaySurface(os9x_mGfxLib, &displaySurface));   
      
   
      
   dest=(uint16*)(os9x_RenderingScreenPtr[os9x_curRenderingScreenIndex]);
   for (int i=0;i<320;i++,dest+=320)
   {
	   region.x=(480-320)/2;
	   region.y=i;
	   region.w=320;
	   region.h=1;
	   TwGfxReadSurfaceRegion(displaySurface,&region,(void*)src,320*2,0);
	   for (int j=0;j<320;j++)
	   {
	   	  cc=src[j];
	   	  r=cc>>11;v=(cc>>5)&63;b=cc&31;
	   	  r=(r+(Col>>11))>>1;v=(v+((Col>>5)&63))>>1;b=(b+(Col&31))>>1;
	   	  dest[j]=(r<<11)|(v<<5)|b;
	   }
   }
   
	ljz_free(src);
}


  

char g_filename[512];
const char *S9xGetFilename (const char *ex);

void S9xLoadSDD1Data ()
{
	Settings.SDD1Pack=TRUE;
}


void OutOfMemory()
{
 // S9xMessage(0,0,"Out of memory ...\n");
 os9x_pause(1);
 menu_message("Out of memory ...\n");
 menu_waitPen(NULL,NULL,1);
}

/*
  Initialisation des variables systemes de la SNES
*/

const char *S9xBasename (const char *f)
{
  const char *p;
  if ((p = strrchr (f, '/')) != NULL || (p = strrchr (f, '\\')) != NULL)
    return (p + 1);
  return (f);
}

void S9xExtraUsage (){}
void S9xGraphicsMode (){}
void S9xTextMode (){}

bool8 S9xInitUpdate ()
{  
  if (os9x_softrendering) GFX.Screen=vrambuffer;
  else GFX.Screen=os9x_RenderingScreenPtr[os9x_curRenderingScreenIndex];
  os9x_curRenderingScreen=os9x_RenderingScreen[os9x_curRenderingScreenIndex];    
  return(TRUE);
}

void os9x_TwRender(void)
{
		TwGfxPointType destLocation = {0, 0};
            TwGfxSurfaceType* displaySurface;
            // Get palmos display surface:
            xassert(TwGfxGetPalmDisplaySurface(os9x_mGfxLib, &displaySurface));

            TwGfxRectType mDisp;
			mDisp.x=0;
			mDisp.y=0;
			mDisp.w=256;
			mDisp.h=224;//(Settings.PAL?240:224);
						
			switch (os9x_renderingmode)
			{
				case 0:
					{						
						destLocation.x=(os9x_screen_w-mDisp.w)>>1;
						destLocation.y=(os9x_screen_h-mDisp.h)>>1;
						if (!TwGfxIsSurfaceReady(os9x_curRenderingScreen))
							xassert(TwGfxBitBlt(displaySurface, &destLocation, os9x_curRenderingScreen, &mDisp));
							
						
						break;
					}
				case 1:
					{
						TwGfxRectType mDispDest;
						mDispDest.x=(os9x_screen_w-366/*(Settings.PAL?342:366)*/)>>1;
						mDispDest.y=0;
						mDispDest.w=366;//(Settings.PAL?342:366);
						mDispDest.h=320;
						if (!TwGfxIsSurfaceReady(os9x_curRenderingScreen))
							xassert(TwGfxStretchBlt2(displaySurface, &mDispDest, os9x_curRenderingScreen, &mDisp,twGfxStretchFast));
						break;
					}
				case 2:
					{
						TwGfxRectType mDispDest;
						mDispDest.x=(os9x_screen_w-366/*(Settings.PAL?342:366)*/)>>1;
						mDispDest.y=0;
						mDispDest.w=366;//(Settings.PAL?342:366);
						mDispDest.h=320;
						if (!TwGfxIsSurfaceReady(os9x_curRenderingScreen))
							xassert(TwGfxStretchBlt2(displaySurface, &mDispDest, os9x_curRenderingScreen, &mDisp,twGfxStretchFast|twGfxStretchSmooth));
						break;
					}
				case 3:
					{
						TwGfxRectType mDispDest;
						mDispDest.x=0;
						mDispDest.y=0;
						mDispDest.w=480;
						mDispDest.h=320;
						if (!TwGfxIsSurfaceReady(os9x_curRenderingScreen))
							xassert(TwGfxStretchBlt2(displaySurface, &mDispDest, os9x_curRenderingScreen, &mDisp,twGfxStretchFast));
						break;
					}				
				case 4:
					{
						TwGfxRectType mDispDest;
						mDispDest.x=0;
						mDispDest.y=0;
						mDispDest.w=480;
						mDispDest.h=320;
						if (!TwGfxIsSurfaceReady(os9x_curRenderingScreen))
							xassert(TwGfxStretchBlt2(displaySurface, &mDispDest, os9x_curRenderingScreen, &mDisp,twGfxStretchFast|twGfxStretchSmooth));
						break;
					}							
											
				case 5:
					{
						TwGfxRectType mDispDest;
						mDisp.x=(256-240)>>1;
						mDisp.y=(/*(Settings.PAL?240:224)*/224-160)>>1;
						mDisp.w=240;
						mDisp.h=160;
						mDispDest.x=0;
						mDispDest.y=0;
						mDispDest.w=480;
						mDispDest.h=320;
						if (!TwGfxIsSurfaceReady(os9x_curRenderingScreen))
							xassert(TwGfxStretchBlt2(displaySurface, &mDispDest, os9x_curRenderingScreen, &mDisp,twGfxStretchFast));
						break;
					}	
				case 6:
					{
						TwGfxRectType mDispDest;
						mDisp.x=(256-240)>>1;
						mDisp.y=(/*(Settings.PAL?240:224)*/224-160)>>1;
						mDisp.w=240;
						mDisp.h=160;
						mDispDest.x=0;
						mDispDest.y=0;
						mDispDest.w=480;
						mDispDest.h=320;
						if (!TwGfxIsSurfaceReady(os9x_curRenderingScreen))
							xassert(TwGfxStretchBlt2(displaySurface, &mDispDest, os9x_curRenderingScreen, &mDisp,twGfxStretchFast|twGfxStretchSmooth));
						break;
					}							
											
			}
}		


void os9x_asmfastrender(uint8 *screen,uint8 *source,int height)
{
	__asm{
		cmp   r2,#0
		beq	  fin
		stmfd r13!,{r3-r12}	
	 loopY:	
		ldmia r1!,{r3-r12}  //r3-r12 : 10regs -> 40bytes <=> 20pixels
		stmia r0!,{r3-r12} //20
		ldmia r1!,{r3-r12}
		stmia r0!,{r3-r12} //40
		ldmia r1!,{r3-r12}
		stmia r0!,{r3-r12} //60
		ldmia r1!,{r3-r12}
		stmia r0!,{r3-r12} //80
		ldmia r1!,{r3-r12}
		stmia r0!,{r3-r12} //100
		ldmia r1!,{r3-r12}
		stmia r0!,{r3-r12} //120
		ldmia r1!,{r3-r12}
		stmia r0!,{r3-r12} //140
		ldmia r1!,{r3-r12}
		stmia r0!,{r3-r12} //160
		ldmia r1!,{r3-r12}
		stmia r0!,{r3-r12} //180
		ldmia r1!,{r3-r12}
		stmia r0!,{r3-r12} //200
		ldmia r1!,{r3-r12}
		stmia r0!,{r3-r12} //220
		ldmia r1!,{r3-r12}
		stmia r0!,{r3-r12} //240
		ldmia r1!,{r3-r10}
		stmia r0!,{r3-r10} //256						
		add	  r0,r0,#128 //(320-256) * 2		
		subs  r2,r2,#1
		bne   loopY
	
		
		ldmfd r13!,{r3-r12}	
	fin:		
		}	
}


bool8 S9xDeinitUpdate (int Width, int Height, bool8 sixteen_bit)
{
  int i,j;  
  if (Width==256) 
	{
		if (Height<=240)
		{		 
#ifdef PROFILING	 
PROF_START(15);
#endif

		{			
		  /*TO DO : render vrambuffer*/
		  
		  	if (os9x_softrendering)
		  	{
		  		os9x_asmfastrender((uint8*)os9x_curRenderingScreenPtr,(uint8*)vrambuffer,Height);
		  	}
		  	
/*	char str[256];
	framecpto++;
	sprintf(str,"fr : %d\n%d %d %d %d %d\n%d %d %d %d\n",
		framecpto,
		SoundData.channels[0].state,
		SoundData.channels[0].hertz,
		SoundData.channels[0].frequency,
		SoundData.channels[0].count,
		SoundData.channels[0].envx,
		SoundData.channels[0].left_vol_level,
		SoundData.channels[0].right_vol_level,
		SoundData.channels[0].env_error,
		SoundData.channels[0].erate);
		
	
		
	
	if (SoundData.channels[0].state||SoundData.channels[0].left_vol_level||SoundData.channels[0].right_vol_level)
		{
		S9xMessage(0,0,str);
		menu_waitPen(NULL,NULL,1);
		}*/
		
		  
			os9x_TwRender();
			

//			os9x_curRenderingScreenIndex^=1;
			os9x_curRenderingScreenPtr=os9x_RenderingScreenPtr[os9x_curRenderingScreenIndex];
		}
        
		  
		os9x_framerendered++;		  
#ifdef PROFILING
PROF_END(15);
#endif		  
 
 
#ifdef PROFILING
PROF_START(11);
#endif		  
		  
#ifdef PROFILING
PROF_END(11);
#endif		   
		  return(TRUE);
		}	      
	}    	
 menu_message("Video mode not handled now");
 menu_waitPen(NULL,NULL,1);
  return(TRUE);
}


bool8 S9xOpenSoundDevice(int mode, bool8 stereo, int buffer_size)
{     
  __asm 
  {
  	ldr  r0, = reg_sys
  	add	 r0,r0,r10
  	str	 r9,[r0]
  	str	 r10,[r0,#4]
  } 
  so.stereo = os9x_sndStereo;
  so.sixteen_bit = os9x_snd16bits;
  so.playback_rate = os9x_sndFrequency;
  so.buffer_size = os9x_sndBuffsize;
  if (so.sixteen_bit) so.buffer_size*=2;
  so.encoded = FALSE;
  
  return(TRUE);
}

bool8 S9xReadMousePosition (int which1_0_to_1, int &x, int &y, uint32 &buttons)
{ 
  x=0;
  y=0;
  buttons=0;
  return(FALSE);
}
bool8 S9xReadSuperScopePosition (int &x, int &y, uint32 &buttons)
{
  return(FALSE);
}


void S9xDeinitDisplay ()
{
  ljz_free(GFX.ZBuffer);
  ljz_free(GFX.SubZBuffer);
  ljz_free(GFX.SubScreen);
  S9xGraphicsDeinit();
}

void S9xInitDisplay ()
{
/*  if (os9x_softrendering) 
  {*/
  	GFX.Screen = vrambuffer;
  	GFX.SubScreen = (uint8 *)ljz_malloc(256*240*2);    
  	GFX.SubZBuffer = (uint8 *)ljz_malloc(256*240);
/*  }
  else 
  {
  	GFX.SubScreen = NULL;//(uint8 *)ljz_malloc(256*240*2);    
  	GFX.SubZBuffer = NULL;//(uint8 *)ljz_malloc(256*240);
  }*/
  
  GFX.Pitch = GFX.RealPitch = 256*2;
  
  GFX.ZBuffer = (uint8 *)ljz_malloc(256*240);  
  
  GFX.Delta = (GFX.SubScreen - GFX.Screen) >> 1;
  GFX.PPL = GFX.Pitch >> 1;
  GFX.PPLx2 = GFX.Pitch;
  GFX.ZPitch = GFX.Pitch >> 1;  
}

void S9xMessage (int type, int number, const char *message)
{		
	if (type==0) Cls(0)
	MsgAll(0,number,(char*)message,0xFFFF);	
	TwGfxPointType destLocation = {0, 0};
	TwGfxSurfaceType* displaySurface;
	TwGfxRectType mDisp;
	mDisp.x=0;
	mDisp.y=0;
	mDisp.w=320;
	mDisp.h=320;
	// Get palmos display surface:
	xassert(TwGfxGetPalmDisplaySurface(os9x_mGfxLib, &displaySurface));
	destLocation.x=(os9x_screen_w-320)>>1;
	destLocation.y=0;
	if (!TwGfxIsSurfaceReady(os9x_RenderingScreen[os9x_curRenderingScreenIndex]))
	{		
		xassert(TwGfxBitBlt(displaySurface, &destLocation, os9x_RenderingScreen[os9x_curRenderingScreenIndex], &mDisp));
	}
	if (type) menu_waitPen(NULL,NULL,1);
}



uint32 S9xReadJoypad (int which1_0_to_4)
{
  uint32 val=0x80000000;    
  if (which1_0_to_4==0)
  {	  
	  if (os9x_vpad&KEY_Y) 
	  {
	  	switch (os9x_autofireY)
  		{
  			case 0:val|=SNES_Y_MASK; break;
			case 1:if ((os9x_frame&31)>15) val|=SNES_Y_MASK;break;
			case 2:if ((os9x_frame&15)>7) val|=SNES_Y_MASK;break;
  			case 3:if ((os9x_frame&7)>3) val|=SNES_Y_MASK;break;
		}  		
	  }
	  if (os9x_vpad&KEY_X) 
	  {
	  	switch (os9x_autofireX)
  		{
  			case 0:val|=SNES_X_MASK; break;
			case 1:if ((os9x_frame&31)>15) val|=SNES_X_MASK;break;
			case 2:if ((os9x_frame&15)>7) val|=SNES_X_MASK;break;
  			case 3:if ((os9x_frame&7)>3) val|=SNES_X_MASK;break;
		}  		
	  }
	  if (os9x_vpad&KEY_B) 
	  {
	  	switch (os9x_autofireB)
  		{
  			case 0:val|=SNES_B_MASK; break;
			case 1:if ((os9x_frame&31)>15) val|=SNES_B_MASK;break;
			case 2:if ((os9x_frame&15)>7) val|=SNES_B_MASK;break;
  			case 3:if ((os9x_frame&7)>3) val|=SNES_B_MASK;break;
		}  		
	  }
	  if (os9x_vpad&KEY_A) 
	  {
	  	switch (os9x_autofireA)
  		{
  			case 0:val|=SNES_A_MASK; break;
			case 1:if ((os9x_frame&31)>15) val|=SNES_A_MASK;break;
			case 2:if ((os9x_frame&15)>7) val|=SNES_A_MASK;break;
  			case 3:if ((os9x_frame&7)>3) val|=SNES_A_MASK;break;
		}  		
	  }
	  if (os9x_vpad&KEY_X) 
	  {
	  	switch (os9x_autofireX)
  		{
  			case 0:val|=SNES_X_MASK; break;
			case 1:if ((os9x_frame&31)>15) val|=SNES_X_MASK;break;
			case 2:if ((os9x_frame&15)>7) val|=SNES_X_MASK;break;
  			case 3:if ((os9x_frame&7)>3) val|=SNES_X_MASK;break;
		}  		
	  }
	  if (os9x_vpad&KEY_L) 
	  {
	  	switch (os9x_autofireL)
  		{
  			case 0:val|=SNES_TL_MASK; break;
			case 1:if ((os9x_frame&31)>15) val|=SNES_TL_MASK;break;
			case 2:if ((os9x_frame&15)>7) val|=SNES_TL_MASK;break;
  			case 3:if ((os9x_frame&7)>3) val|=SNES_TL_MASK;break;
		}  		
	  }
	  if (os9x_vpad&KEY_R) 
	  {
	  	switch (os9x_autofireR)
  		{
  			case 0:val|=SNES_TR_MASK; break;
			case 1:if ((os9x_frame&31)>15) val|=SNES_TR_MASK;break;
			case 2:if ((os9x_frame&15)>7) val|=SNES_TR_MASK;break;
  			case 3:if ((os9x_frame&7)>3) val|=SNES_TR_MASK;break;
		}  		
	  }
	  if (os9x_vpad&KEY_LEFT) val|=SNES_LEFT_MASK;
	  if (os9x_vpad&KEY_RIGHT) val|=SNES_RIGHT_MASK;
	  if (os9x_vpad&KEY_DOWN) val|=SNES_DOWN_MASK;
	  if (os9x_vpad&KEY_UP) val|=SNES_UP_MASK;
	  if (os9x_vpad&KEY_SELECT) val|=SNES_SELECT_MASK;
	  if (os9x_vpad&KEY_START) val|=SNES_START_MASK;
  }
  return(val);
}


extern unsigned char gammatab[10][32];
void S9xSetPalette ()
{

}

int Do_Nothing()
{
	int j=rand();
	j+=1;
	return j;
}

void S9xSyncSpeed ()
{
   int haswait;   
      
   S9xProcessEvents(FALSE);      

         
   os9x_frame++;
   os9x_framecomputed++;	      
   if ((Settings.SkipFrames== AUTO_FRAMERATE)&&(!os9x_fastforward))
    {    
       int32 i;
       haswait=0;
       os9x_frameBeginTime+=Settings.FrameTime*100/os9x_speedpct;
       
       if ((int32)(os9x_frameBeginTime-os9x_getTickCount())>(int32)(Settings.FrameTime*20))
          os9x_frameBeginTime=os9x_getTickCount()+Settings.FrameTime;
       
       i=os9x_frameBeginTime-os9x_getTickCount()+1;
       if (i>0) {haswait=1; SysTaskDelay(i);}
//       while (os9x_getTickCount()<=os9x_frameBeginTime)  haswait=1;
    
	   if (IPPU.SkippedFrames>_MAX_SKIP_FRAME_) 
	   {	   	
	   	haswait=1;
	   }
       if (!haswait) 
    	{
		  IPPU.RenderThisFrame=FALSE;
		  IPPU.SkippedFrames++;
		}
	      else
		{
		  IPPU.RenderThisFrame = TRUE;
		  IPPU.SkippedFrames = 0;
	    }
    }
  else
    {
	  os9x_frameBeginTime+=Settings.FrameTime*100/os9x_speedpct;
	  
	  if ((int32)(os9x_frameBeginTime-os9x_getTickCount())>(int32)(Settings.FrameTime*20))
         os9x_frameBeginTime=os9x_getTickCount()+Settings.FrameTime;       
	  haswait=0;
	  
	  if (os9x_fastforward)
	  {
	    if (++IPPU.FrameSkip > OS9X_TURBOFSKIP)
		{	
			IPPU.RenderThisFrame=TRUE;
			IPPU.FrameSkip=0;
		}
		else
		{
			IPPU.RenderThisFrame=FALSE;
		}
	  }
	  else
	  {
        if (++IPPU.FrameSkip > Settings.SkipFrames)
		{	
        	int32 i;
			//while (os9x_getTickCount()<=os9x_frameBeginTime) 
   	   		//	haswait=1;
   	   		i=os9x_frameBeginTime-os9x_getTickCount()+1;
	        if (i>0) {SysTaskDelay(i);}
			
			IPPU.RenderThisFrame=TRUE;
			IPPU.FrameSkip=0;
		}
		else
		{
			IPPU.RenderThisFrame=FALSE;
			
			if (os9x_soundenabled==2)
			{
			//	while (os9x_getTickCount()<=os9x_frameBeginTime) haswait=1;
				int i=os9x_frameBeginTime-os9x_getTickCount()+1;
		        if (i>0) {SysTaskDelay(i);}
		    }
			
   	   			
		}
	  }
    }    
}

void S9xInitInputDevices()
{
}

void S9xSetTitle(char *title)
{
}

char *GetSnapName()
{  
  return(NULL);
}



void S9xGetSaveFilename (char *ex,char *filename)
{
  strcpy (filename, os9x_savesdir);
  strcat (filename, shortrom_filename);  
  strcat (filename, ex);  
}



void Snes_Close_ROM()
{    

  menu_message("Saving SRAM");
  S9xGetSaveFilename (".srm",sram_filename);   
  Memory.SaveSRAM (sram_filename);
  if (Settings.APUEnabled) S9xSetSoundMute (TRUE);  
  //S9xSaveCheatFile (S9xGetFilename (".cht"));
  S9xDeinitDisplay ();  
  S9xDeinitAPU ();
  Memory.Deinit ();
}

void S9xReinitsound()
{
/*  if (0)
  {
  	  S9xSetSoundMute(TRUE);  
	  S9xOpenSoundDevice(os9x_sndFrequency,os9x_sndStereo,os9x_sndBuffsize);
	  S9xSetSoundMute(FALSE);					
  }*/
}


void S9xProcessEvents (bool8 block)
{  
	if (os9x_vpad&KEY_QUICKLOAD)
	{
		FILE *savefile;
	  	S9xGetSaveFilename (".za0",sram_filename);
		savefile=fopen(sram_filename,"rb");
	    if (savefile) 
	    {	  		
		  	fclose(savefile);	
		  	if (menu_confirm("Load state ?")) os9x_load(".za0");
	  	}	  			
	}
	
	if (os9x_vpad&KEY_QUICKSAVE)
	{
		if (menu_confirm("Save state ?"))
		{
			os9x_save(".za0");
		}
	}
	
	if (os9x_vpad&KEY_RENDER)
	{
		os9x_softrendering++;
		if (os9x_softrendering>2) os9x_softrendering=0;		
		os9x_ShowSub=0;
	  	ZeroMemory (IPPU.TileCached [TILE_2BIT], (MAX_2BIT_TILES+MAX_4BIT_TILES+MAX_8BIT_TILES)<<1);
    	S9xInitUpdate();
		S9xReschedule ();
		switch (os9x_softrendering)
		{
			case 0:menu_message("Render : Hardware");break;
			case 1:menu_message("Render : Software - fast");break;
			case 2:menu_message("Render : Software - exact");break;
		}
		int i=os9x_getTickCount();
		while ((os9x_getTickCount()-i)<300)
		{
		}
		os9x_frameBeginTime=os9x_getTickCount()+Settings.FrameTime*100/os9x_speedpct;
	}
	
	if (os9x_vpad&KEY_TURBO)
	{			
		os9x_fastforward=1;		
	}
	else 
	if (os9x_fastforward)
	{
		os9x_fastforward=0;
		os9x_frameBeginTime=os9x_getTickCount()+Settings.FrameTime*100/os9x_speedpct;
	}
}

void S9xGenerateSound ()
{
}

void S9xExit ()
{ 
  S9xSetSoundMute (TRUE);
  S9xDeinitDisplay ();
  S9xGetSaveFilename (".srm",sram_filename);   
  Memory.SaveSRAM (sram_filename);
  //S9xSaveCheatFile (S9xGetFilename (".cht"));
  Memory.Deinit ();
  S9xDeinitAPU ();
}

void _makepath (char *path,const char *,const char *dir,
		 const char *fname, const char *ext)
{
  if (dir && *dir)
    {
      strcpy (path, dir);
      strcat (path, SLASH_STR);
    }
  else
    *path = 0;
  strcat (path, fname);
  if (ext && *ext)
    {
      strcat (path, ".");
      strcat (path, ext);
    }
}

void _splitpath (const char *path, char *drive, char *dir, char *fname,
		 char *ext)
{
  *drive = 0;

  char *slash = (char*)strrchr (path, '/');
  if (!slash)
    slash =  (char*)strrchr (path, '\\');

  char *dot =  (char*)strrchr (path, '.');

  if (dot && slash && dot < slash)
    dot = NULL;

  if (!slash)
    {
      strcpy (dir, "");
      strcpy (fname, path);
      if (dot)
        {
	  *(fname + (dot - path)) = 0;
	  strcpy (ext, dot + 1);
        }
      else
	strcpy (ext, "");
    }
  else
    {
      strcpy (dir, path);
      *(dir + (slash - path)) = 0;
      strcpy (fname, slash + 1);
      if (dot)
	{
	  *(fname + (dot - slash) - 1) = 0;
	  strcpy (ext, dot + 1);
	}
      else
	strcpy (ext, "");
    }
}

void S9xAutoSaveSRAM ()
{
  S9xGetSaveFilename (".srm",sram_filename);   
  Memory.SaveSRAM (sram_filename);
}

const char *GetHomeDirectory ()
{
  return (getenv ("HOME"));
}


const char *S9xGetFilename (const char *ex)
{
  

  //_splitpath (rom_filename/*Memory.ROMFilename*/, drive, dir, fname, ext);
  strcpy (g_filename, os9x_romsdir);
  
  strcat (g_filename, shortrom_filename);
  strcat (g_filename, ex);

  return (g_filename);
}



const char *S9xGetROMDirectory ()
{
  return (os9x_romsdir);
}


const char *S9xChooseFilename (bool8 read_only,uint8 num)
{  
  return (NULL);
}

bool8 S9xOpenSnapshotFile (const char *fname, bool8 read_only, STREAM *file)
{
 /* char filename [PATH_MAX];
  char drive [_MAX_DRIVE];
  char dir [_MAX_DIR];
  char ext [_MAX_EXT];*/

 // strcpy(filename,fname);
      
  if (read_only)
    {
      if (*file = OPEN_STREAM(fname,"rb")) return(TRUE);
    }
  else
    {
      if (*file = OPEN_STREAM(fname,"w+b")) return(TRUE);
    }
  return (FALSE);
}

void S9xCloseSnapshotFile (STREAM file)
{
  CLOSE_STREAM (file);
}

//extern int32 dsp_opcode[256];
void Snes9X_Start()
{  

/*  char strtmp[64];
  unsigned long freeP,maxP;
  MemHeapFreeBytes(0,(unsigned long*)&freeP,(unsigned long*)&maxP);
  sprintf(strtmp,"free heap :\n%d\n%d",freeP,maxP);
  S9xMessage(1,0,strtmp);*/
  Cls(0)  
  //memset(dsp_opcode,0,256*4);

  os9x_frameBeginTime=os9x_getTickCount();
  os9x_frame=0;

  os9x_framerendered=0;
  
  os9x_timertps_running=0;
  os9x_timersnd_running=0;
  os9x_emupaused=1;
  
    
  os9x_exitemu=0;
  os9x_emupaused=0;
  
#ifdef TESTING
  init_logop();
#endif  
  
  
  os9x_pause(0);
   /* while (!os9x_exitemu)
  {
      if (!Settings.Paused) S9xMainLoop (); 

      if ((Settings.Paused)&&(Settings.APUEnabled))
	  {
		  S9xSetSoundMute (TRUE);
	  }

      if ((!Settings.Paused)&&(Settings.APUEnabled))
	  {
	      S9xSetSoundMute (FALSE);
	  }    
  }*/
}



void os9x_paramInit(void)
{  
  //default values
  /*gfx*/
  os9x_gammavalue=0;
  os9x_showfps=0;
  
  os9x_specialskipframe=0;
  
  os9x_syncmode=0;
  
  os9x_fastforward=0;
  
  int val;
  FtrGet(APPLI_ID,FTR_OPT_FSKIP_ID,(unsigned long*)&val); 
  os9x_fskipvalue=val;
  
  
  FtrGet(APPLI_ID,FTR_OPT_CPUCORE_ID,(unsigned long*)&val);  
  os9x_asmcpu=val;
  
  os9x_fastmode=1;
  /*input*/   
  
  os9x_autofireA=0;
  os9x_autofireB=0;
  os9x_autofireX=0;
  os9x_autofireY=0;
  os9x_autofireL=0;
  os9x_autofireR=0;
  os9x_speedpct=100;
  
  /*hack*/
  
  FtrGet(APPLI_ID,FTR_OPT_SNESTRANSP_ID,(unsigned long*)&val);
  if (os9x_softrendering!=1) val=0;  
  os9x_ShowSub=(val?4:0);
  
  os9x_PalBrightness=0;
  os9x_fastsprite=0;
  os9x_BG_Forced=0;
  os9x_DisableIRQ=0;
  os9x_DisableHDMA=0;
  os9x_CyclesPercentage=100;
  /*sound*/
  FtrGet(APPLI_ID,FTR_OPT_SOUND_ID,(unsigned long*)&val);
  os9x_soundenabled=val;
  os9x_sampledecoder=1;//0;//4;
  
  FtrGet(APPLI_ID,FTR_OPT_SOUNDFREQ_ID,(unsigned long*)&val);
  if (val==1) os9x_sndFrequency=22050;
  else if (val==2) os9x_sndFrequency=11025;
  else os9x_sndFrequency=44100;
  
  os9x_sndBuffsize=1024;
  os9x_sndStereo=1;
  os9x_snd16bits=1;  
  //  
  
}

int os9x_Init(void)
{
  int i;
  
/*  char strtmp[64];
  unsigned long freeP,maxP;
  MemHeapFreeBytes(0,(unsigned long*)&freeP,(unsigned long*)&maxP);
  sprintf(strtmp,"free heap :\n%d\n%d",freeP,maxP);
  S9xMessage(1,0,strtmp);*/
  
  /*emu parameters ini*/
  os9x_paramInit();

  os9x_vpad=0;
  os9x_curRenderingScreenIndex=0;        
  os9x_curRenderingScreenPtr=os9x_RenderingScreenPtr[os9x_curRenderingScreenIndex];
  os9x_sndBuffer=NULL;      

  unsigned long val;
  FtrGet(APPLI_ID,FTR_OPT_FAST_SPR_ID,(unsigned long*)&val);  
  os9x_fastsprite=val;
  


   snd_stream=0;
 /*********************/ 
  
	unsigned long val1,val2;
	FtrGet(APPLI_ID,FTR_OPT_SCREENMODE_ID,(unsigned long*)&val1);
	FtrGet(APPLI_ID,FTR_OPT_SMOOTHING_ID,(unsigned long*)&val2);
	if (!val1) os9x_renderingmode=0;
	else 
	if (val1==1) os9x_renderingmode=(val2?2:1);
	else
	if (val1==2) os9x_renderingmode=(val2?4:3);
	else
	os9x_renderingmode=(val2?6:5);
  
      
  os9x_apuenabled=os9x_soundenabled;  
      
    
  ZeroMemory (&Settings, sizeof (Settings));

  // ROM Options
    memset (&Settings, 0, sizeof (Settings));

    Settings.ForceLoROM = false;
    Settings.ForceInterleaved = false;

    Settings.ForceNotInterleaved = false;
    Settings.ForceInterleaved = false;
    Settings.ForceInterleaved2 = false;

    Settings.ForcePAL = false;
    Settings.ForceNTSC = false;
    Settings.ForceHeader = false;
    Settings.ForceNoHeader = false;

    // Sound options        
    
    Settings.SoundSync = FALSE;
    Settings.InterpolatedSound = FALSE;//TRUE;
    Settings.SoundEnvelopeHeightReading = TRUE;
    Settings.DisableSoundEcho = FALSE;
    Settings.DisableMasterVolume = FALSE;
    Settings.Mute = FALSE;
    Settings.SoundSkipMethod = 0;
    Settings.SoundPlaybackRate = os9x_sndFrequency;
    Settings.SixteenBitSound = os9x_snd16bits;
    Settings.Stereo = os9x_sndStereo;
    Settings.AltSampleDecode = os9x_sampledecoder;
    Settings.ReverseStereo = FALSE;
//    Settings.SoundDriver = 0;//WIN_SNES9X_DIRECT_SOUND_DRIVER;
    Settings.SoundBufferSize = 0;//4;
    Settings.SoundMixInterval = 0;//20;
	Settings.DisableSampleCaching=TRUE;
	
	Settings.FixFrequency = FALSE;

    // Tracing options
    Settings.TraceDMA = false;
    Settings.TraceHDMA = false;
    Settings.TraceVRAM = false;
    Settings.TraceUnknownRegisters = false;
    Settings.TraceDSP = false;

    // Joystick options
    Settings.SwapJoypads = false;
    Settings.JoystickEnabled = false;

    // ROM timing options (see also H_Max above)
    Settings.PAL = false;
    Settings.FrameTimePAL = 20;
    Settings.FrameTimeNTSC = 17;    

    // CPU options 
    Settings.CyclesPercentage = os9x_CyclesPercentage;
    Settings.Shutdown = true;
    Settings.ShutdownMaster = true;
    Settings.NextAPUEnabled = Settings.APUEnabled = os9x_apuenabled;
    Settings.DisableIRQ = os9x_DisableIRQ;
    Settings.Paused = false;
    Settings.H_Max = SNES_CYCLES_PER_SCANLINE;
    Settings.HBlankStart = (256 * Settings.H_Max) / SNES_HCOUNTER_MAX;
    
    os9x_specialskipframe=0;
    if (os9x_fskipvalue==AUTO_FSKIP) Settings.SkipFrames=AUTO_FRAMERATE;
    else if (os9x_fskipvalue==SKEEZIX_FSKIP) 
    {
    	Settings.SkipFrames=0;
    	os9x_specialskipframe=1;
    }
    else Settings.SkipFrames=os9x_fskipvalue;


    // ROM image and peripheral options
    Settings.ForceSuperFX = false;
    Settings.ForceNoSuperFX = false;
    Settings.MultiPlayer5 = true;
    Settings.Mouse = true;
    Settings.SuperScope = true;
    Settings.MultiPlayer5Master = true;
    Settings.SuperScopeMaster = true;
    Settings.MouseMaster = true;
    Settings.SuperFX = false;
 
    // SNES graphics options
    Settings.BGLayering = false;
    Settings.DisableGraphicWindows = false;
    Settings.ForceTransparency = false;
    Settings.ForceNoTransparency = false;
    Settings.DisableHDMA = os9x_DisableHDMA;
    Settings.Mode7Interpolate = false;
    Settings.DisplayFrameRate = false;
    
    Settings.SixteenBit = 1;
    Settings.Transparency = 1;
    Settings.SupportHiRes = false;

    Settings.AutoSaveDelay = 0;
    Settings.ApplyCheats = true;

    Settings.TurboMode = false;
    Settings.TurboSkipFrames = 15;
    Settings.AutoMaxSkipFrames = 10;

    Settings.Port = 1996;


framecpto=0;

  Settings.ForcedPause = 0;
  Settings.StopEmulation = TRUE;
  Settings.Paused = FALSE;
     
  
  Settings.HBlankStart = (256 * Settings.H_Max) / SNES_HCOUNTER_MAX;
  
//  S9xMessage(0,0,"Init Memory");


  if (!Memory.Init ())
    OutOfMemory ();
          
//  S9xMessage(0,0,"Init Display");


  S9xInitDisplay ();
  

//  S9xMessage(0,0,"Init Graphics");


  if (!S9xGraphicsInit ())
    OutOfMemory ();
        
//  S9xMessage(0,0,"Init APU");

  if (!S9xInitAPU())
    OutOfMemory ();
        
//  S9xMessage(0,0,"Init Sound");


  S9xInitSound (Settings.SoundPlaybackRate, Settings.Stereo,Settings.SoundBufferSize);
  if (!Settings.APUEnabled)
	
    {
//      S9xMessage(0,0,"Sound off\n");
      S9xSetSoundMute (TRUE);
    }
  uint32 saved_flags = CPU.Flags;
  
  /*************************/
  /*debug*/    
  DBG_BREAK
    /*************************/

  if (rom_filename)
    {      
//      S9xMessage(0,0,rom_filename);	  
	  sprintf(strload,"Loading : %s",shortrom_filename);
      menu_message(strload);
//	unsigned long freeM,maxM;	
//	MemHeapFreeBytes(0,&freeM,&maxM);
//	StrPrintF(strload,"mem : %d %d",freeM,maxM);
//	menu_message(strload);
//	menu_waitPen(NULL,NULL,1);

      if (!Memory.LoadROM (rom_filename))
		{
	      menu_message("Could not load ROM");
	      menu_waitPen(NULL,NULL,1);
	      Snes_Close_ROM();
	      return -1;
	    }
	
		
	  /*************************/
  /*debug*/
  DBG_BREAK
    /*************************/		  
	  S9xGetSaveFilename (".srm",sram_filename);	  
	  Memory.LoadSRAM (sram_filename);
        //S9xLoadCheatFile (S9xGetFilename (".cht"));      
#ifdef TESTING_LOADQUICKATSTART
        os9x_load(".za0");
#endif        
    }
  else
    {
      S9xReset ();
      Settings.Paused |= 2;
    }
       
    
  CPU.Flags = saved_flags;
    
  if (Settings.APUEnabled) S9xSetSoundMute (FALSE);

  if (Settings.PAL) Settings.FrameTime=Settings.FrameTimePAL;
  else Settings.FrameTime=Settings.FrameTimeNTSC;

  int curtime=os9x_time();

  /*last init before start (needed to be done after S9xReset*/
  PPU.BG_Forced=os9x_BG_Forced;

  Snes9X_Start();

  //Snes_Close_ROM();
  return(0);
}

void S9xParseArg (char **argv, int &index, int argc)
{	
}

//START_EXTERN_C

void os9x_changerendering(void)
{
	os9x_renderingmode++;	
	if (os9x_renderingmode>6) os9x_renderingmode=0;
#ifdef __SYS_FRIENDLY__	
	if (os9x_renderingmode==3) StatHide();
	if (os9x_renderingmode==0) StatShow();
#endif	
	menu_message("Changing screen mode");
	int i=os9x_getTickCount();
	while ((os9x_getTickCount()-i)<300)
	{
	}
}

int os9x_setupenv(TwGfxType* mGfxLib)
{
  os9x_mGfxLib=mGfxLib;  
  os9x_screen_h=320;
  os9x_screen_w=480;
  return 0;
}

void os9x_setScreenWH(int w,int h)
{
	os9x_screen_h=h;
	os9x_screen_w=w;
}

int os9x_TwInit(void)
{
  TwGfxSurfaceInfoType surfInfo;

  surfInfo.size = sizeof(surfInfo);
  surfInfo.width = 320;
  surfInfo.height = 320;
  surfInfo.location = twGfxLocationAcceleratorMemoryNoBackingStore;
  surfInfo.pixelFormat = twGfxPixelFormatRGB565;
  xassert(TwGfxAllocSurface(os9x_mGfxLib, &os9x_RenderingScreen[0], &surfInfo));
  surfInfo.size = sizeof(surfInfo);
  surfInfo.width = 320;
  surfInfo.height = 320;
  surfInfo.location = twGfxLocationAcceleratorMemoryNoBackingStore;
  surfInfo.pixelFormat = twGfxPixelFormatRGB565;
  xassert(TwGfxAllocSurface(os9x_mGfxLib, &os9x_RenderingScreen[1], &surfInfo));
  
  TwGfxRectType mClearRect;
  mClearRect.x=0;
  mClearRect.y=0;
  mClearRect.w=320;
  mClearRect.h=320;
  TwGfxFillRect(os9x_RenderingScreen[0],&mClearRect, TwGfxDisplayRGBToPackedRGB(0));
  TwGfxFillRect(os9x_RenderingScreen[1],&mClearRect, TwGfxDisplayRGBToPackedRGB(0));


/*  if (os9x_softrendering)
  {
  }
  else*/
  {
	  surfInfo.size = sizeof(surfInfo);
	  surfInfo.width = 32;
	  surfInfo.height = 32;
	  surfInfo.location = twGfxLocationAcceleratorMemoryNoBackingStore;
	  surfInfo.pixelFormat = twGfxPixelFormatRGB565;
	  xassert(TwGfxAllocSurface(os9x_mGfxLib, &os9x_tmpRenderingScreen, &surfInfo));

	  //TILE_2BIT, MAX_TILE is 4096=64x64
	  surfInfo.size = sizeof(surfInfo);
	  surfInfo.width = 64*8; 
	  surfInfo.height = 64*8;
	  surfInfo.location = twGfxLocationAcceleratorMemoryNoBackingStore;
	  surfInfo.pixelFormat = twGfxPixelFormatRGB565;
	  xassert(TwGfxAllocSurface(os9x_mGfxLib, &os9x_tileCaches[TILE_2BIT], &surfInfo));
	  //TILE_4BIT, MAX_TILE is 2048=64x32
	  surfInfo.size = sizeof(surfInfo);
	  surfInfo.width = 64*8; 
	  surfInfo.height = 32*8;
	  surfInfo.location = twGfxLocationAcceleratorMemoryNoBackingStore;
	  surfInfo.pixelFormat = twGfxPixelFormatRGB565;
	  xassert(TwGfxAllocSurface(os9x_mGfxLib, &os9x_tileCaches[TILE_4BIT], &surfInfo));
	  //TILE_8BIT, MAX_TILE is 1024=64x16
	  surfInfo.size = sizeof(surfInfo);
	  surfInfo.width = 64*8; 
	  surfInfo.height = 16*8;
	  surfInfo.location = twGfxLocationAcceleratorMemoryNoBackingStore;
	  surfInfo.pixelFormat = twGfxPixelFormatRGB565;
	  xassert(TwGfxAllocSurface(os9x_mGfxLib, &os9x_tileCaches[TILE_8BIT], &surfInfo));
	  if (TwGfxLockSurface(os9x_tileCaches[TILE_2BIT], (void**)&os9x_tileCachesPtr[TILE_2BIT]))
	  {
		  //err
		  return 1;
	  }
	  if (TwGfxLockSurface(os9x_tileCaches[TILE_4BIT], (void**)&os9x_tileCachesPtr[TILE_4BIT]))
	  {
		  //err
		  return 2;
	  }
	  if (TwGfxLockSurface(os9x_tileCaches[TILE_8BIT], (void**)&os9x_tileCachesPtr[TILE_8BIT]))
	  {
		  //err
		  return 3;	  	  
	  }
	  
	  tmp_sprBitmap.size = sizeof(TwGfxBitmapType);  
	  tmp_sprBitmap.width=32;
	  tmp_sprBitmap.height=32;
	  tmp_sprBitmap.rowBytes=4;//32/2;//((tmp_sprBitmap.width/8)>=4?tmp_sprBitmap.width/8:4);
	  tmp_sprBitmap.pixelFormat=twGfxPixelFormatMonochrome;//Monochrome;
	  tmp_sprBitmap.data=ljz_malloc(tmp_sprBitmap.height*tmp_sprBitmap.rowBytes);  
	  memset(tmp_sprBitmap.data,0,tmp_sprBitmap.height*tmp_sprBitmap.rowBytes);  
  }
  if (TwGfxLockSurface(os9x_RenderingScreen[0], (void**)&os9x_RenderingScreenPtr[0]))
  {
	  //err
	  return 4;
  }
  if (TwGfxLockSurface(os9x_RenderingScreen[1], (void**)&os9x_RenderingScreenPtr[1]))
  {
	  //err
	  return 5;
  }
  
	        
  TwInputOpen(&os9x_mInputQueue, "twinput", "r");
  os9x_mInputFormat = (Int32*)ljz_malloc(sizeof(Int32)*sizeof(os9x_inputFormats)/sizeof(os9x_inputFormats[0]));
  memmove(os9x_mInputFormat, os9x_inputFormats, sizeof(os9x_inputFormats));
  TwInputSetFormat(os9x_mInputQueue, os9x_mInputFormat, sizeof(os9x_inputFormats));    
  TwInputActivate(os9x_mInputQueue);
  
  
  return 0;
}

void os9x_TwDeInit(void)
{
/*  if (!os9x_softrendering)
  {*/
	  TwGfxUnlockSurface(os9x_tileCaches[TILE_2BIT],0);
	  TwGfxUnlockSurface(os9x_tileCaches[TILE_4BIT],0);
	  TwGfxUnlockSurface(os9x_tileCaches[TILE_8BIT],0);
	  
	  if (os9x_tileCaches[TILE_2BIT]) TwGfxFreeSurface(os9x_tileCaches[TILE_2BIT]);
	  if (os9x_tileCaches[TILE_4BIT]) TwGfxFreeSurface(os9x_tileCaches[TILE_4BIT]);
	  if (os9x_tileCaches[TILE_8BIT]) TwGfxFreeSurface(os9x_tileCaches[TILE_8BIT]);  
	  
	  if (os9x_tmpRenderingScreen) TwGfxFreeSurface(os9x_tmpRenderingScreen);
	  
	  if (tmp_sprBitmap.data) ljz_free(tmp_sprBitmap.data);
//  }
  if (os9x_RenderingScreen[0]) TwGfxFreeSurface(os9x_RenderingScreen[0]);
  if (os9x_RenderingScreen[1]) TwGfxFreeSurface(os9x_RenderingScreen[1]);
  
  
  
  
  TwInputClose(os9x_mInputQueue);  	
  ljz_free(os9x_mInputFormat);
}

int os9x_loadrom(void)
{   
  ljz_std_showstat();  
/*  char str[64];
  unsigned long maxP,freeP;
  MemHeapFreeBytes(0,&freeP,&maxP);
  sprintf(str,"RAM Free:%d Max:%d");
  menu_message(str);menu_waitPen(NULL,NULL,1);*/
  
  
  
  int val;
  FtrGet(APPLI_ID,FTR_OPT_SNESRENDER_ID,(unsigned long*)&val);
  if (val>2) val=0;
  os9x_softrendering=val;    

  char *ftrptr;
/*#ifdef __MWERKS__
  strcat(rom_filename,"/");
#else
  strcat(rom_filename,"\\");
#endif*/
  FtrGet(APPLI_ID,FTR_ROM_FILENAME_ID ,(unsigned long*)&ftrptr);
  
  os9x_curVolume=ftrptr[0];
  
  
  strcpy(os9x_romsdir,OS9X_ROMSDIR);
  os9x_romsdir[0]=os9x_curVolume+'0';  
  strcpy(os9x_savesdir,OS9X_SAVESDIR);
  os9x_savesdir[0]=os9x_curVolume+'0';
  
  strcpy(rom_filename,os9x_romsdir);      

  ftrptr+=3;
  strcpy(shortrom_filename,ftrptr);  
  char *p=StrChr(shortrom_filename,'.');
  char *q;
  q=p;
  while (p)
  {
  	q=p;
  	p=StrChr(p+1,'.');
  }
  *q=0;
                           
  if (StrCaselessCompare(q+1, "spc") == 0)
  {
//	  	menu_message("SPC FILE");
  	strcpy (g_filename, os9x_romsdir);
	strcat (g_filename, shortrom_filename);
	strcat (g_filename, ".spc");
  	OSPC_Play(g_filename);
  	return 1;
  }
    
  strcat(rom_filename,ftrptr);
    
  FtrPtrFree(APPLI_ID, FTR_ROM_FILENAME_ID);      

  vrambuffer = (uint8*)ljz_malloc(256*240*2);        
  if (!os9x_TwInit()) return os9x_Init();     
  else return -1;  
}

void os9x_updatevpad(uint32 val)
{
	os9x_vpad=val;
}

void os9x_end(void)
{		
#ifdef TESTING  
  close_logop();
#endif    
//wait for potential gfx job to finish
	TwGfxSurfaceType* displaySurface;
	// Get palmos display surface:
	xassert(TwGfxGetPalmDisplaySurface(os9x_mGfxLib, &displaySurface));
	while (TwGfxIsSurfaceReady(displaySurface));	


	os9x_pause(1);
	Snes_Close_ROM();
	ljz_free(vrambuffer);
	

	os9x_TwDeInit();
	
	int val;
	
	if ((os9x_renderingmode)&&(!(os9x_renderingmode&1))) FtrSet(APPLI_ID, FTR_OPT_SMOOTHING_ID,1);
	else FtrSet(APPLI_ID, FTR_OPT_SMOOTHING_ID,0);	
	
	 FtrSet(APPLI_ID,FTR_OPT_CPUCORE_ID,  os9x_asmcpu);  


	FtrSet(APPLI_ID, FTR_OPT_SOUND_ID,os9x_soundenabled);
	switch (os9x_sndFrequency)
	{
		case 11025:val=2;break;
		case 22050:val=1;break;
		default:val=0;break;
	}
	FtrSet(APPLI_ID, FTR_OPT_SOUNDFREQ_ID,val);
	
	FtrSet(APPLI_ID, FTR_OPT_SCREENMODE_ID,((os9x_renderingmode+1)>>1));
	
	FtrSet(APPLI_ID, FTR_OPT_FSKIP_ID,os9x_fskipvalue);
	
	FtrSet(APPLI_ID, FTR_OPT_FAST_SPR_ID, os9x_fastsprite);
	FtrSet(APPLI_ID, FTR_OPT_SNESRENDER_ID,os9x_softrendering);
	FtrSet(APPLI_ID, FTR_OPT_SNESTRANSP_ID,(os9x_ShowSub==4));


/*	char str[64];
	unsigned long maxP,freeP;
	MemHeapFreeBytes(0,&freeP,&maxP);
	sprintf(str,"RAM Free:%d Max:%d");
	menu_message(str);menu_waitPen(NULL,NULL,1);*/
	ljz_std_showstat();
}

void os9x_pause(int pause)
{
	if (pause)
	{
		if ((os9x_soundenabled==2)&&(snd_stream))
		{
			SndStreamStop(snd_stream);
			SndStreamDelete(snd_stream);
		}			
		S9xSetSoundMute (TRUE);		
	}
	else
	{		
		S9xSetSoundMute (FALSE);				
		if (os9x_soundenabled==2) 
		{
			SndStreamCreate(&snd_stream,sndOutput,os9x_sndFrequency,(os9x_snd16bits?sndInt16Little:sndUInt8),(os9x_sndStereo?sndStereo:sndMono),os9x_sndCallBack,&reg_sys,os9x_sndBuffsize);
			SndStreamStart(snd_stream);
		}
		os9x_frameBeginTime=os9x_getTickCount()+Settings.FrameTime*100/os9x_speedpct;
	}
}

void os9x_changefskip(void)
{
	os9x_fskipvalue++;	
	if (os9x_fskipvalue>SKEEZIX_FSKIP) os9x_fskipvalue=0;
	
	os9x_specialskipframe=0;
	if (os9x_fskipvalue==AUTO_FSKIP) Settings.SkipFrames=AUTO_FRAMERATE;
    else if (os9x_fskipvalue==SKEEZIX_FSKIP) 
    {
    	Settings.SkipFrames=0;
    	os9x_specialskipframe=1;
    }
    else Settings.SkipFrames=os9x_fskipvalue;
	
	char tmp[64];
	if (os9x_fskipvalue==AUTO_FSKIP) sprintf(tmp,"Frameskip : AUTO");
	else if (os9x_fskipvalue==SKEEZIX_FSKIP) sprintf(tmp,"Frameskip : SKEEZIX");
	else sprintf(tmp,"Frameskip : %d",Settings.SkipFrames);	
	
	menu_message(tmp);
	int i=os9x_getTickCount();
	while ((os9x_getTickCount()-i)<300)
	{
	}
	
	
	os9x_frameBeginTime=os9x_getTickCount()+Settings.FrameTime*100/os9x_speedpct;
}
//END_EXTERN_C

/*void os9x_checksnap(void)
{
	   FILE *savefile;
	  int snap_exist=0;

	  S9xGetSaveFilename (".za0",sram_filename);   	  	  	
	  savefile=fopen(sram_filename,"rb");	  
	  if (savefile) {snap_exist=1;fclose(savefile);}
	  else snap_exist=0;
	  if (snap_exist)
	  {
		  if (!FrmAlert(FrmAlertLoadState))
		  {		  			  
			strcpy (tmp_filename, os9x_savesdir);
		  	strcat (tmp_filename, "tmp.xxx");  
		  	menu_message("Unzipping");
			os9x_stateuncompress(sram_filename,tmp_filename);
			menu_message("Loading");
			S9xUnfreezeGame(tmp_filename);			
			remove(tmp_filename);
		  }
		  else snap_exist=0;	  
	  }
}*/


/*********************/

char *os9x_getfilename(char *ext)
{
	return (char*)S9xGetFilename (ext);
}


/*********************/
/*********************/
/*********************/
int os9x_ShowMenuGFXConfig(uint8 *savescr)
{
  uint8 *scr;
  int x,y;
  int redraw;  
  int result;
  int scrmode,smoothing,fskipval;
  RectangleType *item_rect;
  item_rect=(RectangleType*)ljz_malloc(21*sizeof(RectangleType));
  char tmp[16];
  

	
	if (!os9x_renderingmode) {scrmode=0;smoothing=0;}
	else {scrmode=(os9x_renderingmode+1)>>1;smoothing=!(os9x_renderingmode&1);}

  fskipval=os9x_fskipvalue;

	    
  redraw=1;         
  for (;;)
  {  
  	  if (redraw)
  	  {
  	  	redraw=0;
  	  	scr=WinScreenLock(winLockCopy);
	    if (scr&&savescr) memcpy(scr,savescr,480*320*2);	    
		//if (scr) WinScreenUnlock();
  	  	RGBColorType fg;
	  	WinPushDrawState ();
  	  	WinSetDrawMode(winOverlay);
    	fg.r=50;fg.g=200;fg.b=50;
	    WinSetTextColorRGB(&fg,NULL);
	    WinSetForeColorRGB(&fg,NULL);
	    FntSetFont(boldFont);
		WinPaintChars(LJZ_OSD_TITLE,strlen(LJZ_OSD_TITLE),10,10);	
		WinPopDrawState();
		
		menu_button(310,20,(char*)"BACK",6,&item_rect[0],2);
	  	menu_button(10,80,(char*)"GFX ENGINE",0,&item_rect[1],2);
	  	menu_button(200,80,(char*)"HW",(!os9x_softrendering?2:1),&item_rect[2],0);
	  	menu_button(250,80,(char*)"SW1",(os9x_softrendering==1?2:1),&item_rect[3],0);
	  	menu_button(300,80,(char*)"SW2",(os9x_softrendering==2?2:1),&item_rect[4],0);
	  	menu_button(10,120,(char*)"TRANSPARENCY",0,&item_rect[5],2);
	  	menu_button(200,120,(char*)"OFF",((os9x_softrendering==2)|(os9x_ShowSub==4)?1:2),&item_rect[6],0);
	  	menu_button(250,120,(char*)"ON",((os9x_softrendering==2)|(os9x_ShowSub==4)?2:1),&item_rect[7],0);	  
	  	menu_button(10,160,(char*)"FAST SPRITES",0,&item_rect[8],2);	 
	  	menu_button(200,160,(char*)"OFF",(os9x_fastsprite==0?2:1),&item_rect[9],0);	 
	  	menu_button(250,160,(char*)"ON",(os9x_fastsprite?2:1),&item_rect[10],0);	 
	  
	  	menu_button(10,200,(char*)"FRAMESKIP",0,&item_rect[11],2);	  
	  	menu_bar(200,200,fskipval,11,&item_rect[12]);
	  	if (fskipval<10) sprintf(tmp,"%d",fskipval);
	  	else if (fskipval==10) sprintf(tmp,"AUTO");
	  	else sprintf(tmp,"Skeezix");
	  	menu_messageRaw(320,200,tmp);
	  
	  	menu_button(10,240,(char*)"SCREENMODE",0,&item_rect[13],2);
	  	menu_button(200,240,(char*)"1:1",(scrmode==0?2:1),&item_rect[14],0);
	  	menu_button(250,240,(char*)"4:3",(scrmode==1?2:1),&item_rect[15],0);
	  	menu_button(300,240,(char*)"FULL",(scrmode==2?2:1),&item_rect[16],0);
	  	menu_button(350,240,(char*)"ZOOM",(scrmode==3?2:1),&item_rect[17],1);
	  
	  	menu_button(10,280,(char*)"SMOOTHING",0,&item_rect[18],2);
	  	menu_button(200,280,(char*)"OFF",(smoothing?1:2),&item_rect[19],0);
	  	menu_button(250,280,(char*)"ON",(smoothing?2:1),&item_rect[20],0);	  	  	  
	  	
	  	if (scr) WinScreenUnlock();
	
  	  }
	  menu_waitPen(&x,&y,0);
	  
	  
	  //BACK	  
	  if (TEST_PEN_MENU(x,y,item_rect[0])) {result=0;break;}
	  //GFX ENGINE 
	  //HW
	  if (TEST_PEN_MENU(x,y,item_rect[2])) 
	  {
	  	redraw=1;os9x_softrendering=0;os9x_ShowSub=0;
	  	ZeroMemory (IPPU.TileCached [TILE_2BIT], (MAX_2BIT_TILES+MAX_4BIT_TILES+MAX_8BIT_TILES)<<1);
    	S9xInitUpdate();
		S9xReschedule ();
	  }
	  //SW Fast
	  if (TEST_PEN_MENU(x,y,item_rect[3])) 
	  {
	  	redraw=1;os9x_softrendering=1;
	  	ZeroMemory (IPPU.TileCached [TILE_2BIT], (MAX_2BIT_TILES+MAX_4BIT_TILES+MAX_8BIT_TILES)<<1);
    	S9xInitUpdate();
    	S9xReschedule ();
	  }
	  //SW Exact
	  if (TEST_PEN_MENU(x,y,item_rect[4])) 
	  {
	  	redraw=1;os9x_softrendering=2;os9x_fastsprite=0;
	  	ZeroMemory (IPPU.TileCached [TILE_2BIT], (MAX_2BIT_TILES+MAX_4BIT_TILES+MAX_8BIT_TILES)<<1);
    	S9xInitUpdate();
    	S9xReschedule ();
	  }
	  //TRANSPARENCY OFF
	  if (TEST_PEN_MENU(x,y,item_rect[6])&&(os9x_softrendering==1)) 
	  {
		  os9x_ShowSub=0;
		  redraw=1;
	  }
	  //TRANSPARENCY ON
	  if (TEST_PEN_MENU(x,y,item_rect[7])&&(os9x_softrendering==1)) 
	  {
	  	  os9x_ShowSub=4;
	  	  redraw=1;
	  }
	  //FASTSPRITES OFF
	  if (TEST_PEN_MENU(x,y,item_rect[9])&&(os9x_softrendering<2)) 
	  {
	  	  os9x_fastsprite=0;
	  	  redraw=1;
	  }
	  //FASTSPRITES ON
	  if (TEST_PEN_MENU(x,y,item_rect[10])&&(os9x_softrendering<2)) 
	  {
	  	  os9x_fastsprite=1;
	  	  redraw=1;
	  }
	  //FSKIP
	  if (TEST_PEN_MENU(x,y,item_rect[12])) 
	  {
	  	fskipval=(x-10-item_rect[12].topLeft.x)*11/100;
	  	if (fskipval<0) fskipval=0;
	  	if (fskipval>11) fskipval=11;
	  	redraw=1;
	  }
	  //SCREEN MODES
	  if (TEST_PEN_MENU(x,y,item_rect[14])) 
	  {
	  	  scrmode=0;
	  	  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[15])) 
	  {
	  	  scrmode=1;
	  	  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[16])) 
	  {
	  	  scrmode=2;
	  	  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[17])) 
	  {
	  	  scrmode=3;
	  	  redraw=1;
	  }
	  //SMOOTHING
	  if (TEST_PEN_MENU(x,y,item_rect[19])&&scrmode) 
	  {
	  	  smoothing=0;
	  	  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[20])&&scrmode) 
	  {
	  	  smoothing=1;
	  	  redraw=1;
	  }
  }  
  
  os9x_fskipvalue=fskipval;

  os9x_specialskipframe=0;
  if (os9x_fskipvalue==AUTO_FSKIP) Settings.SkipFrames=AUTO_FRAMERATE;
  else if (os9x_fskipvalue==SKEEZIX_FSKIP) 
  {
	Settings.SkipFrames=0;
    os9x_specialskipframe=1;
  }
  else Settings.SkipFrames=os9x_fskipvalue;
  
  if (!scrmode) os9x_renderingmode=0;
	else 
	if (scrmode==1) os9x_renderingmode=(smoothing?2:1);
	else
	if (scrmode==2) os9x_renderingmode=(smoothing?4:3);
	else
	os9x_renderingmode=(smoothing?6:5);
  
  
  menu_waitPen(NULL,NULL,2);
  
  ljz_free(item_rect);
  return result;
}

int os9x_ShowMenuSNDConfig(uint8 *savescr)
{
  uint8 *scr;
  int x,y;
  int redraw;  
  int result;
  int vol;
  int bassboost;
  RectangleType *item_rect;
  char tmp[16];
  item_rect=(RectangleType*)ljz_malloc(15*sizeof(RectangleType));
  
  vol=TwSndGetVolume();
  bassboost=TwSndGetBassBoost();
	    
  redraw=1;         
  for (;;)
  {  
  	  if (redraw)
  	  {
  	  	redraw=0;
  	  	scr=WinScreenLock(winLockCopy);  
	    if (scr&&savescr) memcpy(scr,savescr,480*320*2);	    
		//if (scr) WinScreenUnlock();
  	  	RGBColorType fg;
	  	WinPushDrawState ();
  	  	WinSetDrawMode(winOverlay);
    	fg.r=50;fg.g=200;fg.b=50;
	    WinSetTextColorRGB(&fg,NULL);
	    WinSetForeColorRGB(&fg,NULL);
	    FntSetFont(boldFont);
		WinPaintChars(LJZ_OSD_TITLE,strlen(LJZ_OSD_TITLE),10,10);	
		WinPopDrawState();
		
		menu_button(310,20,(char*)"BACK",6,&item_rect[0],2);	  
		menu_button(10,80,(char*)"SOUND",0,&item_rect[1],2);
		menu_button(200,80,(char*)"OFF",(os9x_soundenabled==0?2:1),&item_rect[2],0);
		menu_button(250,80,(char*)"SIM",(os9x_soundenabled==1?2:1),&item_rect[3],0);	  
		menu_button(300,80,(char*)"ON",(os9x_soundenabled==2?2:1),&item_rect[4],0);	 
	  
/*		menu_button(10,120,(char*)"VOLUME",0,&item_rect[5],2);	  
		menu_bar(200,120,vol,64,&item_rect[6]);		
		sprintf(tmp,"%d%",vol*100/64);	  	
	  	menu_messageRaw(320,120,tmp);*/
	  
		menu_button(10,160,(char*)"BASS BOOST",0,&item_rect[7],2);
		menu_button(200,160,(char*)"OFF",(bassboost==0?2:1),&item_rect[8],0);
		menu_button(300,160,(char*)"ON",(bassboost?2:1),&item_rect[9],0);	 
	  
		if (scr) WinScreenUnlock();
  	  }
	  menu_waitPen(&x,&y,0);
	  
	  
	  //BACK	  
	  if (TEST_PEN_MENU(x,y,item_rect[0])) {result=0;break;}	  
	  //SOUND OFF
	  if (TEST_PEN_MENU(x,y,item_rect[2])) 
	  {	  	  
		  Settings.NextAPUEnabled = Settings.APUEnabled=os9x_apuenabled=os9x_soundenabled=0;		  
		  CPU.APU_APUExecuting=0;
		  redraw=1;
	  }
	  //SOUND SIM
	  if (TEST_PEN_MENU(x,y,item_rect[3])) 
	  {
	  	  if (!os9x_soundenabled)
	  	  {
	  	  	if (menu_confirm("RESET needed. Continue ?")) S9xReset();
	  	  }
	  	  Settings.NextAPUEnabled = Settings.APUEnabled=os9x_apuenabled=os9x_soundenabled=1;	  	  
	  	  redraw=1;
	  }
	  //SOUND ON
	  if (TEST_PEN_MENU(x,y,item_rect[4])) 
	  {
		  if (!os9x_soundenabled)
	  	  {
	  	  	if (menu_confirm("RESET needed. Continue ?")) S9xReset();
	  	  }
		  Settings.NextAPUEnabled = Settings.APUEnabled=os9x_apuenabled=os9x_soundenabled=2;
		  redraw=1;
	  }
	  
	  //VOLUME
/*	  if (TEST_PEN_MENU(x,y,item_rect[6])) 
	  {
	  	vol=(x-item_rect[6].topLeft.x)*64/100;
	  	if (vol>64) vol=64;
	  	redraw=1;
	  }*/
	  //BASSBOOST OFF
	  if (TEST_PEN_MENU(x,y,item_rect[8])) 
	  {
	  	bassboost=0;
	  	redraw=1;
	  }
	  //BASSBOOST ON
	  if (TEST_PEN_MENU(x,y,item_rect[9])) 
	  {
	  	bassboost=1;
	  	redraw=1;
	  }
  }  
  
  TwSndSetVolume(vol);
  TwSndSetBassBoost(bassboost);
  
  menu_waitPen(NULL,NULL,2);
  
  ljz_free(item_rect);
  return result;
}

int os9x_ShowMenuOTHERConfig(uint8 *savescr)
{
  uint8 *scr;
  int x,y;
  int redraw;  
  int result;
  RectangleType *item_rect;
  char tmp[16];
  item_rect=(RectangleType*)ljz_malloc(36*sizeof(RectangleType));
  
  redraw=1;         
  for (;;)
  {  
  	  if (redraw)
  	  {
  	  	redraw=0;
  	  	scr=WinScreenLock(winLockCopy);  
	    if (scr&&savescr) memcpy(scr,savescr,480*320*2);	    
  	  	RGBColorType fg;
	  	WinPushDrawState ();
  	  	WinSetDrawMode(winOverlay);
    	fg.r=50;fg.g=200;fg.b=50;
	    WinSetTextColorRGB(&fg,NULL);
	    WinSetForeColorRGB(&fg,NULL);
	    FntSetFont(boldFont);
		WinPaintChars(LJZ_OSD_TITLE,strlen(LJZ_OSD_TITLE),10,10);	
		WinPopDrawState();
  	
  		
  	  	  	  	  	  	
	  menu_button(310,20,(char*)"BACK",6,&item_rect[0],2);	  
	  menu_button(10,50,(char*)"AUTOFIRE A",0,&item_rect[1],2);
	  menu_button(200,50,(char*)"OFF",(os9x_autofireA==0?2:1),&item_rect[2],0);
	  menu_button(250,50,(char*)"SLW",(os9x_autofireA==1?2:1),&item_rect[3],0);
	  menu_button(300,50,(char*)"MED",(os9x_autofireA==2?2:1),&item_rect[4],0);
	  menu_button(350,50,(char*)"FST",(os9x_autofireA==3?2:1),&item_rect[5],0);	  
	  menu_button(10,80,(char*)"AUTOFIRE B",0,&item_rect[6],2);
	  menu_button(200,80,(char*)"OFF",(os9x_autofireB==0?2:1),&item_rect[7],0);
	  menu_button(250,80,(char*)"SLW",(os9x_autofireB==1?2:1),&item_rect[8],0);
	  menu_button(300,80,(char*)"MED",(os9x_autofireB==2?2:1),&item_rect[9],0);
	  menu_button(350,80,(char*)"FST",(os9x_autofireB==3?2:1),&item_rect[10],0);
	  menu_button(10,110,(char*)"AUTOFIRE X",0,&item_rect[11],2);
	  menu_button(200,110,(char*)"OFF",(os9x_autofireX==0?2:1),&item_rect[12],0);
	  menu_button(250,110,(char*)"SLW",(os9x_autofireX==1?2:1),&item_rect[13],0);
	  menu_button(300,110,(char*)"MED",(os9x_autofireX==2?2:1),&item_rect[14],0);
	  menu_button(350,110,(char*)"FST",(os9x_autofireX==3?2:1),&item_rect[15],0);
	  menu_button(10,140,(char*)"AUTOFIRE Y",0,&item_rect[16],2);
	  menu_button(200,140,(char*)"OFF",(os9x_autofireY==0?2:1),&item_rect[17],0);
	  menu_button(250,140,(char*)"SLW",(os9x_autofireY==1?2:1),&item_rect[18],0);
	  menu_button(300,140,(char*)"MED",(os9x_autofireY==2?2:1),&item_rect[19],0);
	  menu_button(350,140,(char*)"FST",(os9x_autofireY==3?2:1),&item_rect[20],0);
	  menu_button(10,170,(char*)"AUTOFIRE L",0,&item_rect[21],2);
	  menu_button(200,170,(char*)"OFF",(os9x_autofireL==0?2:1),&item_rect[22],0);
	  menu_button(250,170,(char*)"SLW",(os9x_autofireL==1?2:1),&item_rect[23],0);
	  menu_button(300,170,(char*)"MED",(os9x_autofireL==2?2:1),&item_rect[24],0);
	  menu_button(350,170,(char*)"FST",(os9x_autofireL==3?2:1),&item_rect[25],0);
	  menu_button(10,200,(char*)"AUTOFIRE R",0,&item_rect[26],2);
	  menu_button(200,200,(char*)"OFF",(os9x_autofireR==0?2:1),&item_rect[27],0);
	  menu_button(250,200,(char*)"SLW",(os9x_autofireR==1?2:1),&item_rect[28],0);
	  menu_button(300,200,(char*)"MED",(os9x_autofireR==2?2:1),&item_rect[29],0);
	  menu_button(350,200,(char*)"FST",(os9x_autofireR==3?2:1),&item_rect[30],0);
	  
	  menu_button(10,250,(char*)"EMU SPEED",0,&item_rect[31],2);	  
	  menu_bar(200,250,os9x_speedpct,100,&item_rect[32]);
	  sprintf(tmp,"%d%",os9x_speedpct);
    	menu_messageRaw(320,250,tmp);
    	
      menu_button(10,285,(char*)"CPU CORE",0,&item_rect[33],2);
 	  menu_button(200,285,(char*)"C",(os9x_asmcpu==0?2:1),&item_rect[34],0);
	  menu_button(250,285,(char*)"ASM",(os9x_asmcpu==1?2:1),&item_rect[35],0);
	  
		if (scr) WinScreenUnlock();	  
  	  }
	  menu_waitPen(&x,&y,0);
	  
	  
	  //BACK	  
	  if (TEST_PEN_MENU(x,y,item_rect[0])) {result=0;break;}	  
	  //AUTOFIRE A
	  if (TEST_PEN_MENU(x,y,item_rect[2])) 
	  {
		  os9x_autofireA=0;		  
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[3])) 
	  {
		  os9x_autofireA=1;
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[4])) 
	  {
		  os9x_autofireA=2;
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[5])) 
	  {
		  os9x_autofireA=3;
		  redraw=1;
	  }
	  //AUTOFIRE B
	  if (TEST_PEN_MENU(x,y,item_rect[7])) 
	  {
		  os9x_autofireB=0;		  
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[8])) 
	  {
		  os9x_autofireB=1;
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[9])) 
	  {
		  os9x_autofireB=2;
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[10])) 
	  {
		  os9x_autofireB=3;
		  redraw=1;
	  }
	  //AUTOFIRE X
	  if (TEST_PEN_MENU(x,y,item_rect[12])) 
	  {
		  os9x_autofireX=0;		  
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[13])) 
	  {
		  os9x_autofireX=1;
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[14])) 
	  {
		  os9x_autofireX=2;
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[15])) 
	  {
		  os9x_autofireX=3;
		  redraw=1;
	  }
	  //AUTOFIRE Y
	  if (TEST_PEN_MENU(x,y,item_rect[17])) 
	  {
		  os9x_autofireY=0;		  
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[18])) 
	  {
		  os9x_autofireY=1;
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[19])) 
	  {
		  os9x_autofireY=2;
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[20])) 
	  {
		  os9x_autofireY=3;
		  redraw=1;
	  }
	  //AUTOFIRE L
	  if (TEST_PEN_MENU(x,y,item_rect[22])) 
	  {
		  os9x_autofireL=0;		  
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[23])) 
	  {
		  os9x_autofireL=1;
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[24])) 
	  {
		  os9x_autofireL=2;
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[25])) 
	  {
		  os9x_autofireL=3;
		  redraw=1;
	  }
	  //AUTOFIRE R
	  if (TEST_PEN_MENU(x,y,item_rect[27])) 
	  {
		  os9x_autofireR=0;		  
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[28])) 
	  {
		  os9x_autofireR=1;
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[29])) 
	  {
		  os9x_autofireR=2;
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[30])) 
	  {
		  os9x_autofireR=3;
		  redraw=1;
	  }
	  //SPEED
	  if (TEST_PEN_MENU(x,y,item_rect[32])) 
	  {
	  	os9x_speedpct=(x-10-item_rect[32].topLeft.x);
	  	if (os9x_speedpct>100) os9x_speedpct=100;
	  	if (os9x_speedpct<10) os9x_speedpct=10;
	  	redraw=1;
	  }
	  //CPU CORE
	  if (TEST_PEN_MENU(x,y,item_rect[34])) 
	  {
		  if (menu_confirm("RESET needed. Continue ?")) 
		  {
			os9x_asmcpu=0;		  
		  	S9xReset();
		  }
		  
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[35])) 
	  {
		  if (menu_confirm("RESET needed. Continue ?")) 
		  {
			os9x_asmcpu=1;
		  	S9xReset();
		  }
		  redraw=1;
	  }
  }  
  
  menu_waitPen(NULL,NULL,2);
  
  ljz_free(item_rect);
  return result;
}


int os9x_save(char *ext)
{
	menu_message("Saving");		
/*	strcpy (tmp_filename, os9x_savesdir);
	strcat (tmp_filename, "tmp.xxx");  	*/
	S9xGetSaveFilename (ext,sram_filename);			
	S9xFreezeGame(/*tmp_filename*/sram_filename);
	/*menu_message("Zipping");					
	int res=os9x_statecompress(tmp_filename,sram_filename,NULL);	
	if (res)
	{
		char str[64];
		sprintf(str,"Error %d",res);
		menu_message(str);
		menu_waitPen(NULL,NULL,1);
	}
	remove(tmp_filename);*/
	return 0;
}



int os9x_load(char *ext)
{
	int snap_exist;
	FILE *savefile;
	S9xGetSaveFilename (ext,sram_filename);
	savefile=fopen(sram_filename,"rb");
  	if (savefile) 
  	{
  		fclose(savefile);
/*		strcpy (tmp_filename, os9x_savesdir);
	  	strcat (tmp_filename, "tmp.xxx");  
	  	menu_message("Unzipping");
		os9x_stateuncompress(sram_filename,tmp_filename);*/
		menu_message("Loading");
		S9xUnfreezeGame(sram_filename/*tmp_filename*/);					
//		remove(tmp_filename);		  
		S9xInitUpdate();
		S9xReschedule ();
		return 1;
	}
	return 0;
}


int os9x_loadzsnes(char *ext)
{
	int snap_exist;
	FILE *savefile;
	S9xGetSaveFilename (ext,sram_filename);
	savefile=fopen(sram_filename,"rb");
  	if (savefile) 
  	{
  		fclose(savefile);		
		S9xUnfreezeGame(sram_filename);
		S9xInitUpdate();
		S9xReschedule ();
		return 1;
	}
	return 0;
}


int os9x_ShowMenuSave(uint8 *savescr)
{
  uint8 *scr;
  int x,y;
  int redraw;  
  int result;
  RectangleType *item_rect;
   FILE *savefile;
  	  int slot[4];
  item_rect=(RectangleType*)ljz_malloc(15*sizeof(RectangleType));
  memset((char*)item_rect,0,15*sizeof(RectangleType));
	    
  redraw=1;         
  for (;;)
  {  
  	  if (redraw)
  	  {
  	  	redraw=0;
  	  	scr=WinScreenLock(winLockCopy);  
	    if (scr&&savescr) memcpy(scr,savescr,480*320*2);	    
		//if (scr) WinScreenUnlock();
  	  	RGBColorType fg;
	  	WinPushDrawState ();
  	  	WinSetDrawMode(winOverlay);
    	fg.r=50;fg.g=200;fg.b=50;
	    WinSetTextColorRGB(&fg,NULL);
	    WinSetForeColorRGB(&fg,NULL);
	    FntSetFont(boldFont);
		WinPaintChars(LJZ_OSD_TITLE,strlen(LJZ_OSD_TITLE),10,10);	
		WinPopDrawState();
  	
  		
  	  	  	  	  	  	
	 
  	  slot[0]=slot[1]=slot[2]=slot[3]=0;

	  
	  for (int i=0;i<4;i++)	  
	  {
	  		struct tm *localTime;
			time_t long_time;
			char str[255],str2[5];		
			sprintf(str2,".za%1d",i);
		    S9xGetSaveFilename (str2,sram_filename);		    
			savefile=fopen(sram_filename,"rb");
		    if (savefile) 
	  		{	
			  	slot[i]=1;
			  	fclose(savefile);	
			  	long_time=__getdate_file(sram_filename);		
				localTime = localtime(&long_time);
				//date is an ofs from 01 Jan 1900 00:00:00			
			sprintf(str,"%02d %s %02d %02d:%02d",
			localTime->tm_mday,str_month[localTime->tm_mon],localTime->tm_year-100,localTime->tm_hour,localTime->tm_min);
			if (i) 
			{
				menu_messageRaw(300,50+i*30,str);
				menu_button(160,50+i*30,"X",5,&item_rect[6+i],3);
			}
			else 
			{
				menu_messageRaw(300,170,str);
				menu_button(160,170,"X",5,&item_rect[6+i],3);
			}
		    }			 
			
	  	}	
  	  	  	  	  	  	
	  menu_button(310,20,(char*)"BACK",6,&item_rect[0],2);
	  menu_button(10,80,(char*)"SAVE",0,NULL,2);
	  menu_button(200,80,(char*)"SLOT 1",(slot[1]?2:1),&item_rect[2],1);
	  menu_button(200,110,(char*)"SLOT 2",(slot[2]?2:1),&item_rect[3],1);
	  menu_button(200,140,(char*)"SLOT 3",(slot[3]?2:1),&item_rect[4],1);
	  menu_button(200,170,(char*)"QUICK",(slot[0]?2:1),&item_rect[1],1);
	  
	  
	  
	  if (scr) WinScreenUnlock();
  	  }
	  menu_waitPen(&x,&y,1);
	  
	  	  if (TEST_PEN_MENU(x,y,item_rect[6])) 
	  {
	  	if (menu_confirm("Delete QUICKSLOT?"))
	  	{
			S9xGetSaveFilename (".za0",sram_filename);	
	  		remove(sram_filename);
	  	}
	  	redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[7])) 
	  {
	  	if (menu_confirm("Delete SLOT 1?"))
	  	{
			S9xGetSaveFilename (".za1",sram_filename);	
	  		remove(sram_filename);
	  	}
	  	redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[8])) 
	  {
	  	if (menu_confirm("Delete SLOT 2?"))
	  	{
		  	S9xGetSaveFilename (".za2",sram_filename);	
	  		remove(sram_filename);
	  	}
	  	redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[9])) 
	  {
	  	if (menu_confirm("Delete SLOT 3?"))
	  	{
		  	S9xGetSaveFilename (".za3",sram_filename);	
	  		remove(sram_filename);
	  	}
	  	redraw=1;
	  }
	  
	  //BACK	  
	  if (TEST_PEN_MENU(x,y,item_rect[0])) {result=0;break;}
	  //SAVE 0
	  if (TEST_PEN_MENU(x,y,item_rect[2]))
	  {
		  	if (!slot[1]||(menu_confirm("Overwrite ?")))
		  {os9x_save(".za1");result=1;  break;}
		  else redraw=1;
		
	  }
	  //SAVE 1
	  if (TEST_PEN_MENU(x,y,item_rect[3]))
	  {
		  	if (!slot[2]||(menu_confirm("Overwrite ?")))
		  {os9x_save(".za2");result=1; break;}
		  else redraw=1;
		 
	  }
	  //SAVE 2
	  if (TEST_PEN_MENU(x,y,item_rect[4]))
	  {
		  	if (!slot[3]||(menu_confirm("Overwrite ?")))
		  {os9x_save(".za3");result=1; break;}
		  else redraw=1;
		 
	  }
	  //QUICKSAVE
	  if (TEST_PEN_MENU(x,y,item_rect[1]))
	  {
    	  	if (!slot[0]||(menu_confirm("Overwrite ?")))
		  {os9x_save(".za0");result=1;  break;}
		  else redraw=1;
	  	  
		  result=1;
		
	  }
  }  
  ljz_free(item_rect);
  return result;
}



int os9x_ShowMenuLoad(uint8 *savescr)
{
  uint8 *scr;
  int x,y;
  int redraw;  
  int result;
  RectangleType *item_rect;
  item_rect=(RectangleType*)ljz_malloc(15*sizeof(RectangleType));
  memset((char*)item_rect,0,15*sizeof(RectangleType));
	    
  redraw=1;         
  for (;;)
  {  
  	  if (redraw)
  	  {
  	  	redraw=0;
  	  	scr=WinScreenLock(winLockCopy);  
	    if (scr&&savescr) memcpy(scr,savescr,480*320*2);	    
		//if (scr) WinScreenUnlock();
  	  	RGBColorType fg;
	  	WinPushDrawState ();
  	  	WinSetDrawMode(winOverlay);
    	fg.r=50;fg.g=200;fg.b=50;
	    WinSetTextColorRGB(&fg,NULL);
	    WinSetForeColorRGB(&fg,NULL);
	    FntSetFont(boldFont);
		WinPaintChars(LJZ_OSD_TITLE,strlen(LJZ_OSD_TITLE),10,10);	
		WinPopDrawState();
  	
  	  FILE *savefile;
  	  int slot[5];
  	  slot[0]=slot[1]=slot[2]=slot[3]=slot[4]=0;
      for (int i=0;i<5;i++)	  
	  {
	  		struct tm *localTime;
			time_t long_time;
			char str[255],str2[5];		
			if (i<4) sprintf(str2,".za%1d",i);
			else sprintf(str2,".zst");
		    S9xGetSaveFilename (str2,sram_filename);		    
			savefile=fopen(sram_filename,"rb");
		    if (savefile) 
	  		{	
			  	slot[i]=1;
			  	fclose(savefile);	
			  	long_time=__getdate_file(sram_filename);		
				localTime = localtime(&long_time);
				//date is an ofs from 01 Jan 1900 00:00:00			
				sprintf(str,"%02d %s %02d %02d:%02d",
				localTime->tm_mday,str_month[localTime->tm_mon],localTime->tm_year-100,localTime->tm_hour,localTime->tm_min);
				if (i) 
				{
					if (i<4)
					{
						menu_messageRaw(300,50+i*30,str);
						menu_button(160,50+i*30,"X",5,&item_rect[6+i],3);
					}
					else
					{
						menu_messageRaw(300,200,str);
						menu_button(160,200,"X",5,&item_rect[6+i],3);
					}
				}
				else 
				{
					menu_messageRaw(300,170,str);
					menu_button(160,170,"X",5,&item_rect[6+i],3);
				}
		    }			
	  	}	
	  menu_button(310,20,(char*)"BACK",6,&item_rect[0],2);
	  menu_button(10,80,(char*)"LOAD",0,NULL,2);
	  menu_button(200,80,(char*)"SLOT 1",(slot[1]?2:3),&item_rect[2],1);
	  menu_button(200,110,(char*)"SLOT 2",(slot[2]?2:3),&item_rect[3],1);
	  menu_button(200,140,(char*)"SLOT 3",(slot[3]?2:3),&item_rect[4],1);
	  menu_button(200,170,(char*)"QUICK",(slot[0]?2:3),&item_rect[1],1);
	  menu_button(200,200,(char*)"ZSNES",(slot[4]?2:1),&item_rect[5],1);	  
		
	  
	  if (scr) WinScreenUnlock();
  	  }
	  menu_waitPen(&x,&y,1);
	  
	  
	  if (TEST_PEN_MENU(x,y,item_rect[10])) 
	  {
	  	if (menu_confirm("Delete ZSNES?"))
	  	{
		  	S9xGetSaveFilename (".zst",sram_filename);	
	  		remove(sram_filename);
	  	}
	  	redraw=1;
	  }
	  
  	  if (TEST_PEN_MENU(x,y,item_rect[6])) 
	  {
	  	if (menu_confirm("Delete QUICKSLOT?"))
	  	{
		  	S9xGetSaveFilename (".za0",sram_filename);	
	  		remove(sram_filename);
	  	}
	  	redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[7])) 
	  {
	  	if (menu_confirm("Delete SLOT 1?"))
	  	{
		  	S9xGetSaveFilename (".za1",sram_filename);	
	  		remove(sram_filename);
	  	}
	  	redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[8])) 
	  {
	  	if (menu_confirm("Delete SLOT 2?"))
	  	{
		  	S9xGetSaveFilename (".za2",sram_filename);	
	  		remove(sram_filename);
	  	}
	  	redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[9])) 
	  {
	  	if (menu_confirm("Delete SLOT 3?"))
	  	{
		  	S9xGetSaveFilename (".za3",sram_filename);	
	  		remove(sram_filename);
	  	}
	  	redraw=1;
	  }
	  
	  //BACK	  
	  if (TEST_PEN_MENU(x,y,item_rect[0])) {result=0;break;}
	  
	  
	  //QUICKLOAD
	  if (TEST_PEN_MENU(x,y,item_rect[1]))
	  {
    	if (os9x_load(".za0")) {result=1;break;}
	  }
	  //LOAD 0
	  if (TEST_PEN_MENU(x,y,item_rect[2]))
	  {
		if (os9x_load(".za1")) {result=1;break;}
	  }
	  //LOAD 1
	  if (TEST_PEN_MENU(x,y,item_rect[3]))
	  {
		if (os9x_load(".za2")) {result=1;break;}
	  }
	  //LOAD 2
	  if (TEST_PEN_MENU(x,y,item_rect[4]))
	  {
		if (os9x_load(".za3")) {result=1;break;}	  
	  }
	
	  //QUICKLOAD
	  if (TEST_PEN_MENU(x,y,item_rect[1]))
	  {
    	if (os9x_load(".za0")) {result=1;break;}
	  }	  
	  //ZSNES
	  if (TEST_PEN_MENU(x,y,item_rect[5]))
	  {
    	if (os9x_loadzsnes(".zst")) {result=1;break;}
	  }
  }  
  ljz_free(item_rect);
  return result;
}


int os9x_ShowMenuConfig(uint8 *savescr)
{
  uint8 *scr;
  int x,y;
  int redraw;  
  int result;
  RectangleType *item_rect;
  item_rect=(RectangleType*)ljz_malloc(15*sizeof(RectangleType));
	    
  redraw=1;         
  for (;;)
  {  
  	  if (redraw)
  	  {
  	  	redraw=0;
  	  	scr=WinScreenLock(winLockCopy);  
	    if (scr&&savescr) memcpy(scr,savescr,480*320*2);	    
		//if (scr) WinScreenUnlock();
  	  	RGBColorType fg;
	  	WinPushDrawState ();
  	  	WinSetDrawMode(winOverlay);
    	fg.r=50;fg.g=200;fg.b=50;
	    WinSetTextColorRGB(&fg,NULL);
	    WinSetForeColorRGB(&fg,NULL);
	    FntSetFont(boldFont);
		WinPaintChars(LJZ_OSD_TITLE,strlen(LJZ_OSD_TITLE),10,10);	
		WinPopDrawState();
		
		menu_button(310,20,(char*)"BACK",6,&item_rect[0],2);	  
	  	menu_button(172,100,(char*)"GFX",0,&item_rect[1],2);
	  	menu_button(172,150,(char*)"SOUND",0,&item_rect[2],2);
	  	menu_button(172,200,(char*)"OTHER",0,&item_rect[3],2);	  
  	    menu_button(172,250,(char*)"SND & BRT",9,&item_rect[4],2);
	  	if (scr) WinScreenUnlock();
  	  }
	  menu_waitPen(&x,&y,1);
	  
	  
	  //BACK	  
	  if (TEST_PEN_MENU(x,y,item_rect[0])) {result=0;break;}	  
	  //GFX
	  if (TEST_PEN_MENU(x,y,item_rect[1])) 
	  {
	  	os9x_ShowMenuGFXConfig(savescr);
		redraw=1;
	  }
	  //SOUND
	  if (TEST_PEN_MENU(x,y,item_rect[2])) 
	  {
     	os9x_ShowMenuSNDConfig(savescr);
		redraw=1;
	  }
	  //OTHER
	  if (TEST_PEN_MENU(x,y,item_rect[3])) 
	  {	  	  		  
		  os9x_ShowMenuOTHERConfig(savescr);
		  redraw=1;
	  }
	  //SND & BRT
	  if (TEST_PEN_MENU(x,y,item_rect[4]))
	  {
	  	  EventType myevent;
	  	  
	  	  for (;;)	  	  
	  	  {
		  	  EvtGetEvent(&myevent,0);
	  	  	  if (myevent.eType==nilEvent) break;			  
		  }
	  	  
	  	  myevent.eType=keyDownEvent;
	  	  myevent.data.keyDown.chr=vchrBrightness;	  	  
	  	  EvtAddEventToQueue(&myevent);
	  	  
	  	  for (;;)	  	  
	  	  {
		  	  EvtGetEvent(&myevent,100);
	  	  	  if (myevent.eType==nilEvent) break;
			  if (myevent.eType==keyDownEvent)
			  {
			  	if (myevent.data.keyDown.chr!=vchrLaunch)
			  	{SysHandleEvent(&myevent);}
			  }			  
		  }
		  redraw=1;
	  }
  }  
  ljz_free(item_rect);
  return result;
}


int os9x_ShowSysInfos(uint8 *savescr)
{
  uint8 *scr;
  int x,y;
  int redraw;  
  int result;
  RectangleType *item_rect,my_rect;
  item_rect=(RectangleType*)ljz_malloc(15*sizeof(RectangleType));
	    
  redraw=1;         
  for (;;)
  {  
  	  if (redraw)
  	  {
  	  	redraw=0;
  	  	scr=WinScreenLock(winLockCopy);  
	    if (scr&&savescr) memcpy(scr,savescr,480*320*2);	    
		//if (scr) WinScreenUnlock();
  	  	RGBColorType fg;
	  	WinPushDrawState ();
  	  	WinSetDrawMode(winOverlay);
    	fg.r=50;fg.g=200;fg.b=50;
	    WinSetTextColorRGB(&fg,NULL);
	    WinSetForeColorRGB(&fg,NULL);
	    FntSetFont(boldFont);
		WinPaintChars(LJZ_OSD_TITLE,strlen(LJZ_OSD_TITLE),10,10);	
		WinPopDrawState();
				
		char str[64],strb[32];
		unsigned long maxP,freeP,usedP;		
		VolumeInfoType vinfo;
		VFSVolumeSize(os9x_curVolume,&usedP,&maxP);		
		VFSVolumeGetLabel(os9x_curVolume,strb,16);strb[16]=0;
		menu_button(10,70,"Volume",0,&my_rect,4);		
		sprintf(str,"%s[%d] Used:%dMb/%dMb",strb,os9x_curVolume,usedP>>20,maxP>>20);
		menu_messageRaw(my_rect.topLeft.x+my_rect.extent.x+5,70,str);				
		MemHeapFreeBytes(0,&freeP,&maxP);		
		menu_button(10,100,"RAM",6,&my_rect,4);		
		sprintf(str,"RAM Free:%d Max:%d",freeP,maxP);
		menu_messageRaw(my_rect.topLeft.x+my_rect.extent.x+5,100,str);		
		TwGfxInfoType gfxinfo;
		gfxinfo.size=sizeof(gfxinfo);
		TwGfxGetInfo(os9x_mGfxLib,&gfxinfo);		
		menu_button(10,130,"VRAM",6,&my_rect,4);		
		sprintf(str,"Free:%d Max:%d",gfxinfo.freeAcceleratorMemory,gfxinfo.totalAcceleratorMemory);
		menu_messageRaw(my_rect.topLeft.x+my_rect.extent.x+5,130,str);
		
		
		menu_button(10,160,"ROM",4,&my_rect,4);						
		sprintf(str,"%s [%s]",Memory.ROMName,(Memory.ROMChecksum + Memory.ROMComplementChecksum != 0xffff ||
	      Memory.ROMChecksum != Memory.sum1) ? "bad checksum" : "checksum ok");
		menu_messageRaw(my_rect.topLeft.x+my_rect.extent.x+5,160,str);		
		
		menu_button(10,190,"Type",4,&my_rect,4);
		sprintf(str,"[%s]%s,%s/%s",Memory.MapMode (),Memory.MapType (),Memory.Size (),Memory.KartContents ());
	    menu_messageRaw(my_rect.topLeft.x+my_rect.extent.x+5,190,str);
	    
	    menu_button(10,220,"SRAM",7,&my_rect,4);
		sprintf(str,"%s",Memory.StaticRAMSize ());
		menu_messageRaw(my_rect.topLeft.x+my_rect.extent.x+5,220,str);
		menu_button(250,220,"TV",7,&my_rect,4);
		sprintf(str,"%s",Memory.TVStandard ());
		menu_messageRaw(my_rect.topLeft.x+my_rect.extent.x+5,220,str);
		
		
		menu_button(10,250,"ROMID",7,&my_rect,4);
		sprintf(str,"%s",Memory.ROMId );
		menu_messageRaw(my_rect.topLeft.x+my_rect.extent.x+5,250,str);
		
		menu_button(250,250,"CompanyID",7,&my_rect,4);
		sprintf(str,"%s",Memory.CompanyId);
		menu_messageRaw(my_rect.topLeft.x+my_rect.extent.x+5,250,str);
		
		
  	
	  	menu_button(310,20,(char*)"BACK",6,&item_rect[0],2);
		
	  
	  	if (scr) WinScreenUnlock();
  	  }
	  menu_waitPen(&x,&y,1);
	  
	  
	  
	  //BACK	  
	  if (TEST_PEN_MENU(x,y,item_rect[0])) {result=0;break;}
	  
	  
  }  
  ljz_free(item_rect);
  return result;
}





int os9x_ShowMenu()
{
  int x,y;
  int redraw;
  int result;
  int slot0;
  uint8 *scr,*savescr;
  RectangleType *item_rect;
  item_rect=(RectangleType*)ljz_malloc(15*sizeof(RectangleType));  
  redraw=1;
  
  TwGfxSurfaceType* displaySurface;
  // Get palmos display surface:
  xassert(TwGfxGetPalmDisplaySurface(os9x_mGfxLib, &displaySurface));
  while (TwGfxIsSurfaceReady(displaySurface));
  
  savescr=(uint8*)ljz_malloc(320*480*2);  
  scr=WinScreenLock(winLockCopy);  
  if (scr)
  {
	  for (x=0;x<320*480;x++)
	  {
  		y=((uint16*)scr)[x];
	  	((uint16*)scr)[x]=((y>>12)<<11)|(((y>>6)&31)<<5)|((y>>1)&15);
	  }
	  memcpy(savescr,scr,480*320*2);
  }
  if (scr) WinScreenUnlock();
  
  
  os9x_pause(1);
        
  for (;;)
  {  
  	if (redraw)
  	{  	  	
  		FILE *savefile;
	  	S9xGetSaveFilename (".za0",sram_filename);
		savefile=fopen(sram_filename,"rb");
	    if (savefile) 
	    {
	  		slot0=1;
		  	fclose(savefile);	
	  	}
	  	else slot0=0;
  	
  		redraw=0;
		scr=WinScreenLock(winLockCopy);  
	    if (scr&&savescr) memcpy(scr,savescr,480*320*2);	    
		//if (scr) WinScreenUnlock();
  		
  		RGBColorType fg;
	  	WinPushDrawState ();
  	  	WinSetDrawMode(winOverlay);
    	fg.r=50;fg.g=200;fg.b=50;
	    WinSetTextColorRGB(&fg,NULL);
	    WinSetForeColorRGB(&fg,NULL);
	    FntSetFont(boldFont);
		WinPaintChars(LJZ_OSD_TITLE,strlen(LJZ_OSD_TITLE),10,10);	
		WinPopDrawState();
  		
		menu_button(310,20,(char*)"BACK",6,&item_rect[0],2);
		menu_button(60,100,(char*)"SAVE",0,&item_rect[1],2);
		menu_button(280,100,(char*)"QUICK SAVE",(slot0?2:1),&item_rect[2],2);
		menu_button(60,150,(char*)"LOAD",0,&item_rect[3],2);
		menu_button(280,150,(char*)"QUICK LOAD",(slot0?2:3),&item_rect[4],2);
		menu_button(60,200,(char*)"CONFIG",0,&item_rect[5],2);
		
		menu_button(280,200,(char*)"SYS INFOS",7,&item_rect[8],2);
		
		menu_button(280,250,(char*)"LAUNCHER",4,&item_rect[6],2);
		
		menu_button(60,250,(char*)"RESET SNES",9,&item_rect[7],2);
		
		if (scr) WinScreenUnlock();
  	}
	  menu_waitPen(&x,&y,1);
	  //HOME
	  if (TEST_PEN_MENU(x,y,item_rect[6])) {result=1;break;}
	  //BACK
	  if (TEST_PEN_MENU(x,y,item_rect[0])) {result=0;break;}
	  //CONFIG
	  if (TEST_PEN_MENU(x,y,item_rect[5])) {os9x_ShowMenuConfig(savescr);redraw=1;}
	  //LOAD
	  if (TEST_PEN_MENU(x,y,item_rect[3])) {if (os9x_ShowMenuLoad(savescr)) {result=0;break;} redraw=1;}
	  //SAVE
	  if (TEST_PEN_MENU(x,y,item_rect[1])) {if (os9x_ShowMenuSave(savescr)) {result=0;break;} redraw=1;}	  
	  //QUICK SAVE
	  if (TEST_PEN_MENU(x,y,item_rect[2]))
	  {
		  os9x_save(".za0");result=0;break;
	  }
	  //QUICK LOAD
	  if (TEST_PEN_MENU(x,y,item_rect[4]))
	  {
	    if (os9x_load(".za0")) {result=0;break;}
	  }
	  //RESET SNES
	  if (TEST_PEN_MENU(x,y,item_rect[7])) {if (menu_confirm("RESET SNES ?")) {S9xReset(); result=0;break;}redraw=1;}
	  
	  //SYS INFOS
	  if (TEST_PEN_MENU(x,y,item_rect[8])) {os9x_ShowSysInfos(savescr); redraw=1;}
	}
  ljz_free(item_rect);
  ljz_free(savescr);
  
  os9x_pause(0);
  
  return result;
}  

int yo_rand_val=0;
int yo_rand(void)
{
	yo_rand_val++;
	return yo_rand_val;
}
