
#ifndef _PSG_H_
#define _PSG_H_

/* Macro to access currently selected PSG channel */
#define PSGCH   psg.channel[psg.select]

#define PSG_VOICE_REG           0 /* voice index */
#define PSG_VOLUME_REG          1 /* master volume */
#define PSG_FREQ_LSB_REG        2 /* lower 8 bits of 12 bit frequency */
#define PSG_FREQ_MSB_REG        3 /* actually most significant nibble */
#define PSG_DDA_REG             4
#define PSG_DDA_ENABLE          0x80 /* bit 7 */
#define PSG_DDA_DIRECT_ACCESS   0x40 /* bit 6 */
#define PSG_DDA_VOICE_VOLUME    0x1F /* bits 0-4 */
#define PSG_BALANCE_REG         5
#define PSG_BALANCE_LEFT        0xF0 /* bits 4-7 */
#define PSG_BALANCE_RIGHT       0x0F /* bits 0-3 */
#define PSG_DATA_INDEX_REG      6
#define PSG_NOISE_REG           7
#define PSG_NOISE_ENABLE        0x80 /* bit 7 */

#define PSG_DIRECT_ACCESS_BUFSIZE 0x400


/* PSG structure */
typedef struct {
    uint32		frq;
	BOOL		bOn;
	BOOL		bDDA;
	uint32		volume;
	uint32		volumeL;
	uint32		volumeR;
	int8		wave[32];
	uint32		waveIndex;
	uint32		phase;
	BOOL		bNoiseOn;
	uint32		noiseFrq;	
	
	int8      daa_data[PSG_DIRECT_ACCESS_BUFSIZE];
	uint32		daa_index;
	uint32		daa_phase;
}t_psg;

/* Global variables */
//extern t_psg psg[8];

/* Function prototypes */
int psg_init(void);
void psg_reset(void);
void psg_shutdown(void);
void psg_w(uint16 address, int8 data);
//void psg_update(int16 *buf/*l, int16 *bufr*/, int length);

#endif /* _PSG_H_ */

