
#include "shared.h"
#include "LJZmenu.h"


#define KEY_UP    		0x00000001
#define KEY_DOWN  		0x00000002
#define KEY_LEFT  		0x00000004
#define KEY_RIGHT 		0x00000008
#define KEY_SEL   		0x00000010
#define KEY_A     		0x00000020
#define KEY_B	  		0x00000040
#define KEY_SELECT 		0x00000080
#define KEY_START		0x00000100
#define KEY_QUICKLOAD   0x00000200
#define KEY_QUICKSAVE   0x00000400
#define KEY_TURBO  		0x00000800
#define KEY_SCREENMODE	0x00001000
#define KEY_FRAMESKIP	0x00002000




// Assertion Support
static void
assert_check(int error, const char* message)
{
    if (error) {
        ErrDisplayFileLineMsg("PalmOS", (UInt16) error, message);
    }
}

#define xassert(error) {assert_check(error, #error);}

static void showError(const char* aWhat, Err aError) {
    ErrDisplayFileLineMsg("oink", (UInt16) aError, aWhat);
}


char str_month[12][4]=
{"Jan","Feb","Mar","Apr","May","Jun",
"Jul","Aug","Sep","Oct","Nov","Dec"};

char RomPath[260];
char shortrom_filename[64];
char tg16Z_curVolume;

int tg16Z_loadrom();
void tg16Z_end();
int tg16Z_setupenv(TwGfxType* mGfxLib);

void tg16Z_changefskip(void);
void tg16Z_changerendering(void);
void tg16Z_updatevpad(unsigned int val);
void tg16Z_MainLoop(void);
void tg16Z_pause(int pause);
int tg16Z_ShowMenu(void);
void tg16Z_updateScreen(void);
void tg16Z_asmfastrender256(uint8 *screen,uint8 *source,uint32 h);
void tg16Z_asmfastrender(uint8 *screen,uint8 *source,uint32 h,uint32 w);
int32 tg16Z_getTickCount(void);

TwGfxType *tg16Z_mGfxLib;
TwGfxSurfaceType *tg16Z_curRenderingScreen,*tg16Z_RenderingScreen[2];
uint16 *tg16Z_curRenderingScreenPtr,*tg16Z_RenderingScreenPtr[2];
uint32 tg16Z_curRenderingScreenIndex;
uint32 tg16Z_enabledSound,tg16Z_sndfreq;
uint32 tg16Z_renderingmode;
uint32 tg16Z_padState;
int32 tg16Z_frameskipped,tg16Z_frameskip,tg16Z_fastforward,tg16Z_specialfskip;
int32 tg16Z_frameBeginTime;
int32 tg16Z_speedpct;
int32 tg16Z_autofireA,tg16Z_autofireB,tg16Z_autofireC;
int32 tg16Z_framecount,tg16Z_drawframe;

int tg16Z_cpu_cyclone;

int32 tg16Z_frameTime;

TwInputHandle tg16Z_mInputQueue;
Int32 tg16Z_inputFormats[] = { twInputTimeStamp };
typedef struct {Int32 mTime;} tg16Z_ZUserEvent;
tg16Z_ZUserEvent tg16Z_mUserEvent;
Int32* tg16Z_mInputFormat;        

int state_load(int num,int onlytest);
int state_save(int num);

uint32 yo_aligned_arm_4;
uint8 VideoBuffer[(32+512+32)*256*2];


static unsigned char *RomData;
static int RomLen;

#include "SoundMgr.h"
static SndStreamRef snd_stream;
typedef struct {uint32 __r9;uint32 __r10;} reg_sys_t;
static reg_sys_t reg_sys;
uint32 tg16Z_sndbuffsize;

#include "sys/stat.h"


static Err tg16Z_sndCallBack (void *userData,SndStreamRef stream, void *bufferZ,UInt32 frameCountZ)
{
	__asm 
	{
		stmfd  r13!,{r9,r10}
		ldr	   r9,[r0]
		ldr	   r10,[r0,#4]
	}		
	//fm_update_timers();
	//audio_update((int16*)bufferZ);
	//psg_update((int16*)bufferZ, frameCountZ);
	update_audio((int16*)bufferZ, frameCountZ);
	__asm 
	{
		ldmfd  r13!,{r9,r10}
	}
	return errNone;
}

void load_sram(void)
{
/*	FILE *f;	
	char savename[255],result[256];
	uint8 i=0,j=255,k=255,l=255;
	char chaine[256];  
	i=0;
	j=255;
	k=-1;
	while (RomPath[i]!=0) 
	{
		if (RomPath[i]=='.') j=i;
		if (RomPath[i]=='/') k=i;
		if (RomPath[i]=='\\') k=i;
		i++;
	  }
	if (j==255) j=i;  //pas d'extension	  
	memcpy(result,RomPath+k+1,j+1-k-1);    
	result[j+1-k-1]=0;
	strcat(result,"srm");
	sprintf(savename,"%s%s",TG16Z_SAVESDIR,result);
	savename[0]=tg16Z_curVolume+'0';
	
	f=fopen(savename,"rb");
	if (!f) return;
	fread(saveram,save_len,1,f);
	fclose(f);*/
}
void save_sram(void)
{
/*	FILE *f;	
	char savename[255],result[256];
	uint8 i=0,j=255,k=255,l=255;
	char chaine[256];  
	i=0;
	j=255;
	k=-1;
	while (RomPath[i]!=0) 
	{
		if (RomPath[i]=='.') j=i;
		if (RomPath[i]=='/') k=i;
		if (RomPath[i]=='\\') k=i;
		i++;
	  }
	if (j==255) j=i;  //pas d'extension	  
	memcpy(result,RomPath+k+1,j+1-k-1);    
	result[j+1-k-1]=0;
	strcat(result,"srm");
	sprintf(savename,"%s%s",TG16Z_SAVESDIR,result);
	savename[0]=tg16Z_curVolume+'0';
	f=fopen(savename,"w+b");
	if (!f) return;
	fwrite(saveram,save_len,1,f);
	fclose(f);*/
}

int update_input(void)
{
    int running = 1;
    
  int pad=0;
  
  if (tg16Z_padState&KEY_QUICKLOAD)
	{
		if (!state_load(0,1))
		{
			if (menu_confirm("Load state ?")) state_load(0,0);
			tg16Z_frameBeginTime=tg16Z_getTickCount()+tg16Z_frameTime*100/tg16Z_speedpct;
		}
	}
	if (tg16Z_padState&KEY_QUICKSAVE)
	{
		if (menu_confirm("Save state ?")) state_save(0);
			tg16Z_frameBeginTime=tg16Z_getTickCount()+tg16Z_frameTime*100/tg16Z_speedpct;
	}
	if (tg16Z_padState&KEY_TURBO)
	{		
		tg16Z_fastforward=1;		
	}
	else 
	if (tg16Z_fastforward)
	{
		tg16Z_fastforward=0;
		tg16Z_frameBeginTime=tg16Z_getTickCount()+tg16Z_frameTime*100/tg16Z_speedpct;
	}
    
  if(tg16Z_padState&KEY_UP)     pad|=INPUT_UP;
  if(tg16Z_padState&KEY_DOWN)   pad|=INPUT_DOWN;
  if(tg16Z_padState&KEY_LEFT)   pad|=INPUT_LEFT;
  if(tg16Z_padState&KEY_RIGHT)  pad|=INPUT_RIGHT;
  if(tg16Z_padState&KEY_A) 
  {
	 switch (tg16Z_autofireA)
	 {
  		case 0:pad|=INPUT_B1; break;
  		case 1:
  	  		if ((tg16Z_framecount&31)>15) pad|=INPUT_B1;
  	  		break;
  		case 2:
  	  		if ((tg16Z_framecount&15)>7) pad|=INPUT_B1;
  	  		break;
  		case 3:
  	  		if ((tg16Z_framecount&7)>3) pad|=INPUT_B1;
  	  		break;  		   
  	 }
  }  		    
  if(tg16Z_padState&KEY_B)
  {
 	 switch (tg16Z_autofireB)
	 {
  		case 0:pad|=INPUT_B2; break;
  		case 1:
  	  		if ((tg16Z_framecount&31)>15) pad|=INPUT_B2;
  	  		break;
  		case 2:
  	  		if ((tg16Z_framecount&15)>7) pad|=INPUT_B2;
  	  		break;
  		case 3:
  	  		if ((tg16Z_framecount&7)>3) pad|=INPUT_B2;
  	  		break;  		   
  	 }
  }
  if(tg16Z_padState&KEY_SELECT) pad|=INPUT_SELECT; 
  	
  if(tg16Z_padState&KEY_START)  pad|=INPUT_RUN;

  input.pad[0]=pad;
  return (running);
}


/*******************************************************/

int32 tg16Z_getTickCount()
{
	//TODO return tick 
	/*long long l;
	l=TimGetTicks();	
	return l*1000/SysTicksPerSecond();*/	
  	TwInputPoll(tg16Z_mInputQueue, (Int32 *) &tg16Z_mUserEvent, sizeof(tg16Z_mUserEvent));
	return tg16Z_mUserEvent.mTime;
}


int init_video(void)
{
	//Init vid
	TwGfxSurfaceInfoType surfInfo;
	surfInfo.size = sizeof(surfInfo);
	surfInfo.width = 512; //must be / 4
	surfInfo.height = 256;
	surfInfo.location = twGfxLocationAcceleratorMemoryNoBackingStore;
	surfInfo.pixelFormat = twGfxPixelFormatRGB565;
	xassert(TwGfxAllocSurface(tg16Z_mGfxLib, &tg16Z_RenderingScreen[0], &surfInfo));
	xassert(TwGfxAllocSurface(tg16Z_mGfxLib, &tg16Z_RenderingScreen[1], &surfInfo));

	if (TwGfxLockSurface(tg16Z_RenderingScreen[0], (void**)&tg16Z_RenderingScreenPtr[0]))
	{
	   return 1;
	}
	if (TwGfxLockSurface(tg16Z_RenderingScreen[1], (void**)&tg16Z_RenderingScreenPtr[1]))
	{
	   return 1;
	}
	
	memset(tg16Z_RenderingScreenPtr[0],0,512*256*2);
	memset(tg16Z_RenderingScreenPtr[1],0,512*256*2);
	
	tg16Z_curRenderingScreenIndex=0;
	tg16Z_curRenderingScreen=tg16Z_RenderingScreen[tg16Z_curRenderingScreenIndex];
	tg16Z_curRenderingScreenPtr=tg16Z_RenderingScreenPtr[tg16Z_curRenderingScreenIndex];
	
	
	signed long val1,val2,val;
	FtrGet(APPLI_ID,FTR_OPT_SCREENMODE_ID,(unsigned long*)&val1);
	FtrGet(APPLI_ID,FTR_OPT_SMOOTHING_ID,(unsigned long*)&val2);
	if (!val1) tg16Z_renderingmode=0;
	else 
	if (val1==1) tg16Z_renderingmode=(val2?2:1);
	else
	if (val1==2) tg16Z_renderingmode=(val2?4:3);
	else
	tg16Z_renderingmode=(val2?6:5);
	

	

	tg16Z_fastforward=0;
	
	tg16Z_frameskipped=0;
	tg16Z_specialfskip=0;
	
	 FtrGet(APPLI_ID,FTR_OPT_FSKIP_ID,(unsigned long*)&val); 
	tg16Z_frameskip=val;
	if (tg16Z_frameskip==SKEEZIX_FSKIP) tg16Z_specialfskip=1;
	

    /*input*/
    TwInputOpen(&tg16Z_mInputQueue, "twinput", "r");
    tg16Z_mInputFormat = (Int32*)ljz_malloc(sizeof(Int32)*sizeof(tg16Z_inputFormats)/sizeof(tg16Z_inputFormats[0]));
    memmove(tg16Z_mInputFormat, tg16Z_inputFormats, sizeof(tg16Z_inputFormats));
    TwInputSetFormat(tg16Z_mInputQueue, tg16Z_mInputFormat, sizeof(tg16Z_inputFormats));    
    TwInputActivate(tg16Z_mInputQueue);

	return 0;
}


int tg16Z_setupenv(TwGfxType* mGfxLib)
{
	tg16Z_mGfxLib=mGfxLib;
	return 0;
}

int tg16Z_loadrom()
{
	ljz_std_showstat();
	int val;
	
	
				
	FtrGet(APPLI_ID,FTR_OPT_SOUND_ID,(unsigned long*)&val);  
	tg16Z_enabledSound=val;
	FtrGet(APPLI_ID,FTR_OPT_CPUCORE_ID,(unsigned long*)&val);  
	tg16Z_cpu_cyclone=val;	
	
	FtrGet(APPLI_ID,FTR_OPT_SOUNDFREQ_ID,(unsigned long*)&val);  
	if (val==1) tg16Z_sndfreq=22050;
	else if (val==2) tg16Z_sndfreq=11025;
	else tg16Z_sndfreq=44100;
	
	
	tg16Z_speedpct=100;
	tg16Z_autofireA=0;
	tg16Z_autofireB=0;
	tg16Z_autofireC=0;
	
	tg16Z_framecount=0;
	tg16Z_drawframe=1;
	



	init_video();
	
    char *ftrptr;
    strcpy(RomPath,TG16Z_ROMSDIR);    
    FtrGet(APPLI_ID,FTR_ROM_FILENAME_ID ,(unsigned long*)&ftrptr);
    
    tg16Z_curVolume=ftrptr[0];
    RomPath[0]=tg16Z_curVolume+'0';
    
    ftrptr+=3;
    strcpy(shortrom_filename,ftrptr);  
    strcat(RomPath,ftrptr);
	FtrPtrFree(APPLI_ID, FTR_ROM_FILENAME_ID);	
	
	// Init emulation:		

	/* Load game */
	char strload[128];
    sprintf(strload,"Loading : %s",shortrom_filename);
    menu_message(strload);        

    if(!load_rom(RomPath,0,0))
	{
		char caption[256];
		sprintf(caption, "Error loading file `%s'.",RomPath);
		menu_message(caption);
		menu_waitPen(NULL,NULL,1);
		return 1;
	}
	
	
/*	if (saveram)
	{
		//char str[256];		
		//sprintf(str,"found sram:sz=%d,st=%08X",save_len,save_start);
		//menu_message(str);
		//menu_waitPen(NULL,NULL,1);
		load_sram();
	}*/

    memset(&bitmap, 0, sizeof(t_bitmap));
    bitmap.width  = 32+512+32;
    bitmap.height = 256;
    bitmap.depth  = 16;
    bitmap.granularity = 2;
    bitmap.pitch = (bitmap.width * bitmap.granularity);
    bitmap.data   = (unsigned char *)VideoBuffer;
    bitmap.viewport.w = 256;
    bitmap.viewport.h = 240;
    bitmap.viewport.x = 0x20;
    bitmap.viewport.y = 0x00;
    
    tg16Z_sndbuffsize=1024;    
    system_init(tg16Z_sndfreq,tg16Z_sndbuffsize);        
    __asm 
    {
  		ldr  r0, = reg_sys
	  	add	 r0,r0,r10
  		str	 r9,[r0]
	  	str	 r10,[r0,#4]
    } 
    
    
    system_reset();	
    
    tg16Z_frameTime=17;//(frame_end==0xE0?17:20); //hardcoded to NTSC
            
    tg16Z_frameBeginTime=tg16Z_getTickCount();
    

	tg16Z_pause(0);
	
    return 0;  
}
void tg16Z_end()
{
      int val;
	 tg16Z_pause(1);

	  TwGfxUnlockSurface(tg16Z_RenderingScreen[0],0);
	  TwGfxUnlockSurface(tg16Z_RenderingScreen[1],0);

	  if (tg16Z_RenderingScreen[0]) TwGfxFreeSurface(tg16Z_RenderingScreen[0]);
	  if (tg16Z_RenderingScreen[1]) TwGfxFreeSurface(tg16Z_RenderingScreen[1]);
  
	  TwInputClose(tg16Z_mInputQueue);  	
	  ljz_free(tg16Z_mInputFormat);    
/*emu*/

	  
/*	  if (saveram) 
	  {
	  	save_sram();
	  	ljz_free(saveram);
	  }*/

 	  system_shutdown();

      

 	if ((tg16Z_renderingmode)&&(!(tg16Z_renderingmode&1))) FtrSet(APPLI_ID, FTR_OPT_SMOOTHING_ID,1);
	else FtrSet(APPLI_ID, FTR_OPT_SMOOTHING_ID,0);	

	FtrSet(APPLI_ID, FTR_OPT_SOUND_ID,tg16Z_enabledSound);
	switch (tg16Z_sndfreq)
	{
		case 11025:val=2;break;
		case 22050:val=1;break;
		default:val=0;break;
	}
	FtrSet(APPLI_ID, FTR_OPT_SOUNDFREQ_ID,val);
	
	FtrSet(APPLI_ID, FTR_OPT_SCREENMODE_ID,((tg16Z_renderingmode+1)>>1));
	
	FtrSet(APPLI_ID, FTR_OPT_FSKIP_ID,tg16Z_frameskip);
	ljz_std_showstat();	
}

void tg16Z_asmfastrender(uint8 *screen,uint8 *source,uint32 h,uint32 w)
{
	for (;h;h--,screen+=512-w,source+=32+512+32-w)
	for (int i=w;i;i--)
	{
		*screen++=*source++;
	}
}

void tg16Z_asmfastrender256(uint8 *screen,uint8 *source,uint32 h)
{
	__asm{
		stmfd r13!,{r4-r11}
				
	 loopY:	
		ldmia r1!,{r3-r12}
		stmia r0!,{r3-r12}		
		ldmia r1!,{r3-r12}
		stmia r0!,{r3-r12}		
		ldmia r1!,{r3-r12}
		stmia r0!,{r3-r12}		
		ldmia r1!,{r3-r12}
		stmia r0!,{r3-r12}	//4x 20pix (40bytes/16bpp) : 80pix
		
		ldmia r1!,{r3-r12}
		stmia r0!,{r3-r12}		
		ldmia r1!,{r3-r12}
		stmia r0!,{r3-r12}		
		ldmia r1!,{r3-r12}
		stmia r0!,{r3-r12}		
		ldmia r1!,{r3-r12}
		stmia r0!,{r3-r12}	//4x 20pix (40bytes/16bpp) : 80pix
		//160pix
		ldmia r1!,{r3-r12}
		stmia r0!,{r3-r12}		
		ldmia r1!,{r3-r12}
		stmia r0!,{r3-r12}		
		ldmia r1!,{r3-r12}
		stmia r0!,{r3-r12}		
		ldmia r1!,{r3-r12}
		stmia r0!,{r3-r12}	//4x 20pix (40bytes/16bpp) : 80pix
		//240pix
		
		ldmia r1!,{r3-r10}
		stmia r0!,{r3-r10}	
		//256pix
								
		add	  r1,r1,#640 //(32+512+32-256) * 2
		add	  r0,r0,#512 //(512-256) * 2
		
		subs  r2,r2,#1
		bne   loopY
				
		ldmfd r13!,{r4-r11}	
		}		
}

void tg16Z_updateScreen(void)
{	 
	if (tg16Z_drawframe)
	{
		TwGfxPointType destLocation = {0, 0};
	    TwGfxSurfaceType* displaySurface;
		TwGfxRectType mDisp;
		int width = bitmap.viewport.w;
	    int height = bitmap.viewport.h;
	    
		mDisp.x=0;
		mDisp.y=0;
		mDisp.w=width;
		mDisp.h=height;
    	// Get palmos display surface:
	    xassert(TwGfxGetPalmDisplaySurface(tg16Z_mGfxLib, &displaySurface));	
    
    	if (tg16Z_specialfskip)
    	{
	    	if (tg16Z_framecount&1)
        	{
				if (width==256) tg16Z_asmfastrender256((uint8*)(tg16Z_curRenderingScreenPtr)+320*2*(height>>1),(uint8*)(VideoBuffer)+(32+512+32)*2*(height>>1)+(bitmap.viewport.x<<1),height>>1);
				else tg16Z_asmfastrender((uint8*)(tg16Z_curRenderingScreenPtr)+320*2*(height>>1),(uint8*)(VideoBuffer)+(32+512+32)*2*(height>>1)+(bitmap.viewport.x<<1),height>>1,width);
        	}
        	else
        	{
	        	if (width==256) tg16Z_asmfastrender256((uint8*)tg16Z_curRenderingScreenPtr,(uint8*)VideoBuffer+(bitmap.viewport.x<<1),(height>>1));
	        	else tg16Z_asmfastrender((uint8*)tg16Z_curRenderingScreenPtr,(uint8*)VideoBuffer+(bitmap.viewport.x<<1),(height>>1),width);
	        }
    	}
    	else
    	{
	    	if (width==256) tg16Z_asmfastrender256((uint8*)tg16Z_curRenderingScreenPtr,(uint8*)VideoBuffer+(bitmap.viewport.x<<1),height);
			else tg16Z_asmfastrender((uint8*)tg16Z_curRenderingScreenPtr,(uint8*)VideoBuffer+(bitmap.viewport.x<<1),height,width);
    	}
		switch (tg16Z_renderingmode)
		{    
		case 0:
		{						
			destLocation.x=(480-mDisp.w)>>1;
			destLocation.y=(320-mDisp.h)>>1;			
			if (!TwGfxIsSurfaceReady(tg16Z_curRenderingScreen))
				xassert(TwGfxBitBlt(displaySurface, &destLocation, tg16Z_curRenderingScreen, &mDisp));
			break;
			}
		case 1:
		{
				TwGfxRectType mDispDest;
				mDispDest.w=width*320/height;
				mDispDest.h=320;				
				mDispDest.x=(480-mDispDest.w)>>1;
				mDispDest.y=0;				
				if (!TwGfxIsSurfaceReady(tg16Z_curRenderingScreen))
					xassert(TwGfxStretchBlt2(displaySurface, &mDispDest, tg16Z_curRenderingScreen, &mDisp,twGfxStretchFast));
				break;
			}
		case 2:
		{
				TwGfxRectType mDispDest;
				mDispDest.w=width*320/height;
				mDispDest.h=320;				
				mDispDest.x=(480-mDispDest.w)>>1;
				mDispDest.y=0;	
				if (!TwGfxIsSurfaceReady(tg16Z_curRenderingScreen))
					xassert(TwGfxStretchBlt2(displaySurface, &mDispDest, tg16Z_curRenderingScreen, &mDisp,twGfxStretchFast|twGfxStretchSmooth));
				break;
			}
			
	
		case 3:
			{
				TwGfxRectType mDispDest;
				mDispDest.x=0;
				mDispDest.y=0;
				mDispDest.w=480;
				mDispDest.h=320;
				if (!TwGfxIsSurfaceReady(tg16Z_curRenderingScreen))
					xassert(TwGfxStretchBlt2(displaySurface, &mDispDest, tg16Z_curRenderingScreen, &mDisp,twGfxStretchFast));
				break;
			}							
		case 4:
			{
				TwGfxRectType mDispDest;
				mDispDest.x=0;
				mDispDest.y=0;
				mDispDest.w=480;
				mDispDest.h=320;
				if (!TwGfxIsSurfaceReady(tg16Z_curRenderingScreen))
					xassert(TwGfxStretchBlt2(displaySurface, &mDispDest, tg16Z_curRenderingScreen, &mDisp,twGfxStretchFast|twGfxStretchSmooth));
				break;
			}							
			
		case 5:
			{
				TwGfxRectType mDispDest;
				mDisp.x=(width-240)>>1;
				mDisp.y=(height-160)>>1;
				mDisp.w=240;
				mDisp.h=160;
				mDispDest.x=0;
				mDispDest.y=0;
				mDispDest.w=480;
				mDispDest.h=320;
				if (!TwGfxIsSurfaceReady(tg16Z_curRenderingScreen))
					xassert(TwGfxStretchBlt2(displaySurface, &mDispDest, tg16Z_curRenderingScreen, &mDisp,twGfxStretchFast));
				break;
			}	
		case 6:
			{
				TwGfxRectType mDispDest;
				mDisp.x=(width-240)>>1;
				mDisp.y=(height-160)>>1;
				mDisp.w=240;
				mDisp.h=160;
				mDispDest.x=0;
				mDispDest.y=0;
				mDispDest.w=480;
				mDispDest.h=320;
				if (!TwGfxIsSurfaceReady(tg16Z_curRenderingScreen))
					xassert(TwGfxStretchBlt2(displaySurface, &mDispDest, tg16Z_curRenderingScreen, &mDisp,twGfxStretchFast|twGfxStretchSmooth));
				break;
			}		
		}
		
//		tg16Z_curRenderingScreenIndex^=1;
//		tg16Z_curRenderingScreenPtr=tg16Z_RenderingScreenPtr[tg16Z_curRenderingScreenIndex];
//		bitmap.data   = (unsigned char *)tg16Z_curRenderingScreenPtr;

	}
	
//	frames_displayed++;	
//	tg16Z_frameBeginTime+=tg16Z_frameTime*100/tg16Z_speedpct;	//60Hz

}

void tg16Z_MainLoop(void)
{
    update_input();
    
    tg16Z_frameBeginTime+=tg16Z_frameTime*100/tg16Z_speedpct;
    
    if ((tg16Z_frameskip==AUTO_FSKIP)&&(!tg16Z_fastforward))
	{
		int i,haswaited=0;
		
		//do avoid issue when Tick is looping
		if ((int32)(tg16Z_frameBeginTime-tg16Z_getTickCount())>=(int32)(20*tg16Z_frameTime))
			tg16Z_frameBeginTime=tg16Z_getTickCount()+tg16Z_frameTime*100/tg16Z_speedpct;					
			
		//while (tg16Z_getTickCount()<=tg16Z_frameBeginTime) haswaited=1;
		i=tg16Z_frameBeginTime-tg16Z_getTickCount()+1;
        if (i>0) {haswaited=1; SysTaskDelay(i);}
	
		if (haswaited||(tg16Z_frameskipped>=MAX_FRAME_SKIPPED)) 
		{
			tg16Z_drawframe=1;
			tg16Z_frameskipped=0;
		}
		else 
		{
			tg16Z_drawframe=0;
			tg16Z_frameskipped++;
		}
	}
	else
	{		
		if (tg16Z_frameskip==SKEEZIX_FSKIP) tg16Z_frameskipped=SKEEZIX_FSKIP;
		tg16Z_frameskipped++;
		
		if (tg16Z_fastforward)
		{
			if (tg16Z_frameskipped>TG16Z_TURBOFSKIP)
			{
				tg16Z_frameskipped=0;
				tg16Z_drawframe=1;
			}
			else tg16Z_drawframe=0;
		}
		else
		{
			if (tg16Z_frameskipped>tg16Z_frameskip)
			{
				tg16Z_frameskipped=0;
				tg16Z_drawframe=1;				
			
			}
			else tg16Z_drawframe=0;
		}
		
		if ((!tg16Z_fastforward)&&(tg16Z_drawframe||(tg16Z_enabledSound&2)))
	    {	
			//do avoid issue when Tick is looping
			int i;
			if ((int32)(tg16Z_frameBeginTime-tg16Z_getTickCount())>=(int32)(20*tg16Z_frameTime))
				tg16Z_frameBeginTime=tg16Z_getTickCount()+tg16Z_frameTime*100/tg16Z_speedpct;					
				
			//while (tg16Z_getTickCount()<=tg16Z_frameBeginTime) ;		
			i=tg16Z_frameBeginTime-tg16Z_getTickCount()+1;
	        if (i>0) {SysTaskDelay(i);}
		}
	}

    system_frame(!tg16Z_drawframe);
	tg16Z_updateScreen();
	
	
	tg16Z_framecount++;
}

void tg16Z_pause(int pause)
{	
   if (pause)
	{
		if (tg16Z_enabledSound&2) 
		{
			SndStreamStop(snd_stream);
			SndStreamDelete(snd_stream);
		}
	}
	else
	{
		tg16Z_frameBeginTime=tg16Z_getTickCount()+tg16Z_frameTime*100/tg16Z_speedpct;
		if (tg16Z_enabledSound&2) 
		{
			SndStreamCreate(&snd_stream,sndOutput,tg16Z_sndfreq,sndInt16Little,sndStereo,tg16Z_sndCallBack,&reg_sys,tg16Z_sndbuffsize);
			SndStreamStart(snd_stream);		
	}	}
}


void tg16Z_changefskip(void)
{
	char tmp[64];
	int i;
	
	tg16Z_frameskip++;
	if (tg16Z_frameskip>SKEEZIX_FSKIP) tg16Z_frameskip=0;
	
	tg16Z_specialfskip=0;
	if (tg16Z_frameskip==SKEEZIX_FSKIP) tg16Z_specialfskip=1;
	
	if (tg16Z_frameskip==AUTO_FSKIP) sprintf(tmp,"Frameskip : AUTO");
	else if (tg16Z_frameskip==SKEEZIX_FSKIP) sprintf(tmp,"Frameskip : Skeezix");
	else sprintf(tmp,"Frameskip : %d",tg16Z_frameskip);	
	//DrawMessage(tmp,0);
	menu_message(tmp);
	
	i=tg16Z_getTickCount();
	while ((tg16Z_getTickCount()-i)<300)
	{
	}
	tg16Z_frameBeginTime=tg16Z_getTickCount()+tg16Z_frameTime*100/tg16Z_speedpct;
}
void tg16Z_changerendering(void)
{	
	tg16Z_renderingmode++;
	if (tg16Z_renderingmode==7) tg16Z_renderingmode=0;

	menu_message("Changing screen mode");
	tg16Z_frameBeginTime=tg16Z_getTickCount();
	while ((tg16Z_getTickCount()-tg16Z_frameBeginTime)<300)
	{
	}
	tg16Z_frameBeginTime=tg16Z_getTickCount()+tg16Z_frameTime*100/tg16Z_speedpct;
}


void tg16Z_updatevpad(unsigned int val)
{
	tg16Z_padState=val;
}

/****************************************************************************/

int tg16Z_ShowMenuGFXConfig(uint8 *savescr)
{
  uint8 *scr;
  int x,y;
  int redraw;  
  int result;
  int scrmode,smoothing,fskipval;
  RectangleType *item_rect;
  item_rect=(RectangleType*)ljz_malloc(12*sizeof(RectangleType));
  char tmp[16];
  

	
  if (!tg16Z_renderingmode) {scrmode=0;smoothing=0;}
  else {scrmode=(tg16Z_renderingmode+1)>>1;smoothing=!(tg16Z_renderingmode&1);}
	
  fskipval=tg16Z_frameskip;
	    
  redraw=1;         
  for (;;)
  {  
  	  if (redraw)
  	  {
  	  	redraw=0;
  	  	scr=WinScreenLock(winLockCopy);  
	    if (scr&&savescr) memcpy(scr,savescr,480*320*2);	    
		//if (scr) WinScreenUnlock();
  	  	RGBColorType fg;
	  	WinPushDrawState ();
  	  	WinSetDrawMode(winOverlay);
    	fg.r=50;fg.g=200;fg.b=50;
	    WinSetTextColorRGB(&fg,NULL);
	    WinSetForeColorRGB(&fg,NULL);
	    FntSetFont(boldFont);
		WinPaintChars(LJZ_OSD_TITLE,strlen(LJZ_OSD_TITLE),10,10);	
		WinPopDrawState();
		
		menu_button(310,20,(char*)"BACK",6,&item_rect[0],2);
	  
	  	menu_button(10,80,(char*)"FRAMESKIP",0,&item_rect[1],2);	  
	  	menu_bar(200,80,fskipval,11,&item_rect[2]);
	  	if (fskipval<AUTO_FSKIP) sprintf(tmp,"%d",fskipval);
	  	else if (fskipval==AUTO_FSKIP) sprintf(tmp,"AUTO");
	  	else sprintf(tmp,"Skeezix");
	  	
	  	menu_messageRaw(320,80,tmp);
	  
	  	menu_button(10,130,(char*)"SCREENMODE",0,&item_rect[3],2);
	  	menu_button(200,130,(char*)"1:1",(scrmode==0?2:1),&item_rect[4],0);
	  	menu_button(250,130,(char*)"4:3",(scrmode==1?2:1),&item_rect[5],0);
	  	menu_button(300,130,(char*)"FULL",(scrmode==2?2:1),&item_rect[6],0);
	  	menu_button(350,130,(char*)"ZOOM",(scrmode==3?2:1),&item_rect[7],1);
	  
	  	menu_button(10,180,(char*)"SMOOTHING",0,&item_rect[8],2);
	  	menu_button(200,180,(char*)"OFF",(smoothing?1:2),&item_rect[9],0);
	  	menu_button(250,180,(char*)"ON",(smoothing?2:1),&item_rect[10],0);	  	  	  
	  	
	  	if (scr) WinScreenUnlock();
	
  	  }
	  menu_waitPen(&x,&y,0);
	  
	  
	  //BACK	  
	  if (TEST_PEN_MENU(x,y,item_rect[0])) {result=0;break;}
	  //FSKIP
	  if (TEST_PEN_MENU(x,y,item_rect[2])) 
	  {
	  	fskipval=(x-10-item_rect[2].topLeft.x)*11/100;
	  	if (fskipval<0) fskipval=0;
	  	if (fskipval>11) fskipval=11;
	  	redraw=1;
	  }
	  //SCREEN MODES
	  if (TEST_PEN_MENU(x,y,item_rect[4])) 
	  {
	  	  scrmode=0;
	  	  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[5])) 
	  {
	  	  scrmode=1;
	  	  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[6])) 
	  {
	  	  scrmode=2;
	  	  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[7])) 
	  {
	  	  scrmode=3;
	  	  redraw=1;
	  }
	  //SMOOTHING
	  if (TEST_PEN_MENU(x,y,item_rect[9])&&scrmode) 
	  {
	  	  smoothing=0;
	  	  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[10])&&scrmode) 
	  {
	  	  smoothing=1;
	  	  redraw=1;
	  }
  }  
  
  tg16Z_specialfskip=0;
  tg16Z_frameskip=fskipval;
  if (tg16Z_frameskip==SKEEZIX_FSKIP) tg16Z_specialfskip=1;  

  if (!scrmode) tg16Z_renderingmode=0;
	else 
	if (scrmode==1) tg16Z_renderingmode=(smoothing?2:1);
	else
	if (scrmode==2) tg16Z_renderingmode=(smoothing?4:3);
	else
	tg16Z_renderingmode=(smoothing?6:5);
	
  menu_waitPen(NULL,NULL,2);
  
  ljz_free(item_rect);
  return result;
}



int tg16Z_ShowMenuSNDConfig(uint8 *savescr)
{
  uint8 *scr;
  int x,y;
  int redraw;  
  int result;  
  int bassboost;
  RectangleType *item_rect;
  char tmp[16];
  item_rect=(RectangleType*)ljz_malloc(15*sizeof(RectangleType));
    
  bassboost=TwSndGetBassBoost();
	    
  redraw=1;         
  for (;;)
  {  
  	  if (redraw)
  	  {
  	  	redraw=0;
  	  	scr=WinScreenLock(winLockCopy);  
	    if (scr&&savescr) memcpy(scr,savescr,480*320*2);	    
//		if (scr) WinScreenUnlock();
  	  	RGBColorType fg;
	  	WinPushDrawState ();
  	  	WinSetDrawMode(winOverlay);
    	fg.r=50;fg.g=200;fg.b=50;
	    WinSetTextColorRGB(&fg,NULL);
	    WinSetForeColorRGB(&fg,NULL);
	    FntSetFont(boldFont);
		WinPaintChars(LJZ_OSD_TITLE,strlen(LJZ_OSD_TITLE),10,10);	
		WinPopDrawState();
  	
  		
  	  	  	  	  	  	
	  menu_button(310,20,(char*)"BACK",6,&item_rect[0],2);	  
	  menu_button(10,80,(char*)"SOUND",0,&item_rect[1],2);
	  menu_button(200,80,(char*)"OFF",(tg16Z_enabledSound==0?2:1),&item_rect[2],0);
	  menu_button(250,80,(char*)"SIM",(tg16Z_enabledSound&1?2:1),&item_rect[3],0);	  
	  menu_button(300,80,(char*)"ON",(tg16Z_enabledSound&2?2:1),&item_rect[4],0);	 
	  
/*	  menu_button(10,120,(char*)"VOLUME",0,&item_rect[7],2);	  
	  menu_bar(200,120,vol,64,&item_rect[8]);
	  sprintf(tmp,"%d%",vol*100/64);	  	
	  	menu_messageRaw(320,120,tmp);*/
	  
	  menu_button(10,120,(char*)"BASS BOOST",0,&item_rect[9],2);
	  menu_button(200,120,(char*)"OFF",(bassboost==0?2:1),&item_rect[10],0);
	  menu_button(300,120,(char*)"ON",(bassboost?2:1),&item_rect[11],0);	 
		if (scr) WinScreenUnlock();	  
  	  }
	  menu_waitPen(&x,&y,0);
	  
	  
	  //BACK	  
	  if (TEST_PEN_MENU(x,y,item_rect[0])) {result=0;break;}	  
	  //SOUND OFF
	  if (TEST_PEN_MENU(x,y,item_rect[2])) 
	  {
	  	  if (tg16Z_enabledSound)
	  	  {
	  	  	if (snd.enabled) audio_shutdown();
		    snd.enabled=0;
	  	  }
		  tg16Z_enabledSound=0;		  
		  redraw=1;
	  }
	  //SOUND SIM
	  if (TEST_PEN_MENU(x,y,item_rect[3])) 
	  {
	  	  if (tg16Z_enabledSound!=1) 
	  	  {	
	  	  	 	if (snd.enabled) audio_shutdown();
  		  	  	tg16Z_enabledSound=1;	  	  	 	  	  	
	  	  }
	  	  else
	  	  {
  		  	  tg16Z_enabledSound=1;
  		  }
	  	  redraw=1;
	  }
	  //SOUND ON
	  if (TEST_PEN_MENU(x,y,item_rect[4])) 
	  {
	  	  if (tg16Z_enabledSound!=2)
	  	  {
	  	  	audio_init(tg16Z_sndfreq,tg16Z_sndbuffsize);
	  	  	tg16Z_enabledSound=2;
	  	  }	  	  		  
		  redraw=1;
	  }
	  

	  //BASSBOOST OFF
	  if (TEST_PEN_MENU(x,y,item_rect[9])) 
	  {
	  	bassboost=0;
	  	redraw=1;
	  }
	  //BASSBOOST ON
	  if (TEST_PEN_MENU(x,y,item_rect[10])) 
	  {
	  	bassboost=1;
	  	redraw=1;
	  }
  }  
  
  TwSndSetBassBoost(bassboost);
  
  menu_waitPen(NULL,NULL,2);
  
  ljz_free(item_rect);
  return result;
}


int tg16Z_ShowMenuOTHERConfig(uint8 *savescr)
{
  uint8 *scr;
  int x,y;
  int redraw;  
  int result;
  RectangleType *item_rect;
  char tmp[16];
  item_rect=(RectangleType*)ljz_malloc(21*sizeof(RectangleType));
  
  redraw=1;         
  for (;;)
  {  
  	  if (redraw)
  	  {
  	  	redraw=0;
  	  	scr=WinScreenLock(winLockCopy);  
	    if (scr&&savescr) memcpy(scr,savescr,480*320*2);	    
  	  	RGBColorType fg;
	  	WinPushDrawState ();
  	  	WinSetDrawMode(winOverlay);
    	fg.r=50;fg.g=200;fg.b=50;
	    WinSetTextColorRGB(&fg,NULL);
	    WinSetForeColorRGB(&fg,NULL);
	    FntSetFont(boldFont);
		WinPaintChars(LJZ_OSD_TITLE,strlen(LJZ_OSD_TITLE),10,10);	
		WinPopDrawState();
  	
  		
  	  	  	  	  	  	
	  menu_button(310,20,(char*)"BACK",6,&item_rect[0],2);	  
	  menu_button(10,80,(char*)"AUTOFIRE A",0,&item_rect[1],2);
	  menu_button(200,80,(char*)"OFF",(tg16Z_autofireA==0?2:1),&item_rect[2],0);
	  menu_button(250,80,(char*)"SLW",(tg16Z_autofireA==1?2:1),&item_rect[3],0);
	  menu_button(300,80,(char*)"MED",(tg16Z_autofireA==2?2:1),&item_rect[4],0);
	  menu_button(350,80,(char*)"FST",(tg16Z_autofireA==3?2:1),&item_rect[5],0);
	  
	  menu_button(10,120,(char*)"AUTOFIRE B",0,&item_rect[6],2);
	  menu_button(200,120,(char*)"OFF",(tg16Z_autofireB==0?2:1),&item_rect[7],0);
	  menu_button(250,120,(char*)"SLW",(tg16Z_autofireB==1?2:1),&item_rect[8],0);
	  menu_button(300,120,(char*)"MED",(tg16Z_autofireB==2?2:1),&item_rect[9],0);
	  menu_button(350,120,(char*)"FST",(tg16Z_autofireB==3?2:1),&item_rect[10],0);
	  
	  menu_button(10,160,(char*)"AUTOFIRE C",0,&item_rect[11],2);
	  menu_button(200,160,(char*)"OFF",(tg16Z_autofireC==0?2:1),&item_rect[12],0);
	  menu_button(250,160,(char*)"SLW",(tg16Z_autofireC==1?2:1),&item_rect[13],0);
	  menu_button(300,162,(char*)"MED",(tg16Z_autofireC==2?2:1),&item_rect[14],0);
	  menu_button(350,160,(char*)"FST",(tg16Z_autofireC==3?2:1),&item_rect[15],0);
	  
	  menu_button(10,200,(char*)"EMU SPEED",0,&item_rect[16],2);	  
	  menu_bar(200,200,tg16Z_speedpct,100,&item_rect[17]);
	  sprintf(tmp,"%d%",tg16Z_speedpct);
    	menu_messageRaw(320,200,tmp);
    
      menu_button(10,240,(char*)"CPU CORE",0,&item_rect[18],2);
 	  menu_button(200,240,(char*)"C",(tg16Z_cpu_cyclone==0?2:1),&item_rect[19],0);
	  menu_button(250,240,(char*)"ASM",(tg16Z_cpu_cyclone==1?2:1),&item_rect[20],0);
	  
		if (scr) WinScreenUnlock();	  
  	  }
	  menu_waitPen(&x,&y,0);
	  
	  
	  //BACK	  
	  if (TEST_PEN_MENU(x,y,item_rect[0])) {result=0;break;}	  
	  //AUTOFIRE A
	  if (TEST_PEN_MENU(x,y,item_rect[2])) 
	  {
		  tg16Z_autofireA=0;		  
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[3])) 
	  {
		  tg16Z_autofireA=1;
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[4])) 
	  {
		  tg16Z_autofireA=2;
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[5])) 
	  {
		  tg16Z_autofireA=3;
		  redraw=1;
	  }
	  //AUTOFIRE B
	  if (TEST_PEN_MENU(x,y,item_rect[7])) 
	  {
		  tg16Z_autofireB=0;		  
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[8])) 
	  {
		  tg16Z_autofireB=1;
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[9])) 
	  {
		  tg16Z_autofireB=2;
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[10])) 
	  {
		  tg16Z_autofireB=3;
		  redraw=1;
	  }
	  //AUTOFIRE C
	  if (TEST_PEN_MENU(x,y,item_rect[12])) 
	  {
		  tg16Z_autofireC=0;		  
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[13])) 
	  {
		  tg16Z_autofireC=1;
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[14])) 
	  {
		  tg16Z_autofireC=2;
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[15])) 
	  {
		  tg16Z_autofireC=3;
		  redraw=1;
	  }
	  //SPEED
	  if (TEST_PEN_MENU(x,y,item_rect[17])) 
	  {
	  	tg16Z_speedpct=(x-10-item_rect[17].topLeft.x);
	  	if (tg16Z_speedpct>100) tg16Z_speedpct=100;
	  	if (tg16Z_speedpct<10) tg16Z_speedpct=10;
	  	redraw=1;
	  }
	  //CPU CORE
	  if (TEST_PEN_MENU(x,y,item_rect[19])) 
	  {
		  if (menu_confirm("RESET needed. Continue ?")) 
		  {
			tg16Z_cpu_cyclone=0;		  
		  	system_reset();
		  }
		  
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[20])) 
	  {
		  if (menu_confirm("RESET needed. Continue ?")) 
		  {
			tg16Z_cpu_cyclone=1;
		  	system_reset();
		  }
		  redraw=1;
	  }
  }  
  
  menu_waitPen(NULL,NULL,2);
  
  ljz_free(item_rect);
  return result;
}


int tg16Z_ShowMenuConfig(uint8 *savescr)
{
  uint8 *scr;
  int x,y;
  int redraw;  
  int result;
  RectangleType *item_rect;
  item_rect=(RectangleType*)ljz_malloc(15*sizeof(RectangleType));
	    
  redraw=1;         
  for (;;)
  {  
  	  if (redraw)
  	  {
  	  	redraw=0;
  	  	scr=WinScreenLock(winLockCopy);  
	    if (scr&&savescr) memcpy(scr,savescr,480*320*2);	    
		//if (scr) WinScreenUnlock();
  	  	RGBColorType fg;
	  	WinPushDrawState ();
  	  	WinSetDrawMode(winOverlay);
    	fg.r=50;fg.g=200;fg.b=50;
	    WinSetTextColorRGB(&fg,NULL);
	    WinSetForeColorRGB(&fg,NULL);
	    FntSetFont(boldFont);
		WinPaintChars(LJZ_OSD_TITLE,strlen(LJZ_OSD_TITLE),10,10);	
		WinPopDrawState();
  	
  		
  	  	  	  	  	  	
	  menu_button(310,20,(char*)"BACK",6,&item_rect[0],2);	  
	  menu_button(172,100,(char*)"GFX",0,&item_rect[1],2);
	  menu_button(172,150,(char*)"SOUND",0,&item_rect[2],2);
	  menu_button(172,200,(char*)"OTHER",0,&item_rect[3],2);
	  menu_button(172,250,(char*)"SND & BRT",9,&item_rect[4],2);
	  if (scr) WinScreenUnlock();
  	  }
	  menu_waitPen(&x,&y,1);
	  
	  
	  //BACK	  
	  if (TEST_PEN_MENU(x,y,item_rect[0])) {result=0;break;}	  
	  //GFX
	  if (TEST_PEN_MENU(x,y,item_rect[1])) 
	  {
	  	tg16Z_ShowMenuGFXConfig(savescr);
		redraw=1;
	  }
	  //SOUND
	  if (TEST_PEN_MENU(x,y,item_rect[2])) 
	  {
     	tg16Z_ShowMenuSNDConfig(savescr);
		redraw=1;
	  }
	  //OTHER
	  if (TEST_PEN_MENU(x,y,item_rect[3])) 
	  {
		  tg16Z_ShowMenuOTHERConfig(savescr);
		  redraw=1;		  
	  }
	  //SND & BRT
	  if (TEST_PEN_MENU(x,y,item_rect[4]))
	  {
	  	  LJZ_SHOW_SND_BRT
		  redraw=1;
	  }
  }  
  ljz_free(item_rect);
  return result;
}



int tg16Z_ShowMenuSave(uint8 *savescr)
{
  uint8 *scr;
  int x,y;
  int redraw;  
  int result;
  RectangleType *item_rect;
  item_rect=(RectangleType*)ljz_malloc(15*sizeof(RectangleType));
  memset((char*)item_rect,0,15*sizeof(RectangleType));
  int slot[4];  
  redraw=1;         
  for (;;)
  {  
  	  if (redraw)
  	  {
  	  	redraw=0;
  	  	scr=WinScreenLock(winLockCopy);  
	    if (scr&&savescr) memcpy(scr,savescr,480*320*2);	    
		//if (scr) WinScreenUnlock();
  	  	RGBColorType fg;
	  	WinPushDrawState ();
  	  	WinSetDrawMode(winOverlay);
    	fg.r=50;fg.g=200;fg.b=50;
	    WinSetTextColorRGB(&fg,NULL);
	    WinSetForeColorRGB(&fg,NULL);
	    FntSetFont(boldFont);
		WinPaintChars(LJZ_OSD_TITLE,strlen(LJZ_OSD_TITLE),10,10);	
		WinPopDrawState();
  	
  		
  	  	  	  	  	  	
	  FILE *savefile;
  	 
  	  slot[0]=slot[1]=slot[2]=slot[3]=0;
  	  for (int i=0;i<4;i++) 
  	  if (!state_load(i,1)) 
  	  	{
      		slot[i]=1;
      
	  		struct tm *localTime;
			time_t long_time;
			char str[255];		
			GetStateFileName(i,str);
			long_time=__getdate_file(str);		
			localTime = localtime(&long_time);
			//date is an ofs from 01 Jan 1900 00:00:00			
			sprintf(str,"%02d %s %02d %02d:%02d",
			localTime->tm_mday,str_month[localTime->tm_mon],localTime->tm_year-100,localTime->tm_hour,localTime->tm_min);
			if (i) 
			{
				menu_messageRaw(300,50+i*30,str);
				menu_button(160,50+i*30,"X",5,&item_rect[6+i],3);
			}
			else 
			{
				menu_messageRaw(300,170,str);
				menu_button(160,170,"X",5,&item_rect[6+i],3);
			}
	  	}	  	  	
  	  	  	  	  	  	
	  menu_button(310,20,(char*)"BACK",6,&item_rect[0],2);
	  menu_button(10,80,(char*)"SAVE",0,&item_rect[1],2);
	  menu_button(200,80,(char*)"SLOT 1",(slot[1]?2:1),&item_rect[2],1);
	  menu_button(200,110,(char*)"SLOT 2",(slot[2]?2:1),&item_rect[3],1);
	  menu_button(200,140,(char*)"SLOT 3",(slot[3]?2:1),&item_rect[4],1);
	  menu_button(200,170,(char*)"QUICK",(slot[0]?2:1),&item_rect[5],1);
	  if (scr) WinScreenUnlock();
  	  }
	  menu_waitPen(&x,&y,1);
	  
	  if (TEST_PEN_MENU(x,y,item_rect[6])) 
	  {
	  	if (menu_confirm("Delete QUICKSLOT?"))
	  	{
		  	char str[255];		
			GetStateFileName(0,str);
	  		remove(str);
	  	}
	  	redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[7])) 
	  {
	  	if (menu_confirm("Delete SLOT 1?"))
	  	{
		  	char str[255];		
			GetStateFileName(1,str);
	  		remove(str);
	  	}
	  	redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[8])) 
	  {
	  	if (menu_confirm("Delete SLOT 2?"))
	  	{
		  	char str[255];		
			GetStateFileName(2,str);
	  		remove(str);
	  	}
	  	redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[9])) 
	  {
	  	if (menu_confirm("Delete SLOT 3?"))
	  	{
		  	char str[255];		
			GetStateFileName(3,str);
	  		remove(str);
	  	}
	  	redraw=1;
	  }
	  
	  //BACK	  
	  if (TEST_PEN_MENU(x,y,item_rect[0])) {result=0;break;}
	  //SAVE 0
	  if (TEST_PEN_MENU(x,y,item_rect[2]))
	  {
	  	  if (!slot[1]||(menu_confirm("Overwrite ?")))
		  {state_save(1);result=1;break;}
		  else redraw=1;
		  
	  }
	  //SAVE 1
	  if (TEST_PEN_MENU(x,y,item_rect[3]))
	  {
		  if (!slot[2]||(menu_confirm("Overwrite ?")))
		  {state_save(2);result=1;break;}
		  else redraw=1;
		
	  }
	  //SAVE 2
	  if (TEST_PEN_MENU(x,y,item_rect[4]))
	  {
    	  if (!slot[3]||(menu_confirm("Overwrite ?")))
		  {state_save(3);result=1;break;}
		  else redraw=1;
		
	  }
	  //QUICKSAVE
	  if (TEST_PEN_MENU(x,y,item_rect[5]))
	  {
	  	  if (!slot[0]||(menu_confirm("Overwrite ?")))
		  {state_save(0);result=1;break;}
		  else redraw=1;
		
	  }
  }  
  ljz_free(item_rect);
  return result;
}



int tg16Z_ShowMenuLoad(uint8 *savescr)
{
  uint8 *scr;
  int x,y;
  int redraw;  
  int result;
   int slot[4];
  RectangleType *item_rect;
  item_rect=(RectangleType*)ljz_malloc(15*sizeof(RectangleType));
  memset((char*)item_rect,0,15*sizeof(RectangleType));
	    
  redraw=1;         
  for (;;)
  {  
  	  if (redraw)
  	  {
  	  	redraw=0;
  	  	scr=WinScreenLock(winLockCopy);  
	    if (scr&&savescr) memcpy(scr,savescr,480*320*2);	    
//		if (scr) WinScreenUnlock();
  	  	RGBColorType fg;
	  	WinPushDrawState ();
  	  	WinSetDrawMode(winOverlay);
    	fg.r=50;fg.g=200;fg.b=50;
	    WinSetTextColorRGB(&fg,NULL);
	    WinSetForeColorRGB(&fg,NULL);
	    FntSetFont(boldFont);
		WinPaintChars(LJZ_OSD_TITLE,strlen(LJZ_OSD_TITLE),10,10);	
		WinPopDrawState();
  	
  	  FILE *savefile;
  	 
  	  slot[0]=slot[1]=slot[2]=slot[3]=0;
      for (int i=0;i<4;i++) 
      	if (!state_load(i,1)) 
      	{
      		slot[i]=1;
      
	  		struct tm *localTime;
			time_t long_time;
			char str[255];		
			GetStateFileName(i,str);
			long_time=__getdate_file(str);		
			localTime = localtime(&long_time);
			//date is an ofs from 01 Jan 1900 00:00:00			
			sprintf(str,"%02d %s %02d %02d:%02d",
			localTime->tm_mday,str_month[localTime->tm_mon],localTime->tm_year-100,localTime->tm_hour,localTime->tm_min);
			if (i) 
			{
				menu_messageRaw(300,50+i*30,str);
				menu_button(160,50+i*30,"X",5,&item_rect[6+i],3);
			}
			else 
			{
				menu_messageRaw(300,170,str);
				menu_button(160,170,"X",5,&item_rect[6+i],3);
			}
	  	}	  	  	
      
	  menu_button(310,20,(char*)"BACK",6,&item_rect[0],2);
	  menu_button(10,80,(char*)"LOAD",0,&item_rect[1],2);
	  menu_button(200,80,(char*)"SLOT 1",(slot[1]?2:3),&item_rect[2],1);
	  menu_button(200,110,(char*)"SLOT 2",(slot[2]?2:3),&item_rect[3],1);
	  menu_button(200,140,(char*)"SLOT 3",(slot[3]?2:3),&item_rect[4],1);
	  menu_button(200,170,(char*)"QUICK",(slot[0]?2:3),&item_rect[5],1);
		if (scr) WinScreenUnlock();	  
  	  }
	  menu_waitPen(&x,&y,1);
	  
	  	  if (TEST_PEN_MENU(x,y,item_rect[6])) 
	  {
	  	if (menu_confirm("Delete QUICKSLOT?"))
	  	{
		  	char str[255];		
			GetStateFileName(0,str);
	  		remove(str);
	  	}
	  	redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[7])) 
	  {
	  	if (menu_confirm("Delete SLOT 1?"))
	  	{
		  	char str[255];		
			GetStateFileName(1,str);
	  		remove(str);
	  	}
	  	redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[8])) 
	  {
	  	if (menu_confirm("Delete SLOT 2?"))
	  	{
		  	char str[255];		
			GetStateFileName(2,str);
	  		remove(str);
	  	}
	  	redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[9])) 
	  {
	  	if (menu_confirm("Delete SLOT 3?"))
	  	{
		  	char str[255];		
			GetStateFileName(3,str);
	  		remove(str);
	  	}
	  	redraw=1;
	  }
	  
	  //BACK	  
	  if (TEST_PEN_MENU(x,y,item_rect[0])) {result=0;break;}
	  //LOAD 0
	  if (TEST_PEN_MENU(x,y,item_rect[2]))
	  {
		  if (slot[1])
		if (!state_load(1,0)) {result=1;break;}
	  }
	  //LOAD 1
	  if (TEST_PEN_MENU(x,y,item_rect[3]))
	  {
		  if (slot[2])
		if (!state_load(2,0)) {result=1;break;}
	  }
	  //LOAD 2
	  if (TEST_PEN_MENU(x,y,item_rect[4]))
	  {
		  if (slot[3])
		if (!state_load(3,0)) {result=1;break;}	  
	  }
	
	  //QUICKLOAD
	  if (TEST_PEN_MENU(x,y,item_rect[5]))
	  {
	  	if (slot[0])
    	if (!state_load(0,0)) {result=1;break;}
	  }
  }  
  ljz_free(item_rect);
  return result;
}


int tg16Z_ShowSysInfos(uint8 *savescr)
{
  uint8 *scr;
  int x,y;
  int redraw;  
  int result;
  RectangleType *item_rect,my_rect;
  item_rect=(RectangleType*)ljz_malloc(15*sizeof(RectangleType));
	    
  redraw=1;         
  for (;;)
  {  
  	  if (redraw)
  	  {
  	  	redraw=0;
  	  	scr=WinScreenLock(winLockCopy);  
	    if (scr&&savescr) memcpy(scr,savescr,480*320*2);	    
		//if (scr) WinScreenUnlock();
  	  	RGBColorType fg;
	  	WinPushDrawState ();
  	  	WinSetDrawMode(winOverlay);
    	fg.r=50;fg.g=200;fg.b=50;
	    WinSetTextColorRGB(&fg,NULL);
	    WinSetForeColorRGB(&fg,NULL);
	    FntSetFont(boldFont);
		WinPaintChars(LJZ_OSD_TITLE,strlen(LJZ_OSD_TITLE),10,10);	
		WinPopDrawState();
				
		char str[64],strb[32];
		unsigned long maxP,freeP,usedP;		
		VolumeInfoType vinfo;
		VFSVolumeSize(tg16Z_curVolume,&usedP,&maxP);		
		VFSVolumeGetLabel(tg16Z_curVolume,strb,16);strb[16]=0;
		menu_button(10,70,"Volume",0,&my_rect,4);		
		sprintf(str,"%s[%d] Used:%dMb/%dMb",strb,tg16Z_curVolume,usedP>>20,maxP>>20);
		menu_messageRaw(my_rect.topLeft.x+my_rect.extent.x+5,70,str);				
		MemHeapFreeBytes(0,&freeP,&maxP);		
		menu_button(10,100,"RAM",6,&my_rect,4);		
		sprintf(str,"RAM Free:%d Max:%d",freeP,maxP);
		menu_messageRaw(my_rect.topLeft.x+my_rect.extent.x+5,100,str);		
		TwGfxInfoType gfxinfo;
		gfxinfo.size=sizeof(gfxinfo);
		TwGfxGetInfo(tg16Z_mGfxLib,&gfxinfo);		
		menu_button(10,130,"VRAM",6,&my_rect,4);		
		sprintf(str,"Free:%d Max:%d",gfxinfo.freeAcceleratorMemory,gfxinfo.totalAcceleratorMemory);
		menu_messageRaw(my_rect.topLeft.x+my_rect.extent.x+5,130,str);
						
    		
/*		menu_button(10,160,"ROM",4,&my_rect,4);
		menu_messageRaw(my_rect.topLeft.x+my_rect.extent.x+5,160,rom.name);
		
		sprintf(str,"%dKo RAM-%dKo",mbc.romsize,mbc.ramsize);
		menu_button(10,190,"Size",4,&my_rect,4);
	    menu_messageRaw(my_rect.topLeft.x+my_rect.extent.x+5,190,str);
	    
		menu_button(10,220,"Type",7,&my_rect,4);		
		sprintf(str,"%d Batt:%d Rtc:%d CGB:%d",mbc.type,mbc.batt,rtc.batt,hw.cgb);
		menu_messageRaw(my_rect.topLeft.x+my_rect.extent.x+5,220,str);*/
		
						  	
	  	menu_button(310,20,(char*)"BACK",6,&item_rect[0],2);
		
	  
	  	if (scr) WinScreenUnlock();
  	  }
	  menu_waitPen(&x,&y,1);
	  
	  
	  
	  //BACK	  
	  if (TEST_PEN_MENU(x,y,item_rect[0])) {result=0;break;}
	  
	  
  }  
  ljz_free(item_rect);
  return result;
}



int tg16Z_ShowMenu()
{
  int x,y;
  int redraw;
  int result;
  int slot0;
  uint8 *scr,*savescr;
  RectangleType *item_rect;
  item_rect=(RectangleType*)ljz_malloc(15*sizeof(RectangleType));  
  redraw=1;
  
  tg16Z_pause(1);
    
  
   TwGfxSurfaceType* displaySurface;
  // Get palmos display surface:
  xassert(TwGfxGetPalmDisplaySurface(tg16Z_mGfxLib, &displaySurface));
  while (TwGfxIsSurfaceReady(displaySurface));

  
  savescr=(uint8*)ljz_malloc(320*480*2);  
  scr=WinScreenLock(winLockCopy);  
  if (scr&&savescr)
  {
	  for (x=0;x<320*480;x++)
	  {
  		y=((uint16*)scr)[x];
	  	((uint16*)scr)[x]=((y>>12)<<11)|(((y>>6)&31)<<5)|((y>>1)&15);
	  }
	  memcpy(savescr,scr,480*320*2);
  }
  if (scr) WinScreenUnlock();
            
              
  for (;;)
  {  
  	if (redraw)
  	{  	
	  	slot0=!state_load(0,1);    
  		redraw=0;
		scr=WinScreenLock(winLockCopy);  
	    if (scr&&savescr) memcpy(scr,savescr,480*320*2);	    
//		if (scr) WinScreenUnlock();
  		
  		RGBColorType fg;
	  	WinPushDrawState ();
  	  	WinSetDrawMode(winOverlay);
    	fg.r=50;fg.g=200;fg.b=50;
	    WinSetTextColorRGB(&fg,NULL);
	    WinSetForeColorRGB(&fg,NULL);
	    FntSetFont(boldFont);
		WinPaintChars(LJZ_OSD_TITLE,strlen(LJZ_OSD_TITLE),10,10);	
		WinPopDrawState();
  		
		menu_button(310,20,(char*)"BACK",6,&item_rect[0],2);
		menu_button(60,100,(char*)"SAVE",0,&item_rect[1],2);
		menu_button(280,100,(char*)"QUICK SAVE",(slot0?2:1),&item_rect[2],2);
		menu_button(60,150,(char*)"LOAD",0,&item_rect[3],2);
		menu_button(280,150,(char*)"QUICK LOAD",(slot0?2:3),&item_rect[4],2);
		menu_button(60,200,(char*)"CONFIG",0,&item_rect[5],2);
		menu_button(280,250,(char*)"LAUNCHER",4,&item_rect[6],2);
		
		menu_button(280,200,(char*)"SYS INFOS",7,&item_rect[8],2);
		
		menu_button(60,250,(char*)"RESET GEN.",9,&item_rect[7],2);				
		if (scr) WinScreenUnlock();		
		
  	}
	  menu_waitPen(&x,&y,1);
	  //HOME
	  if (TEST_PEN_MENU(x,y,item_rect[6])) {result=1;break;}
	  //BACK
	  if (TEST_PEN_MENU(x,y,item_rect[0])) {result=0;break;}
	  //CONFIG
	  if (TEST_PEN_MENU(x,y,item_rect[5])) {tg16Z_ShowMenuConfig(savescr);redraw=1;}
	  //LOAD
	  if (TEST_PEN_MENU(x,y,item_rect[3])) {if (tg16Z_ShowMenuLoad(savescr)) {result=0;break;} redraw=1;}
	  //SAVE
	  if (TEST_PEN_MENU(x,y,item_rect[1])) {if (tg16Z_ShowMenuSave(savescr)) {result=0;break;} redraw=1;}
	  //QUICK SAVE
	  if (TEST_PEN_MENU(x,y,item_rect[2]))
	  {
		  state_save(0);
		  result=0;
		  break;
	  }
	  //QUICK LOAD
	  if (TEST_PEN_MENU(x,y,item_rect[4]))
	  {
		  if (slot0)
		    if (!state_load(0,0)) {result=0;break;}
	  }
	  //RESET tg16
	  if (TEST_PEN_MENU(x,y,item_rect[7])) {if (menu_confirm("RESET TG16 ?")) {system_reset(); result=0;break;}redraw=1;}
	  
	  //SYS INFOS
	  if (TEST_PEN_MENU(x,y,item_rect[8])) {tg16Z_ShowSysInfos(savescr); redraw=1;}
	}
  ljz_free(item_rect);
  
  ljz_free(savescr);
            
  tg16Z_pause(0);
  return result;
}  

